package org.pasoa.accessors.lfn;

import java.util.HashMap;
import java.util.Map;
import javax.xml.namespace.QName;
import org.pasoa.accessors.DataAccessorManager;
import org.pasoa.accessors.DataAccessorRegistry;
import org.pasoa.accessors.XPath;
import org.pasoa.simpledom.DOMSerialiser;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class LFNAccessorManager implements DataAccessorManager {
    public static String _namespace   = "http://pegasus.isi.edu/schema/pasoa/content/transfer";
    public static String _elementName = "lfnAccessor";
    public static String _itemName    = "filename";
    
    private Map _spaces;
    
    public LFNAccessorManager () {
        _spaces = new HashMap ();
        _spaces.put ("transfer", _namespace);
    }
    
    public Element createLFNAccessor (String filename) {
        DOMSerialiser writer = new DOMSerialiser (_namespace);
        
        writer.single (_elementName, filename);
        
        return ((Document) writer.getRoot ()).getDocumentElement ();
    }

    public XPath convertToXPath (Element accessor) {
        return new XPath ("/transfer/filename[@file='" + accessor.getTextContent () + "']", _spaces);
    }

    public boolean equalDataAccessors (Element accessor1, String style1, Element accessor2, String style2) {
        return accessor1.getTextContent ().equals (accessor2.getTextContent ());
    }

    public Element getDataAccessorForItem (Node dataItem) {
        return createLFNAccessor (dataItem.getAttributes ().getNamedItem ("filename").getNodeValue ());
    }
    
    public void register (DataAccessorRegistry registry, boolean useAsDefault) {
        registry.register (new QName (_namespace, _elementName), this, useAsDefault);
    }
}
