/********************************************************************************
 * Created on Sep 6, 2005
 *
 * Copyright (c) 2005 University of Southampton
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE.
 *******************************************************************************/

package org.pasoa.common;

/**
 * Defines common constants used across PASOA project.
 * 
 * @author pgroth, sm
 *
 */
public interface Constants
{
    /**
     * A key to get a provenance store url from a map
     */
    public static final String PROVENANCE_STORE_URL = "provenance store URL";
    
    /**
     * PRecord namespace
     */
    public static final String PRECORD_NS   = "http://www.pasoa.org/schemas/version025/record/PRecord.xsd";
    
    /**
     * PQuery namespace
     */
    public static final String PQUERY_NS    = "http://www.pasoa.org/schemas/version025/pquery/ProvenanceQuery.xsd";
    
    /**
     * PStructure namespace
     */
    public static final String PSTRUCT_NS   = "http://www.pasoa.org/schemas/version025/PStruct.xsd";
    
    /**
     * Distributed/links namespace
     */
    public static final String PLINKS_NS    = "http://www.pasoa.org/schemas/version025/distribution/PLinks.xsd";
    
    /**
     * Web Services PStructure namespace
     */
    public static final String WPSTRUCT_NS = "http://www.pasoa.org/schemas/version025/PStruct.xsd";
    
    /**
     * PHeader namespace
     */
    public static final String PHEADER_NS   = "http://www.pasoa.org/schemas/version025/PHeader.xsd";
    
    
    /**
     * PASOA Xquery namespance
     */
    public static final String WSXQUERY_NS  = "http://www.pasoa.org/schemas/version025/xquery/XQuery.xsd";
    
    /**
     * PManage namespace
     */
    public static final String PMANAGE_NS   = "http://www.pasoa.org/schemas/version025/PManage.xsd";

    /**
     * The Sender View's viewkind
     */
    public static final String SENDER_VIEW_TYPE_NS = PSTRUCT_NS;
    public static final String SENDER_VIEW_TYPE    = "SenderViewKind";
    
    /**
     * The Receiver View's viewkind
     */
    public static final String RECEIVER_VIEW_TYPE_NS = PSTRUCT_NS;
    public static final String RECEIVER_VIEW_TYPE    = "ReceiverViewKind";
    
    /**
     * The Inferred View's viewkind
     */
    public static final String INFERRED_VIEW_TYPE_NS = PSTRUCT_NS;
    public static final String INFERRED_VIEW_TYPE    = "InferredViewKind";

    
    public static final String WSXQUERY_PREFIX = "xq";
    
    public static final String XSI_PREFIX = "xsi";
    public static final String XSI_NS = "http://www.w3.org/2001/XMLSchema-instance";

    public static final String SOAP_NS = "http://schemas.xmlsoap.org/soap/envelope/";
    
    public static final String RELATIONSHIP_PASSERTION_ELEMENT_NAME = "relationshipPAssertion";
    public static final String ACTOR_STATE_PASSERTION_ELEMENT_NAME = "actorStatePAssertion";
    public static final String INTERACTION_PASSERTION_ELEMENT_NAME = "interactionPAssertion";
    public static final String SUBMISSION_FINISHED_ELEMENT_NAME = "submissionFinished";
    public static final String INTERACTION_METADATA_ELEMENT_NAME = "exposedInteractionMetaData";
    public static final String RECORD_CONTEXT = "record";
    public static final String PQUERY_CONTEXT = "pquery";
    public static final String XQUERY_CONTEXT = "xquery";
}
