package org.pasoa.preserv.factory;


import org.pasoa.preserv.processor.Dispatcher;
import org.pasoa.preserv.processor.PlugInRegistry;
import org.pasoa.preserv.storage.Retrieval;
import org.pasoa.preserv.storage.StorageSystem;
import java.security.Principal;

public class ProvenanceStore
{
     private Dispatcher     _dispatcher;
     private PlugInRegistry _pir;
     private StorageSystem  _storageSystem;
    
     
     public ProvenanceStore (PlugInRegistry pir, StorageSystem storageSystem)
     {
         _pir = pir; 
         _storageSystem = storageSystem;
         _dispatcher = new Dispatcher (_storageSystem, _pir);
            
     }
     
     public boolean authenticate (Principal principal) {
         
         return true;
         
     }
     
     public PlugInRegistry getPlugInRegistry()
     {
         return _pir;
     }

     public Dispatcher getDispatcher()
     {
         return _dispatcher;
     }
     
     public void shutdown() throws Exception
     {
         _dispatcher.shutdown();
         _storageSystem.shutdown();
     }
     
     /**
      * Deletes the pstore and all its content
      * @throws Exception
      */
     public void delete() throws Exception
     {
         _dispatcher.shutdown();
         _storageSystem.delete();
         _dispatcher = new Dispatcher (_storageSystem, _pir);    
     }

     public Retrieval getRetrievalInterface() {
    	 return _storageSystem.getRetrievalInterface();
     }
}
