package org.pasoa.preserv.ontology;

import org.openrdf.model.Graph;
import org.openrdf.model.URI;
import org.openrdf.model.impl.URIImpl;
import org.openrdf.vocabulary.RDFS;

public class PASOAVocabulary {
    public static final String namespace = "http://www.pasoa.org/ontologies/process.owl#";
    
    // Classes
//    public static final URI AssertedActorState     = new URIImpl (namespace + "AssertedActorState");
//    public static final URI AssertedMessageContent = new URIImpl (namespace + "AssertedMessageContent");
    public static final URI Interaction            = new URIImpl (namespace + "Interaction");
    public static final URI ReceiveEvent           = new URIImpl (namespace + "ReceiveEvent");
    public static final URI SendEvent              = new URIImpl (namespace + "SendEvent");
    public static final URI SendOrReceiveEvent     = new URIImpl (namespace + "SendOrReceiveEvent");
    public static final URI Event                  = new URIImpl (namespace + "Event");
    public static final URI EventEntity            = new URIImpl (namespace + "EventEntity");
    public static final URI EventActor             = new URIImpl (namespace + "EventActor");
    
    // Properties
//    public static final URI assertsAbout  = new URIImpl (namespace + "assertsAbout");
    public static final URI hasMessageContent = new URIImpl (namespace + "hasMessageContent");
    public static final URI hasActorState     = new URIImpl (namespace + "hasActorState");
    public static final URI receivingOf       = new URIImpl (namespace + "receivingOf");
    public static final URI sendingOf         = new URIImpl (namespace + "sendingOf");
    public static final URI receivedBy        = new URIImpl (namespace + "receivedBy");
    public static final URI sentBy            = new URIImpl (namespace + "sentBy");
    public static final URI causedBy          = new URIImpl (namespace + "causedBy");
    
    public static void addOntology (Graph graph) {
        graph.add (SendEvent,    new URIImpl (RDFS.SUBCLASSOF), SendOrReceiveEvent);
        System.out.println ("Added triple: " + SendEvent    + " rdfs:subClassOf " + SendOrReceiveEvent);
        graph.add (ReceiveEvent, new URIImpl (RDFS.SUBCLASSOF), SendOrReceiveEvent);
        System.out.println ("Added triple: " + ReceiveEvent + " rdfs:subClassOf " + SendOrReceiveEvent);
        graph.add (SendOrReceiveEvent, new URIImpl (RDFS.SUBCLASSOF), Event);
        System.out.println ("Added triple: " + SendOrReceiveEvent + " rdfs:subClassOf " + Event);
    }
}
