/********************************************************************************
 * Created on 25 April 2006
 *
 * Copyright (c) 2005 University of Southampton
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *******************************************************************************/

package org.pasoa.preserv.ontology;

import org.openrdf.model.URI;
import org.openrdf.model.impl.URIImpl;

/**
 * SWRL functions
 *
 * @author Simon Miles sm@ecs.soton.ac.uk
 */
public class SWRLVocabulary {
    public static final String swrlb = "http://www.w3.org/2003/11/swrlb#";
    
    public static final URI booleanNot                      = new URIImpl (swrlb + "booleanNot");
    public static final URI empty                           = new URIImpl (swrlb + "empty");
    public static final URI equal                           = new URIImpl (swrlb + "equal");
    public static final URI first                           = new URIImpl (swrlb + "first");
    public static final URI subtractDayTimeDurationFromTime = new URIImpl (swrlb + "subtractDayTimeDurationFromTime");
}
