package org.pasoa.preserv.pquery;

import org.pasoa.pstructure.Link;
import org.pasoa.pstructure.ObjectID;
import org.pasoa.pstructure.PAssertionDataKey;
import org.pasoa.pstructure.RelationshipPAssertion;

public class FullRelationship {
    private ObjectID _subject;
    private ObjectID _object;
    private String   _relation;
    private String   _localPAssertionID;
    
    public FullRelationship (ObjectID subject, String relation, String localPAssertionID, ObjectID object) {
        _subject           = subject;
        _object            = object;
        _relation          = relation;
        _localPAssertionID = localPAssertionID;
    }
    
    public FullRelationship (PAssertionDataKey subject, String location, RelationshipPAssertion relationship, RelationshipTarget object) {
        this (new ObjectID (subject, relationship.getSubject ().getParameterName (), new Link (location)),
                relationship.getRelation (), relationship.getLocalPAssertionID (), object);
    }
    
    public String getLocalPAssertionID () {
        return _localPAssertionID;
    }
    
    public ObjectID getObject () {
        return _object;
    }    

    public String getRelation () {
        return _relation;
    }
    
    public ObjectID getSubject () {
        return _subject;
    }
}
