package org.pasoa.preserv.pquery;

import java.net.URL;
import java.util.Map;
import org.pasoa.common.Constants;
import org.pasoa.preserv.factory.PlugIn;
import org.pasoa.preserv.storage.StorageSystem;
import org.pasoa.pstructure.dom.PStructureJavaModel;
import org.pasoa.storeclient.proxy.LocalStoreProxy;
import org.pasoa.storeclient.proxy.StoreCatalogue;
import org.pasoa.storeclient.proxy.StoreProxy;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class ProvenanceQueryPlugin implements PlugIn {
    private Map _configuration;
    
    public Map getConfiguration () {
        return _configuration;
    }
    
    public String getDefaultResponse () {
        // Must be done synchrounously, so no default response
        return null;
    }
    
    public void initialize (Map configuration) {
        _configuration = configuration;
    }
    
    public Document process (Document document, StorageSystem ss) throws Exception {
        ProvenanceQueryDeserialiser parser       = new ProvenanceQueryDeserialiser ();
        ProvenanceQuerySerialiser   writer       = new ProvenanceQuerySerialiser ();
        //String                      thisStoreURL = (String) _configuration.get (Constants.PROVENANCE_STORE_URL);
        String                      thisStoreURL = "http://this.store.url";
        Document                    data         = PStructureJavaModel.getPStructureDocument (ss.getRetrievalInterface ());
        Element                     query        = (Element) document.getDocumentElement ().getElementsByTagNameNS (Constants.PQUERY_NS, "provenanceQuery").item (0);
        ProvenanceQueryRequest      request      = parser.deserialiseProvenanceQuery (query, ss.getRetrievalInterface (), thisStoreURL.toString (), data);
        StoreCatalogue              stores       = new StoreCatalogue ();
        StoreProxy                  local        = new LocalStoreProxy (ss, stores, thisStoreURL, false);
        ProvenanceQuery             querier;
        ProvenanceQueryResults      results;
        
        stores.registerDefaultStore (local);
        stores.registerStore (thisStoreURL, local);
        querier = new ProvenanceQueryEngine (stores, thisStoreURL, false);
        results = querier.resolve (request);
        
        return writer.serialiseProvenanceQueryResults (results);
    }
    
    public boolean receiveDispatchesSyncronously () {
        return true;
    }
}
