package org.pasoa.preserv.pquery;

import org.pasoa.pstructure.GlobalPAssertionKey;
import org.pasoa.pstructure.Link;
import org.pasoa.pstructure.ObjectID;
import org.w3c.dom.Element;

public class RelationshipTarget extends ObjectID {
    private String  _relation;
    private Element _assertion;
    
    public RelationshipTarget (GlobalPAssertionKey gpak, Element dataAccessor, String relation, String parameterName, Link objectLink, Element assertion) throws PQueryProblem {
        super (gpak, parameterName, dataAccessor, objectLink);
        if (assertion == null) {
            throw new PQueryProblem ("Tried to construct relationship target with null assertion at GPAK: " + gpak);
        }
        if (relation == null) {
            throw new PQueryProblem ("Tried to construct relationship target with null relation at GPAK: " + gpak);
        }
        _relation  = relation;
        _assertion = assertion;
    }
    
    public RelationshipTarget (ObjectID object, String defaultLinkURL, String relation, Element assertion) throws PQueryProblem {
        this (object.getGlobalPAssertionKey (), object.getDataAccessor (), relation, object.getParameterName (),
                getLink (object, defaultLinkURL), assertion);
    }
    
    public Element getAssertion () {
        return _assertion;
    }
    
    private static Link getLink (ObjectID object, String defaultLinkURL) {
        if (object.getLink () != null) {
            return object.getLink ();
        } else {
            return new Link (defaultLinkURL);
        }
    }
    
    public String getRelation () {
        return _relation;
    }
}
