package org.pasoa.preserv.pquery;

import java.util.Map;
import org.pasoa.preserv.xquery.QueryProblem;
import org.pasoa.accessors.XPath;
import org.pasoa.util.xpath.jaxen.XPathUtilities;
import org.w3c.dom.Element;

public class RelationshipTargetFilter {
    private String _path;
    private Map    _namespaces;
    private String _xmlMapping;
    
    public RelationshipTargetFilter (String path, Map namespaces, String xmlMapping) {
        _path       = path;
        _namespaces = namespaces;
        _xmlMapping = xmlMapping;
    }
    
    public boolean accept (RelationshipTarget target) throws PQueryProblem {
        try {
            ProvenanceQuerySerialiser encoder   = new ProvenanceQuerySerialiser ();
            Element                   targetDoc = encoder.serialiseRelationshipTarget (target).getDocumentElement ();
            
            return XPathUtilities.resolveBoolean (targetDoc, "boolean(" + _path + ")", _namespaces);
        } catch (QueryProblem ex) {
            throw new PQueryProblem ("Could not resolve relationship target filter", ex);
        }
    }
    
    public XPath getXPath () {
        return new XPath (_path, _namespaces);
    }
    
    public String toString () {
        return "Path: " + _path + ", Namespaces: " + _namespaces;
    }
}
