package org.pasoa.preserv.pquery.test;

import java.net.URL;
import org.pasoa.applications.average.AverageExample;
import org.pasoa.preserv.test.LocalTestbed;
import org.pasoa.preserv.test.RemoteTestbed;
import org.pasoa.simpledom.DOMWriter;

public class DistributedProvenanceQueryTest {
    public static final String whenReceivedByStore = "/ps:pstruct/ps:interactionRecord/ps:interactionKey/ps:messageSink[wsa:Address=\"" + AverageExample.store + "\"]/../../ps:receiver";
    public static final String messageContent      = "/ps:interactionPAssertion/ps:content";
    public static final String storedAtFile1       = "/ex:envelope/ex:store[ex:location=\"" + AverageExample.locate + "\"]/../..";
    public static final String findDataStored      = "/ex:envelope/ex:store/ex:data";
    //public static final String excludesSubTracer1  = "[not(ex:envelope/ph:pheader/ph:interactionMetaData[ph:tracer=\"" + AverageExample.tracer2 + "\"])]";
    
    public static void main (String[] arguments) {
        try {
            String         url1    = "http://localhost:8080/preserv";
            String         url2    = "http://localhost:8080/preserv2";
            RemoteTestbed  remote  = new RemoteTestbed (url1);
            RemoteTestbed  remote2 = new RemoteTestbed (url2);
            AverageExample average = new AverageExample ();
            
            average.record (remote, remote2, true);
            //System.out.println (DOMWriter.writeToString (local.getStoreContents (), true));
            
            System.out.println ("Provenance of data stored in file1");
            System.out.println (DOMWriter.writeToString (remote.provenanceQuery (
                    //"/ps:pstruct/ps:interactionRecord/ps:interactionKey/ps:messageSink[wsa:Address=\"" + AverageExample.store + "\"]/../..",
                    whenReceivedByStore + messageContent + storedAtFile1 + findDataStored,
                    "/pq:relationshipTarget" + messageContent, average.spaces), true));

        } catch (Exception problem) {
            problem.printStackTrace ();
            System.exit (1);
        }
    }
}
