package org.pasoa.preserv.pquery.test;

import java.util.HashMap;
import org.pasoa.applications.average.AverageExample;
import org.pasoa.preserv.pquery.ProvenanceQueryDeserialiser;
import org.pasoa.preserv.pquery.ProvenanceQueryResults;
import org.pasoa.preserv.test.LocalTestbed;
import org.pasoa.simpledom.DOMWriter;
import org.pasoa.storeclient.pquery.ActorProfileChecks;
import org.pasoa.storeclient.pquery.ProvenanceQueryBuilder;
import org.w3c.dom.Element;

public class ProvenanceQueryTest {
    public void test () throws Exception {
        LocalTestbed           testbed = new LocalTestbed ("C:/Code/PASOA-NB/store", true);
        //AverageExample         average = new AverageExample ();
        HashMap                spaces  = new HashMap ();
        ProvenanceQueryBuilder builder = new ProvenanceQueryBuilder (spaces);
        Element                results;
        
        //average.record (testbed);
        System.out.println (DOMWriter.writeToString (testbed.getStoreContents (), true));
        
        /*builder.getQDHBuilder ().
                sinkURL (AverageExample.store).
                receiver ().
                soapBodyCheck ("ex:store/ex:location=\"" + AverageExample.locate + "\"").
                soapBodyItem ("/ex:store/ex:data");
        builder.getRTFBuilder ().isInteraction ();*/
        
        ActorProfileChecks profile = new ActorProfileChecks (spaces);
        builder.getQDHBuilder       ().
                sender              ().
                concurrentState     (profile.nameCheck ("CapitalAllocator")).
                concurrentViewState (profile.nameCheck ("LendingEvaluator")).
                interactionItem     ().
                contentItem         ("/java/object/void/object");
        
        System.out.println ("Provenance of data stored in file1");
        results = testbed.provenanceQuery (builder.build ());
        System.out.println (DOMWriter.writeToString (results, true));
        
        ProvenanceQueryResults bean = new ProvenanceQueryDeserialiser ().
                deserialiseProvenanceQueryResults (results);
        System.out.println ();
        System.out.println (bean);
    }
    
    public static void main (String[] arguments) throws Exception {
        new ProvenanceQueryTest ().test ();
        System.exit (0);
    }
}
