package org.pasoa.preserv.pquery.test;

import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import org.pasoa.storeclient.ClientLib;
import org.w3c.dom.Document;

public class RemoteProvenanceQueryTest {
    public static final String whenReceivedByStore = "/ps:pstruct/ps:interactionRecord/ps:interactionKey/ps:messageSink[wsa:Address=\"http://www.example.com/actors/store\"]/../../ps:receiver";
    public static final String messageContent      = "/ps:interactionPAssertion/ps:content";
    public static final String storedAtFile1       = "/soap:Envelope/soap:Body/ex:store[ex:location=\"/home/sm/data/file1\"]/../../..";
    public static final String findDataStored      = "/soap:Envelope/soap:Body/ex:store/ex:data";
    
    public static void main (String[] arguments) throws Exception {
        ClientLib client = new ClientLib ();
        Map       spaces = new HashMap ();
        Document  results;
        
        spaces.put ("ps",   "http://www.pasoa.org/schemas/version025/PStruct.xsd");
        spaces.put ("pq",   "http://www.pasoa.org/schemas/version025/pquery/ProvenanceQuery.xsd");
        spaces.put ("wsa",  "http://schemas.xmlsoap.org/ws/2004/03/addressing");
        spaces.put ("soap", "http://schemas.xmlsoap.org/soap/envelope/");
        spaces.put ("ex",   "http://www.example.com");
        
        results = client.provenanceQuery (whenReceivedByStore + messageContent + storedAtFile1 + findDataStored,
                "/pq:relationshipTarget" + messageContent, spaces,
                new URL ("http://puffin.ecs.soton.ac.uk:8080/preserv/pquery"));
        
        //System.out.println (DOMWriter.writeToString (results, true));
    }
}
