package org.pasoa.preserv.record;

import java.io.InputStream;


/**
 * A cache used by the dispatcher. Implementations of the the interface
 * must be thread safe.
 * @author pgroth
 */
public interface Cache
{
    public boolean cacheEnabled ();
    
    public void cache (InputStream is, String context, boolean compressed) throws Exception;
    
    public void cache (CacheableItem ci) throws Exception;
    
    /**
     * Returns some item that has been cached. 
     * No order is guranteed. Returns null if there are no CachableItems
     * left in the cache. 
     * 
     * !!! When a cached item is gotten from the cache, it is removed
     *     from the cache and not longer exists there.
     * 
     * @return
     * @throws Exception
     */
    public CacheableItem getCachedItem () throws Exception;
    
    public void cacheShutdown();
   
}
