package org.pasoa.preserv.servlet.management;

import java.net.URL;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.pasoa.common.Constants;
import org.pasoa.preserv.storage.InitialConfig;
import org.pasoa.preserv.storage.mysql.MySQLStore;
import org.pasoa.simpledom.DOMWriter;
import org.pasoa.util.httpsoap.DefaultDocumentClient;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public class ManagementClient {
	
	public static void main(String args[]) {
		try {
			ManagementClient mc = new ManagementClient();
			//mc.deleteRepository(new URL("http://localhost:8080/preserv/manage"), "/store2", false);
			//mc.removeRepository(new URL("http://localhost:8080/preserv/manage"), "/store2", false);
			//System.out.println(DOMWriter.writeToString(mc.contentsOfRepository(new URL("http://localhost:8080/preserv/manage"), "/default", false), true));
//			mc.createRepository(new URL("http://localhost:8080/preserv/manage"), "/store3", MySQLStore.class.getCanonicalName(), "org.pasoa.preserv.xquery.laxquery.XQueryEngine", MySQLStore.getDefaultInitConfig(), false);
//			List<String> strs = mc.listRepositories(new URL("http://localhost:8080/preserv/manage"), "/default", false);
//			System.out.println(strs.size());
//			for (String s: strs) {
//				System.out.println(s);
//			}
			
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	
	public Document sendMessage(String msg, URL provenanceStore, boolean compress) throws Exception {
		String soap = "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\">" +
		"<soapenv:Header>" +
		"</soapenv:Header>" + 
		"<soapenv:Body>" +
		msg + 
		"</soapenv:Body>" +
		"</soapenv:Envelope>";

		DefaultDocumentClient ddc = new DefaultDocumentClient ();
		if (compress) {
			ddc.enablePostCompression();
		} 

		Document response = ddc.invoke (provenanceStore, soap);
		return response;
	}

	public boolean deleteRepository(URL managementSevlet, String storeName, boolean compressed) throws Exception {
		String msg = "<pm:deleteRepository xmlns:pm=\"" + Constants.PMANAGE_NS + "\">" +
				wrapRepository(storeName) +
				"</pm:deleteRepository>";
		ManagementResponseParaser p = new ManagementResponseParaser(sendMessage(msg, managementSevlet, compressed));
		return p.op.equals("deleteRepository") && p.success;
	}
	
	public boolean removeRepository(URL managementSevlet, String storeName, boolean compressed) throws Exception  {
		String msg = "<pm:removeRepository xmlns:pm=\"" + Constants.PMANAGE_NS + "\">" +
				wrapRepository(storeName) +
				"</pm:removeRepository>";
		ManagementResponseParaser p = new ManagementResponseParaser(sendMessage(msg, managementSevlet, compressed));
		return p.op.equals("removeRepository") && p.success;
	}
	
	public Node contentsOfRepository(URL managementSevlet, String storeName, boolean compressed) throws Exception  {
		String msg = "<pm:contentsOfRepository xmlns:pm=\"" + Constants.PMANAGE_NS + "\">" +
				wrapRepository(storeName) +
				"</pm:contentsOfRepository>";
		ManagementResponseParaser p = new ManagementResponseParaser(sendMessage(msg, managementSevlet, compressed));
		if (p.op.equals("contentsOfRepository") && p.success) {
			return p.content.getFirstChild();
		} else{
			return null;
		}
	}

	public boolean createRepository(URL managementSevlet, String storeName, String className, String xqueryEngine, InitialConfig options, boolean compressed) throws Exception  {
		String msg = "<pm:createRepository xmlns:pm=\"" + Constants.PMANAGE_NS + "\">" +
				wrapRepository(storeName) +
				"<pm:xqueryEngine>" +
				xqueryEngine + 
				"</pm:xqueryEngine>" +
				"<pm:className>" +
				className +
				"</pm:className>" +
				"<pm:initialConfig>";
		Enumeration<String> names = options.getInitParameterNames();
		while(names.hasMoreElements()){
			String name = names.nextElement();
			msg += "<pm:pair><pm:key>" + name + "</pm:key>" +
					"<pm:value>" + options.getInitParameter(name) + "</pm:value></pm:pair>";
		}
		msg += "</pm:initialConfig>" +
				"</pm:createRepository>";
		ManagementResponseParaser p = new ManagementResponseParaser(sendMessage(msg, managementSevlet, compressed));
		return p.op.equals("createRepository") && p.success;
	}

	
	private String wrapRepository(String name) {
		return "<pm:repository>" +
				"<pm:repositoryName>" +
				name +
				"</pm:repositoryName>" +
				"</pm:repository>";
	}
	
/*	private String unwrapRepository(Element el) {
		Node storeNameEl = el.getElementsByTagNameNS(Constants.PMANAGE_NS, "repositoryName").item(0);
		if (storeNameEl == null) {
			System.out.println("repositoryName null");
			return null;
		} else {
			return storeNameEl.getTextContent();
		}
	}*/
	
	public List<String> listRepositories(URL managementSevlet, String storeName, boolean compressed) throws Exception {
		String msg = "<pm:listRepositories xmlns:pm=\"" + Constants.PMANAGE_NS + "\" />";
		ManagementResponseParaser p = new ManagementResponseParaser(sendMessage(msg, managementSevlet, compressed));
		if (p.op.equals("listRepositories") && p.success) {
			List<String> stores = new ArrayList<String>();
			
			NodeList nl = p.content.getElementsByTagName("repositoryName");
			int length = nl.getLength();
//			System.out.println(length);
			for (int i = 0; i < length; i++) {
				stores.add(nl.item(i).getTextContent());
			}
			return stores;
		} else{
			return null;
		}
	}
	
}

class ManagementResponseParaser{
	
	String op;
	Element content;
	boolean success;
		
	public ManagementResponseParaser(Document doc) {
		// TODO
		NodeList nl = doc.getDocumentElement().getElementsByTagNameNS(Constants.PMANAGE_NS, "managementResponse");
		if (nl.getLength() > 0) {
			Element response = (Element)nl.item(0);
			success = Boolean.parseBoolean(response.getElementsByTagNameNS(Constants.PMANAGE_NS, "success").item(0).getTextContent());
			op = response.getElementsByTagNameNS(Constants.PMANAGE_NS, "operation").item(0).getTextContent();
			content = (Element)response.getElementsByTagNameNS(Constants.PMANAGE_NS, "content").item(0);
		}
//		System.out.println("op: " + op);
//		System.out.println("success: " + success);
//		if (content == null) {
//			System.out.println("Content == null");
//		} else { 
//			System.out.println("content: " + DOMWriter.writeToString(content, true));
//		}
	}
}