/********************************************************************************
 * Created on Jul 6, 2005
 *
 * Copyright (c) 2005 University of Southampton
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE.
 *******************************************************************************/

package org.pasoa.preserv.storage;

import org.pasoa.preserv.record.Cache;
import org.pasoa.preserv.management.Management;
import org.pasoa.preserv.record.Record;

/**
 * 
 * @author Paul Groth pg03r@ecs.soton.ac.uk
 * 
 * 
 * So that the backend class is compatible with the PreServ web management servlet, 
 * it must meet these conditions:
 * <ul>
 * <li> public static InitialConfig getDefaultInitConfig(); method should return an InitialConfig, 
 * which would contain the default values for the parameters needed by the class. A sample 
 * implementation of Initial config can be found in
 * org.pasoa.preserv.servlet.management.DefaultInitialConfigImpl
 *  
 * <li> A consrtuctor taking InitialConfig
 * <li> The class must be declared in a subpackage of org.pasoa.preserv.storage
 * </ul>
 * 
 * If the class does not meet these requirements the management servlet will 
 * consider it incompatible and will refuse to use.
 */
public interface BackendStore extends Record, Retrieval, Cache, Management
{

}
