package org.pasoa.preserv.storage.je;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.zip.GZIPInputStream;

import org.pasoa.preserv.record.CacheableItem;

public class ByteArrayCacheableItem extends CacheableItem 
{
    private byte[]       _bytes;
    private boolean      _compression;
    private StringBuffer _item;
    
    public ByteArrayCacheableItem (byte[] bytes, String context, boolean isCompressed)
    {
        super (context, null);
        
        _bytes = bytes;
        _compression = isCompressed;
        _item = null;
    }
    
    public boolean isCompressed()
    {
        return _compression;
    }
    
    public byte[] getBytes()
    {
        return _bytes;
    }
    
    public StringBuffer getItem()
    {
        StringBuffer sb = new StringBuffer();
        if (_item != null) {
            sb = _item;
        } else {
            try {
                ByteArrayInputStream bais = new ByteArrayInputStream (_bytes);
                BufferedReader br;
                if (_compression) {
                    br = new BufferedReader(new InputStreamReader(new GZIPInputStream(bais)));
                } else {
                    br = new BufferedReader(new InputStreamReader(bais));
                }
                String line;
    
                while ((line = br.readLine()) != null) {
                  sb.append(line);
                }
                br.close();
            } catch (IOException ioe) {
               System.out.println("ByteArrayCacheableItem: unable to process bytes into a string");
               ioe.printStackTrace();
            }
        }
         
        return sb;
    }
    
    
}
