package org.pasoa.preserv.storage.je;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.pasoa.simpledom.DOMWriter;
import org.w3c.dom.Element;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import com.sleepycat.bind.tuple.TupleBinding;
import com.sleepycat.bind.tuple.TupleInput;
import com.sleepycat.bind.tuple.TupleOutput;
import com.sleepycat.util.FastOutputStream;

public class DomElementBinding extends TupleBinding {
    
    private DocumentBuilder _docBuilder;
    private boolean         _compressing;
    
    public DomElementBinding (boolean compressing) throws ParserConfigurationException {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance ();
        dbf.setNamespaceAware (true);
        _docBuilder  = dbf.newDocumentBuilder ();
        _compressing = compressing;
    }
    
    public Object entryToObject (TupleInput ti) {
        
        Element elem = null;
        try {
            
            synchronized (_docBuilder) {
                if (_compressing) {
                    elem = _docBuilder.parse (new GZIPInputStream (ti)).getDocumentElement ();
                } else {
                    elem = _docBuilder.parse (ti).getDocumentElement ();
                }
            }
        } catch (SAXException e) {
            // TODO Auto-generated catch block
            e.printStackTrace ();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace ();
        }
        
        return elem;
    }
    
    public void objectToEntry (Object obj, TupleOutput to) {
        try {
            FastOutputStream baos = new FastOutputStream ();
            GZIPOutputStream gzos;
            
            Element   elem = (Element) obj;
            DOMWriter domWriter;
            
            if (_compressing) {
                gzos      = new GZIPOutputStream (baos);
                domWriter = new DOMWriter (gzos);
            } else {
                domWriter = new DOMWriter (baos);
            }
            domWriter.write (elem);
            domWriter.close ();
            
            to.write (baos.toByteArray ());
            
        } catch (IOException ioe) {
            ioe.printStackTrace ();
        }
        
    }
    
}
