package org.pasoa.preserv.storage.je;


import com.sleepycat.bind.EntryBinding;
import com.sleepycat.bind.tuple.LongBinding;
import com.sleepycat.bind.tuple.StringBinding;
import com.sleepycat.bind.tuple.TupleBinding;
import com.sleepycat.je.DatabaseEntry;
import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.SecondaryDatabase;
import com.sleepycat.je.SecondaryKeyCreator;

public class IKSecondaryKeyCreator implements SecondaryKeyCreator
{
    private EntryBinding _ikBinding;
   
    public IKSecondaryKeyCreator (EntryBinding binding)
    {
        _ikBinding = binding;
    }
    
    public boolean createSecondaryKey(SecondaryDatabase secondary,
                                      DatabaseEntry key,
                                      DatabaseEntry data,
                                      DatabaseEntry result)
        throws DatabaseException 
   {
        String ik = (String) _ikBinding.entryToObject(data);
        
        boolean returnValue = true;
        if (ik == null) {
            returnValue = false;
        }
        
        StringBinding.stringToEntry(ik, result);
        return returnValue;
    }
}
