package org.pasoa.preserv.storage.je;

import org.pasoa.pstructure.InteractionKey;
import org.pasoa.pstructure.serialiser.PStructureSerialiser;

import com.sleepycat.bind.tuple.TupleBinding;
import com.sleepycat.bind.tuple.TupleInput;
import com.sleepycat.bind.tuple.TupleOutput;

public class InteractionKeyBinding extends TupleBinding {

    private PStructureSerialiser _pss;
    
    public InteractionKeyBinding()
    {
        _pss = new PStructureSerialiser();
    }
    /**
     * Does not return an interaction key but its normalised string representation
     */
    public Object entryToObject(TupleInput ti) {
        return ti.readString();
       
    }

    /**
     * Serializes an interaction key to a byte array 
     */
    public void objectToEntry(Object obj, TupleOutput to) 
    {
        InteractionKey ik = (InteractionKey)obj;        
        to.writeString(_pss.normaliseInteractionKey(ik));
    }

}
