package org.pasoa.preserv.storage.mysql.test;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.Random;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.pasoa.common.Constants;
import org.pasoa.preserv.storage.BackendStore;
import org.pasoa.preserv.storage.mysql.Debug;
import org.pasoa.preserv.storage.mysql.MySQLRetrieval;
import org.pasoa.preserv.test.LocalTestbed;
import org.pasoa.preserv.test.Testbed;
import org.pasoa.pstructure.ActorStatePAssertion;
import org.pasoa.pstructure.ExposedInteractionMetadata;
import org.pasoa.pstructure.GlobalPAssertionKey;
import org.pasoa.pstructure.InteractionKey;
import org.pasoa.pstructure.InteractionPAssertion;
import org.pasoa.pstructure.InteractionRecord;
import org.pasoa.pstructure.Link;
import org.pasoa.pstructure.ObjectID;
import org.pasoa.pstructure.PAssertion;
import org.pasoa.pstructure.Record;
import org.pasoa.pstructure.RecordExposedInteractionMetadata;
import org.pasoa.pstructure.RecordSf;
import org.pasoa.pstructure.RelationshipPAssertion;
import org.pasoa.pstructure.View;
import org.pasoa.pstructure.serialiser.PStructureSerialiser;
import org.pasoa.simpledom.DOMSerialiser;
import org.pasoa.simpledom.DOMWriter;
import org.pasoa.simpledom.NormalisingDOMWriter;
import org.pasoa.util.httpsoap.WSAddressEndpoint;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class ExtremeTest {

	private BackendStore store;

	public String docStyle = "http://www.pasoa.org/schemas/ontologies/DocumentationStyle.Verbatim";
	private String subjectParameterName = "http://www.pasoa.org/schemas/ontologies/relationships/usage.user";
	private String relation = "http://www.pasoa.org/schemas/ontologies/relationships/use";

	private Random random= new Random(System.nanoTime());

//	Current values
	private InteractionKey currentInteractionKey;
	private String currentViewName;

	private PStructureSerialiser pserialiser = new PStructureSerialiser();

	private String objectParameterName = "http://www.pasoa.org/schemas/ontologies/relationships/usage.usedItem";

	private Map<String, String [][]> lpaids = new HashMap<String, String [][]>();

	private int maxSize = 15;

	public ExtremeTest(BackendStore store) {
		super();
		this.store = store;
	}

	public void defaultMaxSize() {
		maxSize = 15;
	}
	public void setMaxSize(int size) {
		maxSize = size;
	}

	public InteractionKey[] generateIKs (int size) throws SAXException, IOException{
		InteractionKey[] iks = new InteractionKey[size];
		for (int i = 0; i < size; i++){
			iks[i] = composeInteractionKey(
					"asserterAddress" + random.nextInt(),
					"asserterAddress" + random.nextInt(),
					"otherInteractionID" + Math.random()
			);
		}
		return iks;
	}

	public Element readElementFromFile(String filename) throws IOException, ParserConfigurationException, SAXException{
		BufferedReader br = new BufferedReader (new FileReader(filename));
		String input = "";
		String tmp = "";
		while ((tmp = br.readLine()) != null) {
			input = input + tmp;
		}
		br.close();

		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		dbf.setNamespaceAware(true);
		DocumentBuilder docBuilder = dbf.newDocumentBuilder();
		Element assertion = docBuilder.parse(new InputSource (new StringReader (input))).getDocumentElement();
		return assertion;
	}

	public void setCurrentInteraciton(InteractionKey intKey, String viewName) {
		currentInteractionKey = intKey;
		currentViewName = viewName; 
	}

	public InteractionRecord[] lastInserted(int n) throws Exception{
		Debug.msg("Getting last " + n + " recrods");
		long diff = store.getNumberOfInteractionRecords() - n;
		InteractionRecord[] irs = new InteractionRecord[n];
		for (int i = 0; i < n; i++) {
			Debug.msg("Getting record " + (i + diff) + " to " + i);
			irs[i] = store.getInteractionRecord(i + diff);
		}
		return irs;
	}

	public void lastInsertedNoSave(int n) throws Exception{
//		Debug.msg("Getting last " + n + " recrods");
		long diff = store.getNumberOfInteractionRecords() - n;
//		InteractionRecord[] irs = new InteractionRecord[n];
		for (int i = 0; i < n; i++) {
//			Debug.msg("Getting record " + (i + diff) + " to " + i);
//			irs[i] = store.getInteractionRecord(i + diff);
			store.getInteractionRecord(i + diff);
		}
//		return irs;
	}


	public static void lastInsertedNoSave(BackendStore store, int n) throws Exception{
//		Debug.msg("Getting last " + n + " recrods");
		long diff = store.getNumberOfInteractionRecords() - n;
//		InteractionRecord[] irs = new InteractionRecord[n];
		for (int i = 0; i < n; i++) {
//			Debug.msg("Getting record " + (i + diff) + " to " + i);
//			irs[i] = store.getInteractionRecord(i + diff);
			store.getInteractionRecord(i + diff);
		}
//		return irs;
	}


	public void recordIRAssync(InteractionRecord[] irs) throws Exception {
		Debug.msg("RecordIRAssync");
		Queue<recordMessage> q = new PriorityQueue<recordMessage>();
		for (InteractionRecord ir : irs) {
//			if (ir == null) throw new NullPointerException();
			decomposeIR(ir, q);
		}
//		Collections.sort(set);
		recordMessages(q);
	}

	public void recordMessages(Queue<recordMessage> q) throws Exception{
		Debug.msg("Recording messages: " + q.size());
		int i = 0;
		recordMessage rm;
		while ((rm = q.poll()) != null) {
//			Debug.msg("Recording " + rm.toString());
			if (i % 20 == 0) Debug.msg("\t" + i + " recorded");
			long start = System.currentTimeMillis();
			store.record(
					rm.getGpak(), 
					rm.getAsserter(), 
					rm.getAssertion(), 
					rm.getKindOfAssertion());
			long end = System.currentTimeMillis();
			Debug.msg("recording\t" + rm.getKindOfAssertion() + "\t" + (end - start));
			i++;
		}
	}

	public void decomposeIR(InteractionRecord ir, Queue<recordMessage> q) throws SAXException, IOException {
		InteractionKey ik = ir.getInteractionKey();
//		Sender
		decomposeView(ik, Constants.SENDER_VIEW_TYPE, ir.getSenderView(), q);

//		Receiver
		decomposeView(ik, Constants.RECEIVER_VIEW_TYPE, ir.getReceiverView(), q);
	}
	public void decomposeView(InteractionKey ik, 
			String viewKind, 
			View view, 
			Queue<recordMessage> q) throws SAXException, IOException {

		Element asserter = view.getAsserter();

		List<ActorStatePAssertion> apas = view.getActorStatePAssertions(); 
		for (ActorStatePAssertion apa: apas){
			q.offer(new recordMessage(
					new GlobalPAssertionKey(ik, viewKind, apa.getLocalPAssertionID()),
					asserter, 
					pserialiser.serialiseActorStatePAssertion(apa).getDocumentElement(), 
					Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME
			));
		}

		List<InteractionPAssertion> ipas = view.getInteractionPAssertions();
		for (InteractionPAssertion ipa: ipas){
			q.offer(new recordMessage(
					new GlobalPAssertionKey(ik, viewKind, ipa.getLocalPAssertionID()),
					asserter, 
					pserialiser.serialiseInteractionPAssertion(ipa).getDocumentElement(), 
					Constants.INTERACTION_PASSERTION_ELEMENT_NAME
			));
		}

		List<RelationshipPAssertion> rpas = view.getRelationshipPAssertions();
		for (RelationshipPAssertion rpa: rpas){
			q.offer(new recordMessage(
					new GlobalPAssertionKey(ik, viewKind, rpa.getLocalPAssertionID()),
					asserter, 
					pserialiser.serialiseRelationshipPAssertion(rpa).getDocumentElement(), 
					Constants.RELATIONSHIP_PASSERTION_ELEMENT_NAME
			));
		}

		List<ExposedInteractionMetadata> eims = view.getExposedInteractionMetadata();
		for (ExposedInteractionMetadata eim: eims){
			q.offer(new recordMessage(
					new GlobalPAssertionKey(ik, viewKind, ""),
					asserter, 
					pserialiser.serialiseExposedInteractionMetadata(eim).getDocumentElement(), 
					Constants.INTERACTION_METADATA_ELEMENT_NAME
			));
		}

//		Submission finished
		DOMSerialiser builder = new DOMSerialiser(Constants.PSTRUCT_NS);
		builder.start(Constants.SUBMISSION_FINISHED_ELEMENT_NAME);
		builder.text("" + view.getNumberOfExpectedPAssertions());
		builder.end();

		q.offer(new recordMessage(new GlobalPAssertionKey(ik, viewKind, ""),
				asserter,
				((Document)builder.getRoot()).getDocumentElement(),
				Constants.SUBMISSION_FINISHED_ELEMENT_NAME
		));
	}

	public void recordView(View view, InteractionKey ik, String viewName) throws Exception{
		recordIPAs(view.getInteractionPAssertions(), ik, viewName, view.getAsserter());
		recordAPAs(view.getActorStatePAssertions(), ik, viewName, view.getAsserter());
		recordRPAs(view.getRelationshipPAssertions(), ik, viewName, view.getAsserter());
		recordEIMs(view.getExposedInteractionMetadata(), ik, viewName, view.getAsserter());
		recordSF(view.getNumberOfExpectedPAssertions(), ik, viewName, view.getAsserter());
	}

	public void recordView(
			View view, 
			InteractionKey ik, 
			String viewName, 
			List<Long> _ipaT, 
			List<Long> _apaT,
			List<Long> _rpaT,
			List<Long> _eimT,
			List<Long> _sfT
	) throws Exception{
		_ipaT.add(recordIPAsT(view.getInteractionPAssertions(), ik, viewName, view.getAsserter()));
		_apaT.add(recordAPAsT(view.getActorStatePAssertions(), ik, viewName, view.getAsserter()));
		_rpaT.add(recordRPAsT(view.getRelationshipPAssertions(), ik, viewName, view.getAsserter()));
		_eimT.add(recordEIMsT(view.getExposedInteractionMetadata(), ik, viewName, view.getAsserter()));
		_sfT.add(recordSFT(view.getNumberOfExpectedPAssertions(), ik, viewName, view.getAsserter()));
	}


	public static void recordView(
			Testbed testbed,
			View view, 
			InteractionKey ik, 
			String viewName, 
			List<Long> _ipaT, 
			List<Long> _apaT,
			List<Long> _rpaT,
			List<Long> _eimT,
			List<Long> _sfT
	) throws Exception{
		_ipaT.add(recordPAT(testbed, view.getInteractionPAssertions(), ik, viewName, view.getAsserter()));
		_apaT.add(recordPAT(testbed, view.getActorStatePAssertions(), ik, viewName, view.getAsserter()));
		_rpaT.add(recordPAT(testbed, view.getRelationshipPAssertions(), ik, viewName, view.getAsserter()));
		_eimT.add(recordEIMsT(testbed, view.getExposedInteractionMetadata(), ik, viewName, view.getAsserter()));
		_sfT.add(recordSFT(testbed, view.getNumberOfExpectedPAssertions(), ik, viewName, view.getAsserter()));
	}

	
	public void recordIPAs(List<InteractionPAssertion> pas, InteractionKey ik, String viewName, Element asserter) throws Exception {
		for (InteractionPAssertion pa: pas) {
			store.record(
					new GlobalPAssertionKey(ik, viewName, pa.getLocalPAssertionID()), 
					asserter, 
					pserialiser.serialiseInteractionPAssertion(pa).getDocumentElement(), 
					Constants.INTERACTION_PASSERTION_ELEMENT_NAME);
		}
	}

	public void recordAPAs(List<ActorStatePAssertion> pas, InteractionKey ik, String viewName, Element asserter) throws Exception {
		for (ActorStatePAssertion pa: pas) {
			store.record(
					new GlobalPAssertionKey(ik, viewName, pa.getLocalPAssertionID()), 
					asserter, 
					pserialiser.serialiseActorStatePAssertion(pa).getDocumentElement(), 
					Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME);
		}
	}

	public void recordRPAs(List<RelationshipPAssertion> pas, InteractionKey ik, String viewName, Element asserter) throws Exception {
		for (RelationshipPAssertion pa: pas) {
			store.record(
					new GlobalPAssertionKey(ik, viewName, pa.getLocalPAssertionID()), 
					asserter, 
					pserialiser.serialiseRelationshipPAssertion(pa).getDocumentElement(), 
					Constants.RELATIONSHIP_PASSERTION_ELEMENT_NAME);
		}
	}

	public void recordEIMs(List<ExposedInteractionMetadata> pas, InteractionKey ik, String viewName, Element asserter) throws Exception {
		for (ExposedInteractionMetadata pa: pas) {
			store.record(
					new GlobalPAssertionKey(ik, viewName, null), 
					asserter, 
					pserialiser.serialiseExposedInteractionMetadata(pa).getDocumentElement(), 
					Constants.INTERACTION_METADATA_ELEMENT_NAME);
		}
	}


	public void recordSF(int sf, InteractionKey ik, String viewName, Element asserter) throws Exception {
		DOMSerialiser builder = new DOMSerialiser(Constants.PSTRUCT_NS);
		builder.start(Constants.SUBMISSION_FINISHED_ELEMENT_NAME);
		builder.text("" + sf);
		builder.end();
		store.record(
				new GlobalPAssertionKey(ik, viewName, null), 
				asserter, 
				((Document)builder.getRoot()).getDocumentElement(), 
				Constants.SUBMISSION_FINISHED_ELEMENT_NAME);
	}


	public long recordIPAsT(List<InteractionPAssertion> pas, InteractionKey ik, String viewName, Element asserter) throws Exception {
		long start = System.currentTimeMillis();
		for (InteractionPAssertion pa: pas) {
			store.record(
					new GlobalPAssertionKey(ik, viewName, pa.getLocalPAssertionID()), 
					asserter, 
					pserialiser.serialiseInteractionPAssertion(pa).getDocumentElement(), 
					Constants.INTERACTION_PASSERTION_ELEMENT_NAME);
		}
		return System.currentTimeMillis() - start;
	}

	public long recordAPAsT(List<ActorStatePAssertion> pas, InteractionKey ik, String viewName, Element asserter) throws Exception {
		long start = System.currentTimeMillis();
		for (ActorStatePAssertion pa: pas) {
			store.record(
					new GlobalPAssertionKey(ik, viewName, pa.getLocalPAssertionID()), 
					asserter, 
					pserialiser.serialiseActorStatePAssertion(pa).getDocumentElement(), 
					Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME);
		}
		return System.currentTimeMillis() - start;
	}

	public long recordRPAsT(List<RelationshipPAssertion> pas, InteractionKey ik, String viewName, Element asserter) throws Exception {
		long start = System.currentTimeMillis();
		for (RelationshipPAssertion pa: pas) {
			store.record(
					new GlobalPAssertionKey(ik, viewName, pa.getLocalPAssertionID()), 
					asserter, 
					pserialiser.serialiseRelationshipPAssertion(pa).getDocumentElement(), 
					Constants.RELATIONSHIP_PASSERTION_ELEMENT_NAME);
		}
		return System.currentTimeMillis() - start;
	}

	public long recordEIMsT(List<ExposedInteractionMetadata> pas, InteractionKey ik, String viewName, Element asserter) throws Exception {
		long start = System.currentTimeMillis();
		for (ExposedInteractionMetadata pa: pas) {
			store.record(
					new GlobalPAssertionKey(ik, viewName, null), 
					asserter, 
					pserialiser.serialiseExposedInteractionMetadata(pa).getDocumentElement(), 
					Constants.INTERACTION_METADATA_ELEMENT_NAME);
		}
		return System.currentTimeMillis() - start;
	}


	public long recordSFT(int sf, InteractionKey ik, String viewName, Element asserter) throws Exception {
		long start = System.currentTimeMillis();
		DOMSerialiser builder = new DOMSerialiser(Constants.PSTRUCT_NS);
		builder.start(Constants.SUBMISSION_FINISHED_ELEMENT_NAME);
		builder.text("" + sf);
		builder.end();
		store.record(
				new GlobalPAssertionKey(ik, viewName, null), 
				asserter, 
				((Document)builder.getRoot()).getDocumentElement(), 
				Constants.SUBMISSION_FINISHED_ELEMENT_NAME);
		return System.currentTimeMillis() - start;
	}

	
	public static long recordPAT(Testbed testbed, List<? extends PAssertion> pas, InteractionKey ik, String viewName, Element asserter) throws Exception {
		long start = System.currentTimeMillis();
		for (PAssertion pa: pas) {
			testbed.record(new Record(pa, ik, viewName, asserter));
		}
		return System.currentTimeMillis() - start;
	}

	public static long recordEIMsT(Testbed testbed, List<ExposedInteractionMetadata> pas, InteractionKey ik, String viewName, Element asserter) throws Exception {
		long start = System.currentTimeMillis();
		for (ExposedInteractionMetadata pa: pas) {
			testbed.record(new RecordExposedInteractionMetadata(pa, ik, viewName, asserter));
		}
		return System.currentTimeMillis() - start;
	}


	public static long recordSFT(Testbed testbed, int sf, InteractionKey ik, String viewName, Element asserter) throws Exception {
		long start = System.currentTimeMillis();
		testbed.record(new RecordSf(sf, ik, viewName, asserter));
		return System.currentTimeMillis() - start;
	}

	public Element composeAsserter(String str) throws SAXException, IOException{
		return (new WSAddressEndpoint("<asserterString>" + str + random.nextInt() + "</asserterString>")).getElement();
	}

	public InteractionRecord composeInteractionRecord (
			Element sender, 
			Element receiver, 
			GlobalPAssertionKey[][] objecidS, 
			GlobalPAssertionKey[][] objecidR, 
			GlobalPAssertionKey[] metadataS, 
			GlobalPAssertionKey[] metadataR
	) throws SAXException, IOException{

		Debug.msg("Composing InteractionRecord");
		currentInteractionKey = composeInteractionKey(
				DOMWriter.writeToString(sender),
				DOMWriter.writeToString(receiver),
				"interactionid" + Math.random()
		);
		return new InteractionRecord(
				currentInteractionKey,
				composeView(sender, generateSize(maxSize), generateSize(maxSize), objecidS, metadataS, Constants.SENDER_VIEW_TYPE),
				composeView(receiver, generateSize(maxSize), generateSize(maxSize),objecidR, metadataR, Constants.RECEIVER_VIEW_TYPE)
		);
	}

	/**
	 * 
	 * @param asserter
	 * @param intPAsize
	 * @param actPAsize
	 * @param objectids
	 * @param eimSize
	 * @return
	 * @throws IOException 
	 * @throws SAXException 
	 */
	public View composeView(Element asserter, int intPAsize, int actPAsize, GlobalPAssertionKey[][] objectids, GlobalPAssertionKey[] metadata, String viewName) throws SAXException, IOException {
		currentViewName = viewName;
//		Debug.msg("Composing View");
		if (objectids == null)
			objectids = new GlobalPAssertionKey[generateSize()][];
		String[] ils = generateLocalPAssertionIDs(intPAsize);
		String[] als = generateLocalPAssertionIDs(actPAsize);
		String[] rls = generateLocalPAssertionIDs(objectids.length);

//		String[] ols = generateLocalPAssertionIDs(relPA.size());
//		String[] els = generateLocalPAssertionIDs(relPAsize);

		List <InteractionPAssertion> ipa = composeInteractionPA(ils);
		List <ActorStatePAssertion> apa = composeActorStatePA(als);

		String [][] passertions = new String[][]{ils, als, rls};
		lpaids.put(viewName, passertions);
		List <RelationshipPAssertion> rpa = composeRelationshipPA(rls, mapRelations(passertions, objectids));
		List <ExposedInteractionMetadata> eim = composeEIM(metadata, passertions); 

		return new View(ipa, apa, rpa, eim, ipa.size() + apa.size() + rpa.size() + eim.size(), asserter);
	}

	public String [][] getLpaids(String viewName) {
		return lpaids.get(viewName);
	}

	private boolean randomSize = true;

	public void setRandomSize(boolean s) {
		randomSize = s;
	}

	public int generateSize() {
		int n;
		if (randomSize) {
			do {
				n = random.nextInt(maxSize);
			} while (n <= 0);
		} else {
			n = maxSize;
		}
		return n;
	}

	public int generateSize(int l) {
		int n;
		if (randomSize) {
			do {
				n = random.nextInt(l);
			} while (n <= 0);
		} else {
			n = maxSize <= l ? maxSize : l ;
		}
//		Debug.msg("Generating size " + n);
		return n;
	}

	public int generateIndex(int l) {
		int n;
		do {
			n = random.nextInt(l);
		} while (n < 0);
//		Debug.msg("Generating index " + n);
		return n;
	}

	public GlobalPAssertionKey[][] ensureGpaks (GlobalPAssertionKey[][] gps, String [][] passertions) {
//		Debug.msg("Ensuring GPAKS");
		if (gps == null) {
			int size1 = generateSize();
			gps = new GlobalPAssertionKey[size1][]; 
			for (int i = 0; i < size1; i++) {
				gps[i] = generateGpaks(passertions);
			}
		} else { 
			for (int i = 0; i < gps.length; i++) {
				if (gps[i] == null) {
					gps[i] = generateGpaks(passertions);
				} else gps[i] = generateGpaks(gps[i], passertions);
			}
		}
		return gps;
	}

	public GlobalPAssertionKey[] generateGpaks(GlobalPAssertionKey[] g, String [][] passertions) {
//		Debug.msg("Generating Gpaks");
		if (g == null) return generateGpaks(passertions);
		for (int i = 0; i < g.length; i++){
			if (g[i] == null) g[i] = lpaid2gpak(getRandomLPAID(passertions));
		}
		return g;
	}

	public GlobalPAssertionKey[] generateGpaks(String [][] passertions) {
//		Debug.msg("Generating Gpaks");
		int size = generateSize();
		GlobalPAssertionKey[] g = new GlobalPAssertionKey[size];
		for (int k = 0; k < size; k++) g[k] = lpaid2gpak(getRandomLPAID(passertions));
		return g;
	}

	public Map<String, GlobalPAssertionKey[]> mapRelations(String[][] passertions, GlobalPAssertionKey[][] objectids) {
//		Debug.msg("Mapping Relations");
		ensureGpaks(objectids, passertions);
		Map<String, GlobalPAssertionKey[]> map = new HashMap<String, GlobalPAssertionKey[]>();
		for (int i = 0; i < objectids.length; i++) {
			while (map.put(getRandomLPAID(passertions), objectids[i]) != null){
				Debug.msg("Filling the map");
			}
		}
		return map;
	}

	public String getRandomLPAID (String[][] passertions) {
		int pt = generateIndex(passertions.length);
		return passertions[pt][generateIndex(passertions[pt].length)];
	}

	public GlobalPAssertionKey getRandomGPAK(InteractionKey intKey, String viewKind, String[][] passertions){
		return new GlobalPAssertionKey(intKey, viewKind, getRandomLPAID(passertions));
	}

	public GlobalPAssertionKey lpaid2gpak(String localPAssertionID){
		return new GlobalPAssertionKey(currentInteractionKey, currentViewName, localPAssertionID);
	}

	public String[] generateLocalPAssertionIDs (int size) {
//		Debug.msg("Generate random LPAIDs");
		String[] list = new String[size];
		for (int i = 0; i < size; i++) {
			list[i] = "localPAID" + random.nextInt();
		}
		return list;
	}

	public InteractionKey composeInteractionKey(Element sender, Element receiver, String interactionID) throws SAXException, IOException{
		return composeInteractionKey(DOMWriter.writeToString(sender), DOMWriter.writeToString(receiver), interactionID);
	}

	public InteractionKey composeInteractionKey(String sender, String receiver, String interactionID) throws SAXException, IOException{
		return new InteractionKey(
				MySQLRetrieval.string2Element("<endPointReference>" + sender + "</endPointReference>"),
				MySQLRetrieval.string2Element("<endPointReference>" + receiver + "</endPointReference>"),
				interactionID);
	}

	public List<ActorStatePAssertion> composeActorStatePA(String localPAssertionIDs[]) throws SAXException, IOException {
		List <ActorStatePAssertion> list = new ArrayList<ActorStatePAssertion>(localPAssertionIDs.length);
		for (String id: localPAssertionIDs)
			list.add(new ActorStatePAssertion(id, docStyle, composeStateBody()));
		return list;
	}

	public List<InteractionPAssertion> composeInteractionPA(String localPAssertionIDs[]) throws SAXException, IOException {
		List <InteractionPAssertion> list = new ArrayList<InteractionPAssertion>(localPAssertionIDs.length);
		for (String id: localPAssertionIDs)
			list.add(new InteractionPAssertion(id, docStyle, composeStateBody()));
		return list;
	}

	public List<RelationshipPAssertion> composeRelationshipPA(String localPAssertionIDs[], Map<String, GlobalPAssertionKey []> map) throws SAXException, IOException {
//		Debug.msg("Composing RPA");
		List <RelationshipPAssertion> list = new ArrayList<RelationshipPAssertion>(localPAssertionIDs.length);
		if (localPAssertionIDs.length != map.size()) throw new IllegalArgumentException();
		Iterator<String> subject = map.keySet().iterator();
		for (int i = 0; i < localPAssertionIDs.length; i++) {
			String subjid = subject.next();
			list.add(new RelationshipPAssertion(
					localPAssertionIDs[i],
					subjid,
					composeDataAccessor(),
					subjectParameterName,
					relation,
					composeObjectIDs(map.get(subjid))
			));
		}
		return list;
	}

	public List<ObjectID> composeObjectIDs(GlobalPAssertionKey gpaks[]) throws SAXException, IOException {
		List <ObjectID> list = new ArrayList<ObjectID>(gpaks.length);
		for (GlobalPAssertionKey id: gpaks)
			list.add(new ObjectID(id, objectParameterName, composeDataAccessor(), composeObjectLink()));
		return list;
	}

	public Link composeObjectLink() {
		return new Link("ftp://someotherstore.ac.uk/store");
	}

	public List<ExposedInteractionMetadata> composeEIM(GlobalPAssertionKey gpaks[], String [][] passertions) throws SAXException, IOException {
		gpaks = generateGpaks(gpaks, passertions);
		List <ExposedInteractionMetadata> list = new ArrayList<ExposedInteractionMetadata>(gpaks.length);
		for (GlobalPAssertionKey id: gpaks)
			list.add(new ExposedInteractionMetadata(id, composeMetadata()));
//		Debug.msg(currentInteractionKey.getInteractionID() + " EIM : " + list.size());
		return list;
	}

	public List<Element> composeMetadata() throws SAXException, IOException {
//		Debug.msg("Compose Metadata");
		int size = generateSize();
		List<Element> list = new ArrayList<Element> (size);
		for (int i = 0; i < size; i++) {
			list.add(MySQLRetrieval.string2Element("<interactionMetaData xmlns=\"" + Constants.PSTRUCT_NS + "\"><met>metadata" + random.nextLong() + "</met></interactionMetaData>"));
		}
		return list;
	}

	public Element composeStateBody() throws SAXException, IOException {
		return MySQLRetrieval.string2Element("<insideText>jfdlsa kfhdsajkf hdljhafd k sljahfdksjq hariewyfhds khfdkjsa hfdkjsa hfdkjha fdksjah fdksjafhdksjhfdjksa hfkdjsh fldsafd jsafkdlhs kjafh dsjfdh sakfjdshafjkdhsalkfhd jfhd saklfhdasjlf hdsjakfhldkjsahf djsahf dlsahfewqrueiwqur iewuqr ioefdsajfhcxzvnxcbz ,vdjsah feuwyrehfjkdashfkjdhfbcnvbcxzklhfd quiryeuwqieryjdfhkahfdklafhdsaifoeuqwioeruiqtuerwiotu hjfahdklsahf djasghdjfkhgkfdhsgfjeqtu erioptureiqop rewuqior ueifjdsak fhsdjakf djsafhdksahroieuwqreujwioqhfjdhakljfdhsakjlrfeioqureqhithrjkhfklsdjhgdfkstyeriq" +
		"</insideText>");
	}

	public boolean areEqual(InteractionRecord[] ir1, InteractionRecord[] ir2){
		Debug.msg("Are equal IR[]");
		if (ir1.length != ir2.length){
			Debug.err("Lengths of IR lists do not match " + ir1.length + " and " + ir2.length);
			return false;
		}

		PriorityQueue<irWrapper> q1 = new PriorityQueue<irWrapper>(); 
		PriorityQueue<irWrapper> q2 = new PriorityQueue<irWrapper>();

		for (int i = 0; i < ir1.length; i++) {
			q1.offer(new irWrapper(ir1[i]));
			q2.offer(new irWrapper(ir2[i]));
		}

		boolean f = areEqual(q1, q2);
		if (!f) Debug.err("IR lists do not match");
		return f;
	}

	public boolean areEqual(InteractionRecord ir1, InteractionRecord ir2) {
		Debug.msg("Are equal IR");
		PStructureSerialiser psSerialiser = new PStructureSerialiser();				

//		InteractionKeys
		if (!ir1.getInteractionKey().equals(ir2.getInteractionKey())) {
			Debug.err("InteractionKeys do not match");
			return false;
		}

//		Views
		if (!areEqual(ir1.getSenderView(), ir2.getSenderView())) return false;
		if (!areEqual(ir1.getReceiverView(), ir2.getReceiverView())) return false;

		return true;
	}

	public boolean isFromStoreAPA(List<ActorStatePAssertion> list) {
		if (list == null || list.size() == 0) return false;
		return list.get(0).getContent().getNodeName().equals(Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME);
	}

	public boolean isFromStoreAPA(ActorStatePAssertion apa) {
		return apa.getContent().getNodeName().equals(Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME);
	}

	public boolean isFromStoreIPA(InteractionPAssertion ipa) {
		return ipa.getContent().getNodeName().equals(Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME);
	}

	public boolean isFromStoreIPA(List<InteractionPAssertion> list) {
		if (list == null || list.size() == 0) return false;
		return list.get(0).getContent().getNodeName().equals(Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME);
	}


	public boolean areEqual(View view1, View view2) {
		Debug.msg("Are equal view");
//		Asserter
		if ((view1.getAsserter() == null && view2.getAsserter() == null) || !NormalisingDOMWriter.writeToString(
				view1.getAsserter()
		).equals(NormalisingDOMWriter.writeToString(
				view2.getAsserter())
		)
		) {
			Debug.err("Asserters do not match");
			return false;
		}
		PriorityQueue<String> q1 = null;
		PriorityQueue<String> q2 = null;

		// ExposedInteractionMetadata
		List <ExposedInteractionMetadata> eimList1 = view1.getExposedInteractionMetadata();
		List <ExposedInteractionMetadata> eimList2 = view2.getExposedInteractionMetadata();
		if (!((eimList1 == null || eimList1.size() == 0) && (eimList2 == null || eimList2.size() == 0) ) && 
				eimList1.size() != eimList2.size()) {
			Debug.err("ExposedInteractionMetadata length does not match " + eimList1.size() + " and " + eimList2.size());
			for (ExposedInteractionMetadata eim: eimList1)
				Debug.err(DOMWriter.writeToString(pserialiser.serialiseExposedInteractionMetadata(eim), true));
			Debug.err("\nNext\n");
			for (ExposedInteractionMetadata eim: eimList2)
				Debug.err(DOMWriter.writeToString(pserialiser.serialiseExposedInteractionMetadata(eim), true));
			return false;
		}
//		boolean eimFlag = false;
		if (eimList1 != null && eimList2 != null) {

			Iterator<ExposedInteractionMetadata> eimit1 = eimList1.iterator();
			Iterator<ExposedInteractionMetadata> eimit2 = eimList2.iterator();
			q1 = new PriorityQueue<String>();
			q2 = new PriorityQueue<String>();

			while (eimit1.hasNext()) {
				Element originalEimElem = pserialiser.serialiseExposedInteractionMetadata(eimit1.next()).getDocumentElement();
				Element receivedEimElem = pserialiser.serialiseExposedInteractionMetadata(eimit2.next()).getDocumentElement();

				q1.offer(NormalisingDOMWriter.writeToString(originalEimElem));
				q2.offer(NormalisingDOMWriter.writeToString(receivedEimElem));
			}
			if (!areEqual(q1, q2)) {
				Debug.err("ExposedInteractionMetadata does not match");
				return false;
			}

			eimit1 = null;
			eimit2 = null;
			eimList1 = null;
			eimList2 = null;
			q1.clear();
			q2.clear();
		}
		// ActorState


		List<ActorStatePAssertion> apalistDB = view1.getActorStatePAssertions(); 
		List<ActorStatePAssertion> apalistCr;

		if (isFromStoreAPA(apalistDB)){
			apalistCr = view2.getActorStatePAssertions();
		} else {
			apalistCr = apalistDB; 
			apalistDB = view2.getActorStatePAssertions();
		}

		if (!((apalistDB == null || apalistDB.size() == 0) && (apalistCr == null || apalistCr.size() == 0) ) && 
				apalistDB.size() != apalistCr.size()) {
			Debug.err("Not the same number of APAs");
			return false;
		}


		Iterator<ActorStatePAssertion> apaitDB = apalistDB.iterator();
		Iterator<ActorStatePAssertion> apaitCr = apalistCr.iterator();

		if (apalistDB != null && apalistCr != null) {
			while (apaitDB.hasNext()) {
				q1.offer(NormalisingDOMWriter.writeToString(apaitDB.next().getContent()));
				q2.offer(NormalisingDOMWriter.writeToString(pserialiser.serialiseActorStatePAssertion(apaitCr.next())));
			}

			if (!areEqual(q1, q2)) {
				Debug.err("APAs do not match");
				return false;
			}

			apalistDB = null;
			apalistCr = null;
			apaitDB = null;
			apaitCr = null;
			q1.clear();
			q2.clear();
		}

		// InteractionPA
		List<InteractionPAssertion> ipalistDB = view1.getInteractionPAssertions(); 
		List<InteractionPAssertion> ipalistCr;

		if (isFromStoreIPA(ipalistDB)){
			ipalistCr = view2.getInteractionPAssertions();
		} else {
			ipalistCr = ipalistDB; 
			ipalistDB = view2.getInteractionPAssertions();
		}

		if (!((ipalistDB == null || ipalistDB.size() == 0) && (ipalistCr == null || ipalistCr.size() == 0) ) && 
				ipalistDB.size() != ipalistCr.size()) {
			Debug.err("Not the same number of IPAs");
			return false;
		}

		if (ipalistDB != null && ipalistCr != null) {
			Iterator<InteractionPAssertion> ipaitDB = ipalistDB.iterator();
			Iterator<InteractionPAssertion> ipaitCr = ipalistCr.iterator();

			while (ipaitDB.hasNext()) {
				q1.offer(NormalisingDOMWriter.writeToString(ipaitDB.next().getContent()));
				q2.offer(NormalisingDOMWriter.writeToString(pserialiser.serialiseInteractionPAssertion(ipaitCr.next())));
			}

			if (!areEqual(q1, q2)) {
				Debug.err("APAs do not match");
				return false;
			}

			ipalistDB = null;
			ipalistCr = null;
			ipaitDB = null;
			ipaitCr = null;
			q1.clear();
			q2.clear();
		}

		List<RelationshipPAssertion> rpalist1 = view1.getRelationshipPAssertions();
		List<RelationshipPAssertion> rpalist2 = view2.getRelationshipPAssertions();

		// RelationshipPA
		if (!((rpalist1 == null || rpalist1.size() == 0) && (rpalist2 == null || rpalist2.size() == 0) ) && 
				rpalist1.size() != rpalist2.size()) {
			Debug.err("Not the same number of RPAs");
			return false;
		}

		if (rpalist1 != null && rpalist2 != null) {

			Iterator<RelationshipPAssertion> rpait1 = rpalist1.iterator();
			Iterator<RelationshipPAssertion> rpait2 = rpalist2.iterator();

			while (rpait1.hasNext()) {
				q1.offer(NormalisingDOMWriter.writeToString(pserialiser.serialiseRelationshipPAssertion(rpait1.next())));
				q2.offer(NormalisingDOMWriter.writeToString(pserialiser.serialiseRelationshipPAssertion(rpait2.next())));
			}

			if (!areEqual(q1, q2)) {
				Debug.err("RPAs do not match");
				return false;
			}

			q1.clear();
			q2.clear();

			rpalist1 = null;
			rpalist2 = null;
			rpait1 = null;
			rpait2 = null;
		}
		// numberOfExpectedPAssertions
		if (view1.getNumberOfExpectedPAssertions() != view2.getNumberOfExpectedPAssertions()) {
			Debug.err("NumberOfExpectedPAssertions does not match " + 
					view1.getNumberOfExpectedPAssertions() + ", " + 
					view2.getNumberOfExpectedPAssertions());
			return false;
		}

		return true;
	}

	public boolean areEqual(ActorStatePAssertion pa1, ActorStatePAssertion pa2) {
		ActorStatePAssertion pa3;
		if (isFromStoreAPA(pa2)){
			pa3 = pa1;
			pa1 = pa2;
			pa2 = pa3;
		}

		return NormalisingDOMWriter.writeToString(pa1.getContent()).equals(
				NormalisingDOMWriter.writeToString(pserialiser.serialiseActorStatePAssertion(pa2))
		);
	}

	public boolean areEqual(ExposedInteractionMetadata eim1, ExposedInteractionMetadata eim2) {
		Element originalEimElem = pserialiser.serialiseExposedInteractionMetadata(eim1).getDocumentElement();
		Element receivedEimElem = pserialiser.serialiseExposedInteractionMetadata(eim2).getDocumentElement();
		String str1 = NormalisingDOMWriter.writeToString(originalEimElem);
		String str2 = NormalisingDOMWriter.writeToString(receivedEimElem);
		boolean f = str1.equals(str2); 
		if (!f) {
			Debug.err(str1);
			Debug.err(str2);
		}
		return f;
	}
	
	public boolean areEqual(RelationshipPAssertion pa1, RelationshipPAssertion pa2) {
		return NormalisingDOMWriter.writeToString(pserialiser.serialiseRelationshipPAssertion(pa1)).equals(
				NormalisingDOMWriter.writeToString(pserialiser.serialiseRelationshipPAssertion(pa2))
		);
	}

	public boolean areEqual(InteractionPAssertion pa1, InteractionPAssertion pa2) {
		InteractionPAssertion pa3;
		if (isFromStoreIPA(pa2)){
			pa3 = pa1;
			pa1 = pa2;
			pa2 = pa3;
		}

		return NormalisingDOMWriter.writeToString(pa1.getContent()).equals(
				NormalisingDOMWriter.writeToString(pserialiser.serialiseInteractionPAssertion(pa2))
		);
	}


	public boolean areEqual(PriorityQueue<?> q1, PriorityQueue<?> q2) {
		Debug.msg("Are equal PQ");
		if (q1.size() != q2.size()) return false;
		while (q1.size() > 0) {
			Object o1 = q1.poll();
			Object o2 = q2.poll();
			if (!o1.equals(o2)) {
				Debug.err("Not equal \n" + o1.toString() + "\n" + o2.toString());
				return false;
			}
		}
		return true;
	}

	/*	public void printList(List<? extends PAssertion> l) {
		for (PAssertion pa: l) {
			Debug.err(pa.getLocalPAssertionID());
		}
	}*/

	public Element composeDataAccessor() throws SAXException, IOException {
		return MySQLRetrieval.string2Element("<xp:xpath xmlns:xp=\"http://www.pasoa.org/xpath\">/</xp:xpath>");
	}

	public class recordMessage implements Comparable{

		private GlobalPAssertionKey gpak;
		private Element asserter;
		private String gpakString;
		private Element assertion;
		private String kindOfAssertion;

		public recordMessage(GlobalPAssertionKey gpak, Element asserter, Element assertion, String kindOfAssertion) {
			super();
			this.gpak= gpak;
			this.asserter= asserter;
			this.assertion= assertion;
			this.kindOfAssertion= kindOfAssertion;
			this.gpakString = gpak.toString();
		}

		public int compareTo(Object o) {
			return gpakString.compareTo(((recordMessage)o).gpakString);
		}

		public Element getAsserter() {
			return asserter;
		}

		public void setAsserter(Element asserter) {
			this.asserter = asserter;
		}

		public Element getAssertion() {
			return assertion;
		}

		public void setAssertion(Element assertion) {
			this.assertion = assertion;
		}

		public GlobalPAssertionKey getGpak() {
			return gpak;
		}

		public void setGpak(GlobalPAssertionKey gpak) {
			this.gpak = gpak;
			gpakString = gpak.toString();
		}

		public String getKindOfAssertion() {
			return kindOfAssertion;
		}

		public void setKingOfAssertion(String kindOfAssertion) {
			this.kindOfAssertion = kindOfAssertion;
		}

		public String toString(){
			return "RecordMessage\n\tgpak " + gpak + 
			"\n\tasserter " + asserter + 
			"\n\tgpakString " + gpakString +
			"\n\tassertion " + assertion +
			"\n\tkindOfAssertion " + kindOfAssertion;
		}

	}

	public class irWrapper implements Comparable {

		private InteractionRecord ir;
		private String comp;

		public irWrapper(InteractionRecord ir) {
			this.ir= ir;
			comp = pserialiser.normaliseInteractionKey(ir.getInteractionKey());
		}



		public InteractionRecord getIr() {
			return ir;
		}

		public void setIr(InteractionRecord ir) {
			this.ir= ir;
			comp = pserialiser.normaliseInteractionKey(ir.getInteractionKey());
		}

		public int compareTo(Object o) {
			return comp.compareTo(((irWrapper)o).comp);
		}

		public boolean equals(Object w) {
			Debug.msg("Comapring irW");
			return areEqual(ir, ((irWrapper)w).ir);
		}

		public String toString() {
			return comp;
		}
	}
}
