package org.pasoa.preserv.storage.mysql.test;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.pasoa.preserv.pquery.ProvenanceQueryDeserialiser;
import org.pasoa.preserv.pquery.ProvenanceQueryPlugin;
import org.pasoa.preserv.pquery.ProvenanceQueryRequest;
import org.pasoa.preserv.processor.Dispatcher;
import org.pasoa.preserv.processor.PlugInRegistry;
import org.pasoa.preserv.record.RecordPlugIn;
import org.pasoa.preserv.storage.GeneralStorageSystem;
import org.pasoa.preserv.storage.StorageSystem;
import org.pasoa.preserv.storage.je.BerkeleyDBJEStorage2;
import org.pasoa.preserv.storage.mysql.Debug;
import org.pasoa.preserv.storage.mysql.MySQLStore;
import org.pasoa.preserv.test.Testbed;
import org.pasoa.preserv.xquery.XQueryPlugIn;
import org.pasoa.pstructure.InteractionRecord;
import org.pasoa.pstructure.Record;
import org.pasoa.pstructure.dom.PStructureJavaModel;
import org.pasoa.storeclient.messages.ProvenanceQueryRequestDocument;
import org.pasoa.storeclient.messages.RecordRequestDocument;
import org.pasoa.storeclient.messages.XPathRequestDocument;
import org.pasoa.storeclient.messages.XQueryRequestDocument;
import org.pasoa.util.httpsoap.DefaultDocumentClient;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class MySQLLocalTestBed extends Testbed{
	
	@Override
	public String getURL() {
		// TODO Auto-generated method stub
		return null;
	}

	private MySQLStore backend;
    private Dispatcher            _dispatch;
    private StorageSystem         _store;
    private RecordPlugIn _record;
	private List<File> _temps;
	public MySQLLocalTestBed (MySQLStore store) throws Exception {
		backend = store;
		initalize();
	}
	
	public MySQLLocalTestBed() throws Exception
    {
//        String tmpPath = this.createTemporaryDirectory().getAbsolutePath();
//        intialize(tmpPath, false);
    	initalize();
    }
/*    
    public MySQLLocalTestbed (String path) throws Exception 
    {
        intialize(path, false);
    }
    
    
    public MySQLLocalTestbed (boolean disableVerifiedCommits) throws Exception
    {
        String tmpPath = this.createTemporaryDirectory().getAbsolutePath();
        intialize(tmpPath, disableVerifiedCommits);
        
    }
    
    public MySQLLocalTestbed (String path, boolean disableVerifiedCommits) throws Exception
    {
        intialize(path, disableVerifiedCommits);
    }
    */
    private void initalize() throws Exception
    {
        //_home = path;
        //_backend = new BerkeleyDBJEStorage2 (_home, disableVerifiedCommits);
    	if (backend != null) backend.reconnect();
    	else backend = new MySQLStore();
    	if (backend == null) {
    		backend = new MySQLStore();
    	}
        
        _record  = new RecordPlugIn ();
        ProvenanceQueryPlugin  query    = new ProvenanceQueryPlugin ();
        XQueryPlugIn           xquery   = new XQueryPlugIn ();
        PlugInRegistry         plugins  = new PlugInRegistry ();
        
        plugins.registerPlugIn ("record", _record);
        plugins.registerPlugIn ("pquery", query);
        plugins.registerPlugIn ("xquery", xquery);
        
        
        _store    = new GeneralStorageSystem (backend, "org.pasoa.preserv.xquery.laxquery.XQueryEngine");
        _dispatch = new Dispatcher (_store, plugins);
    }    

    public String getPathToStorageDirectory(){
  	  return "C:/Program Files/MySQL/MySQL Server 5.0/data/preserv";
    }
    

    public void setSynchronousRecording (boolean sync)
    {
        _record.setReceiveDipatchesSynchronously (sync);
    }
    
    public void enableBackendRecordTimeLogging (PrintWriter output)
    {
       // _backend.enableRecordTimeLog(output);
    }
    
    
    public InteractionRecord getLastInteractionRecord() {
    	try {
			return backend.getInteractionRecord(backend.getNumberOfInteractionRecords() - 1);
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
    }
    
    /**
     * Deletes temporary files and directories created using createTemporaryDirectory,
     * including the one containing the provenance store database.
     */
    public void cleanUp () {
        try {
            _dispatch.shutdown();
//            _store.shutdown();
//            backend.close();
        } catch (Exception cannotShutdown) {
            System.err.println("Cannot shutdown " + cannotShutdown.getMessage());
            Debug.err(cannotShutdown, "");
        }
    }
/*    
    /**
     * Creates a temporary directory.  Used by LocalTestbed to create a directory
     * in which to keep the provenance store database, but can also be used to
     * create directories for other data.
     *  /
    public File createTemporaryDirectory () throws IOException {
        File temp = File.createTempFile ("database", "");
        temp.delete ();
        temp.mkdir ();
        temp.deleteOnExit ();
        
        if (_temps == null) {
            _temps = new LinkedList ();
        }
        _temps.add (temp);
        
        return temp;
    }
  */  
    /**
     * Convenience method to return the whole provenance store contents as a p-structure DOM document.
     */
    public Document getStoreContents () throws Exception {
        return PStructureJavaModel.getPStructureDocument (_store.getRetrievalInterface ());
    }
    
    public Element provenanceQuery (String qdhXPath, String scopeXPath, Map namespaces) throws UnsupportedEncodingException, Exception {

        ProvenanceQueryDeserialiser    parser     = new ProvenanceQueryDeserialiser ();

        ProvenanceQueryRequestDocument request;

        Document                       response;

        

        request  = new ProvenanceQueryRequestDocument (qdhXPath, scopeXPath, namespaces);

        response = new DefaultDocumentClient ().invoke (_dispatch, "pquery", request);

        

        return response.getDocumentElement ();

        //return parser.deserialiseProvenanceQueryResults (response.getDocumentElement ());

    }



    public Element provenanceQuery (ProvenanceQueryRequest query) throws UnsupportedEncodingException, Exception {

        ProvenanceQueryDeserialiser    parser     = new ProvenanceQueryDeserialiser ();

        ProvenanceQueryRequestDocument request;

        Document                       response;

        

        request  = new ProvenanceQueryRequestDocument (query);

        response = new DefaultDocumentClient ().invoke (_dispatch, "pquery", request);

        

        return response.getDocumentElement ();

        //return parser.deserialiseProvenanceQueryResults (response.getDocumentElement ());

    }


    @Override
	public void record (Record record) throws UnsupportedEncodingException, Exception {
        RecordRequestDocument request = new RecordRequestDocument (record);
//System.out.println (DOMWriter.writeToString (request, true));
        new DefaultDocumentClient ().invoke (_dispatch, "record", request);
    }
        
    @Override
    public Element xpath (String xpath, String root, String item, Map namespaces) throws UnsupportedEncodingException, Exception {

        XPathRequestDocument request = new XPathRequestDocument (xpath, root, item, namespaces);

        

        return new DefaultDocumentClient ().invoke (_dispatch, "xquery", request).getDocumentElement ();

    }

    

    public Element xquery (String xquery) throws UnsupportedEncodingException, Exception {

        XQueryRequestDocument request = new XQueryRequestDocument (xquery);

        

        return new DefaultDocumentClient ().invoke (_dispatch, "xquery", request).getDocumentElement ();

    }
    
    public void close() throws Exception {
    	_dispatch.shutdown();
    	backend.close();
    }

    /**
     * Creates a temporary directory.  Used by LocalTestbed to create a directory
     * in which to keep the provenance store database, but can also be used to
     * create directories for other data.
     */
    public File createTemporaryDirectory () throws IOException {
        File temp = File.createTempFile ("database", "");
        temp.delete ();
        temp.mkdir ();
        temp.deleteOnExit ();
        
        if (_temps == null) {
            _temps = new LinkedList ();
        }
        _temps.add (temp);
        
        return temp;
    }
}
