package org.pasoa.preserv.storage.mysql.test;

import java.io.File;

import org.junit.*;

public class MySQLLocalTestBedFixture
{
 
  private MySQLLocalTestBed _localTestbed;

  @Before
  public void setUp() throws Exception
  {
      
       _localTestbed = new MySQLLocalTestBed();
  }
  
  @After
  public void tearDown() throws Exception
  {
//	  _localTestbed.close();
//	  _localTestbed.cleanUp();
      File f = new File(_localTestbed.getPathToStorageDirectory());
      _localTestbed.cleanUp();
      System.out.println("Size after completion " + this.getSize(f));
    
      
  }
  
  public MySQLLocalTestBed getLocalTestbed()
  {
      return _localTestbed;
  }
  
  /**
   * Get the size of a particular folder/directory by
   * recurisevly getting the size of each file in every subfolder
   * 
   * @param folder
   * @return the size of a file
   */
   public long getSize(File folder)
   {
      long folderSize = 0;
      if (folder.isDirectory()) 
      {
          File[] filelist = folder.listFiles();
          for (int i = 0; i < filelist.length; i++) {
              folderSize = folderSize + getSize(filelist[i]);
          }
      }
      else {
          folderSize = folder.length(); 
      }
     
      return folderSize;
   } 

}
