package org.pasoa.preserv.storage.mysql.test.scalability;

import junit.framework.TestCase;
import org.pasoa.preserv.record.CacheableItem;
import org.pasoa.preserv.storage.mysql.Debug;
import org.pasoa.preserv.storage.mysql.MySQLCache;
import org.pasoa.preserv.storage.mysql.MySQLConnector;
import org.pasoa.preserv.storage.mysql.MySQLStore;

public class MySQLCacheTiming extends TestCase {

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MySQLCacheTiming.class);
	}

	private MySQLConnector db;
	private MySQLStore cache;
	
	protected void setUp() throws Exception {
//		db1 = new MySQLConnector(Debug.dbURL, Debug.dbUser, Debug.dbPass);
//		db.connect();
		cache = new MySQLStore();
	}

	protected void tearDown() throws Exception {
		cache = null;
		db.disconnect();
		db = null;
	}

	public void testSize() throws Exception {
//		cache.startRecordTiming();
		long startTime = System.currentTimeMillis();
		for (int i = 0; i <= 10000; i++) {
//				if (i % 100 == 0) Debug.msg("\trecorded " + i);
			CacheableItem ci = new CacheableItem("some path", new StringBuffer("content of this hgfdfk;jashgfoadhgoeragrhjealgkdfhflshgkdfjhsgfdjhaslfdjs;alfjdlsakgfsda"));
			cache.cache(ci);
		}
		Debug.msg("Inserting Total\t" + (System.currentTimeMillis() - startTime));
		
		startTime = System.currentTimeMillis();
		while (cache.getCachedItem() != null);
		
		Debug.msg("Querying Total\t" + (System.currentTimeMillis() - startTime));
//		Debug.msg(cache.stopRecordTiming());
	}

}
