package org.pasoa.preserv.storage.mysql.test.scalability;

import java.io.File;
import java.io.PrintStream;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


import org.pasoa.common.Constants;
import org.pasoa.preserv.index.Index;
import org.pasoa.preserv.record.CacheableItem;
import org.pasoa.preserv.storage.BackendStore;
import org.pasoa.preserv.storage.je.BerkeleyDBJEStorage2;
import org.pasoa.preserv.storage.mysql.Debug;
import org.pasoa.preserv.storage.mysql.MySQLConnector;
import org.pasoa.preserv.storage.mysql.MySQLStore;
import org.pasoa.preserv.storage.mysql.test.ExtremeTest;
import org.pasoa.preserv.storage.mysql.test.MySQLLocalTestBed;
import org.pasoa.preserv.test.LocalTestbed;
import org.pasoa.preserv.test.Testbed;
import org.pasoa.pstructure.ActorStatePAssertion;
import org.pasoa.pstructure.GlobalPAssertionKey;
import org.pasoa.pstructure.InteractionKey;
import org.pasoa.pstructure.Record;
import org.pasoa.simpledom.DOMDeserialiser;
import org.pasoa.simpledom.DOMWriter;
import org.w3c.dom.Element;

public class MySQLRetrieveTime {

	String opt_datafile = "";
	int opt_iik = 0;
	int opt_ivk = 2;
	int opt_ias = 0;
	int opt_ilp = 0;
	int opt_it = 0;
	int opt_csn = -1;
	String opt_bHome = "";
	File opt_folder = new File("");
	boolean opt_mysqlInside = false;
	boolean opt_myisam = false;
	boolean opt_innodb = false;
	boolean opt_berkeleyTrue = false;
	boolean opt_berkeleyFalse = false;
	boolean opt_preservServlet = false;
	boolean opt_straightToStore = false;

	Map<String, List<Long>> retMap = new HashMap<String, List<Long>>();  
	Map<String, List<Long>> recStoreMap = new HashMap<String, List<Long>>();
	Map<String, List<Long>> recServlMap = new HashMap<String, List<Long>>();
	Map<String, List<Long>> recServlShutMap = new HashMap<String, List<Long>>();
	Map<String, List<Long>> cgMap = new HashMap<String, List<Long>>();
	Map<String, List<Long>> cpMap = new HashMap<String, List<Long>>();
	Map<String, List<Long>> miMap = new HashMap<String, List<Long>>();
	Map<String, List<Long>> indIRMap = new HashMap<String, List<Long>>();
	Map<String, List<Long>> indPAMap = new HashMap<String, List<Long>>();
	Map<String, List<Long>> indmVsMap = new HashMap<String, List<Long>>();
	Map<String, List<Long>> indmVMap = new HashMap<String, List<Long>>();
	Map<String, List<Long>> indVMap = new HashMap<String, List<Long>>();

	String[] lpaids;
	InteractionKey[] iks;
	Element[] asserters;
	String[] viewKinds;

	public static void main(String[] args) {
		new MySQLRetrieveTime(args);
	}

	private static void printMessage(){
		System.out.println("Usage (keys in any order): \n" +
				"--actorStatePAFile <file> \n" +
				"--numbeOfIKs <n> \n" +
				"--numbeOfASs <n> \n" +
				"--numbeOfLPs <n> \n" +
				"--numberOfIterations <it> \n" +
				"--berkeleyHomeDir <bHome> \n" +
				"--outputFolder <folder> \n" +
				"--mysqlInside \n" +
				"--cachePerIteration <csn>\n" +
				"--MyISAM \n" +
				"--InnoDB \n" +
				"--berkeleyTrue \n" +
				"--berkeleyFalse \n" +
				"--preservServlet \n" +
				"--straightToStore"
		);
		System.exit(1);
	}

	private long numberOfPAs(MySQLStore store) throws SQLException{
		MySQLConnector db = store.getDB();
		ResultSet rs = db.executeQuery("select count(*) from PAssertions");
		rs.next();
		return rs.getLong(1);
	}

	public static void deleteBerkeley(String home) {
		File _home = new File(home);
		if (_home.exists()) {
			File[] filesToDelete = _home.listFiles();
			for (int i = 0; i < filesToDelete.length; i++) {
				filesToDelete[i].delete();
			}
		}
	}


	public MySQLRetrieveTime(String[] args) {
		try {
			if (args.length == 0) printMessage();
			for (int i = 0; i < args.length; i++) {
				String option = args[i].intern();
				if (option == "--actorStatePAFile")
					opt_datafile = args[++i];
				else if (option == "--numbeOfIKs")
					opt_iik = Integer.parseInt(args[++i]);
				else if (option == "--numbeOfASs")
					opt_ias = Integer.parseInt(args[++i]);
				else if (option == "--numbeOfLPs")
					opt_ilp = Integer.parseInt(args[++i]);
				else if (option == "--numberOfIterations")
					opt_it = Integer.parseInt(args[++i]);
				else if (option == "--berkeleyHomeDir")
					opt_bHome = args[++i];
				else if (option == "--outputFolder")
					opt_folder = new File(args[++i]);
				else if (option == "--mysqlInside")
					opt_mysqlInside = true;
				else if (option == "--cachePerIteration")
					opt_csn = Integer.parseInt(args[++i]);
				else if (option == "--MyISAM")
					opt_myisam = true;
				else if (option == "--InnoDB")
					opt_innodb = true;
				else if (option == "--berkeleyTrue")
					opt_berkeleyTrue = true;
				else if (option == "--berkeleyFalse")
					opt_berkeleyFalse = true;
				else if (option == "--preservServlet")
					opt_preservServlet = true;
				else if (option == "--straightToStore")
					opt_straightToStore = true;
				else
					printMessage();
			}

//			System.out.println("File: " + datafile + " nr: " + n + " it: " + it + " bHome: " + bHome + " output: " + folder.getAbsolutePath() + " mysqlInside: " + mysqlInside + " berkeleyInvolved: " + berkeleyInvolved);
			String msg = 
				"--actorStatePAFile " + opt_datafile + "\n" +
				"--numbeOfIKs " + opt_iik + " \n" +
				"--numbeOfVKs " + opt_ivk + " \n" +
				"--numbeOfASs " + opt_ias + " \n" +
				"--numbeOfLPs " + opt_ilp + " \n" +
				"--numberOfIterations " + opt_it + " \n" +
				"--berkeleyHomeDir " + opt_bHome + " \n" +
				"--outputFolder " + opt_folder + " \n" +
				"--mysqlInside " + opt_mysqlInside + "\n" +
				"--cachePerIteration " + opt_csn + "\n" +
				"--MyISAM " + opt_myisam + "\n" +
				"--InnoDB " + opt_innodb + "\n" +
				"--berkeleyTrue " + opt_berkeleyTrue + "\n" +
				"--berkeleyFalse " + opt_berkeleyFalse + "\n" +
				"--preservServlet " + opt_preservServlet + " \n" +
				"--straightToStore " + opt_straightToStore + "\n" + 
				"Total PAssertions per Iteration: " + (opt_iik * opt_ivk * opt_ias * opt_ilp) + "\n" +
				"Total PAssertions: " + (opt_iik * opt_ivk * opt_ias * opt_ilp * opt_it);
			System.out.println(msg);

			opt_folder.mkdirs();
			PrintStream meta = new PrintStream(new File(opt_folder, "meta.txt"));
			meta.println(msg);
			meta.close();
//			PrintStream out = new PrintStream(new File(opt_folder, "outerr.txt"));
//			System.setErr(out);
//			System.setOut(out);
			PrintStream retOut = new PrintStream(new File(opt_folder, "retrieve.txt"));
			PrintStream recStoreOut = new PrintStream(new File(opt_folder, "recordStore.txt"));
			PrintStream recServlOut = new PrintStream(new File(opt_folder, "recordServl.txt"));
			PrintStream recServlShutOut = new PrintStream(new File(opt_folder, "recordServlShut.txt"));
			PrintStream cgOut = new PrintStream(new File(opt_folder, "cacheGet.txt"));
			PrintStream cpOut = new PrintStream(new File(opt_folder, "cachePut.txt"));
			PrintStream miOut = new PrintStream(new File(opt_folder, "mysqlInside.txt"));
			PrintStream indIROut = new PrintStream(new File(opt_folder, "indexIR.txt"));
			PrintStream indPAOut = new PrintStream(new File(opt_folder, "indexPA.txt"));
			PrintStream indmVsOut = new PrintStream(new File(opt_folder, "indexMySQLFVs.txt"));
			PrintStream indmVOut = new PrintStream(new File(opt_folder, "indexMySQLFV.txt"));
			PrintStream indVOut = new PrintStream(new File(opt_folder, "indexFV.txt"));

			MySQLStore store = new MySQLStore();
			ExtremeTest et = new ExtremeTest(store);
			Element assertion = et.readElementFromFile(opt_datafile);
			DOMDeserialiser des = new DOMDeserialiser(Constants.PSTRUCT_NS);
//			PStructureDeserialiser pdes = new PStructureDeserialiser();
//			ActorStatePAssertion apa = pdes.deserialiseActorStatePAssertion(assertion);
			ActorStatePAssertion apa = new ActorStatePAssertion(des.text(assertion, "localPAssertionId"), des.single(assertion, "content"));

			// CreateArrays

			asserters = new Element[opt_ias];
			iks = new InteractionKey[opt_iik];
			viewKinds = new String[] {Constants.SENDER_VIEW_TYPE, Constants.RECEIVER_VIEW_TYPE};
			lpaids = new String[opt_ilp];

			for (int i = 0; i < opt_iik; i++) {
				iks[i] = et.composeInteractionKey(
						"sender" + Math.random() + i, 
						"receiver" + Math.random() + i, 
						"intID" + Math.random() + i);
			}

			for (int i = 0; i < opt_ias; i++) {
				asserters[i] = et.composeAsserter("asserter" + Math.random() + i);
			}

			String lpRoot = "localPAID" + Math.random();
			for (int i = 0; i < opt_ilp; i++) {
				lpaids[i] = lpRoot + i;
			}

			String engine;
//			testBed.setSynchronousRecording(true);
			if (opt_straightToStore) {
				if (opt_innodb) {
					try {
						engine = "innodb ";
						store.delete("engine=" + engine);

						System.out.println("test1");

//						testMySQLStore(store, testBed, assertion, apa, engine);

						testMySQLStore(store, assertion, Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME, engine);

						Debug.msg("Total in store: " + numberOfPAs(store));
//						System.exit(0);
					} catch (Exception ex) {
						Debug.errNoExit(ex, "test1");
					}
				}
				if (opt_myisam) {
					try {
						engine = "myisam ";
						store.delete("engine=" + engine);
						System.out.println("test2");
//						testMySQLStore(store, testBed, assertion, apa, engine);
						testMySQLStore(store, assertion, Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME, engine);
//						testBed.cleanUp();
						Debug.msg("Total in store: " + numberOfPAs(store));
					} catch (Exception ex) {
						Debug.errNoExit(ex, "test2");
					}
				}

				deleteBerkeley(opt_bHome);

				if (opt_berkeleyTrue) {
					try {
						engine = "Berkeley to OS buffers";
						System.out.println("test3");
						BerkeleyDBJEStorage2 store2 = new BerkeleyDBJEStorage2(opt_bHome, true);

//						store2.delete();

//						LocalTestbed tb = new LocalTestbed(opt_bHome, true);
//						tb.setSynchronousRecording(true);
						testBerkeley(store2, assertion, Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME, engine);
						store2.shutdown();
						deleteBerkeley(opt_bHome);
//						Debug.msg("Total in store: " + store2.getNumberOfInteractionRecords());
//						testBerkeley(store2, assertion, apa, engine);

//						tb.cleanUp();
//						store2.delete();
					} catch (Exception ex) {
						Debug.errNoExit(ex, "test3");
					}
				}

				if (opt_berkeleyFalse) {
					try {
						System.out.println("test4");
						BerkeleyDBJEStorage2 store2 = new BerkeleyDBJEStorage2(opt_bHome, false);
//						store2.delete();
						engine = "Berkeley to disk"; 

//						LocalTestbed tb = new LocalTestbed(opt_bHome, false);
//						tb.setSynchronousRecording(true);
						testBerkeley(store2, assertion, Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME, engine);
						store2.shutdown();
						deleteBerkeley(opt_bHome);
//						Debug.msg("Total in store: " + store2.getNumberOfInteractionRecords());
//						testBerkeley(store2, assertion, apa, engine);

//						tb.cleanUp();
//						store2.delete();
					} catch (Exception ex) {
						Debug.errNoExit(ex, "test4");
					}
				}
			}

			store.printTimeMap(recStoreOut, recStoreMap);
			store.printTimeMap(retOut, retMap);
			store.printTimeMap(cgOut, cgMap);
			store.printTimeMap(cpOut, cpMap);
			store.printTimeMap(miOut, miMap);

			store.printTimeMap(indIROut, indIRMap);
			store.printTimeMap(indPAOut, indPAMap);
			store.printTimeMap(indmVsOut, indmVsMap);
			store.printTimeMap(indmVOut, indmVMap);
			store.printTimeMap(indVOut, indVMap);

			retOut.close();
			recStoreOut.close();
			cgOut.close();
			cpOut.close();
			miOut.close();
			indIROut.close();
			indPAOut.close();
			indmVsOut.close();
			indmVOut.close();
			indVOut.close();

			if (opt_preservServlet) {
				System.out.println("test5");
				if (opt_innodb) {
					try {
						engine = "innodb ";
						store.delete("engine=" + engine);
//						MySQLLocalTestBed testbed = new MySQLLocalTestBed();
						testServletRecordMySQL(apa, engine);
//						testbed.close();
					} catch (Exception ex) {
						Debug.errNoExit(ex, "test5");
					}
				}
				System.out.println("test6");
				if (opt_myisam) {
					try {
						engine = "myisam ";
						store.delete("engine=" + engine);
//						MySQLLocalTestBed testbed = new MySQLLocalTestBed();
						testServletRecordMySQL(apa, engine);
//						testbed.close();
					} catch (Exception ex) {
						Debug.errNoExit(ex, "test6");
					}
				}
				System.out.println("test7");
				deleteBerkeley(opt_bHome);
				if (opt_berkeleyTrue) {
					try {
//						LocalTestbed tb = new LocalTestbed(opt_bHome, true);
						engine = "Berkeley to OS buffers";
						testServletRecordBerkeley(true, apa, engine);
						deleteBerkeley(opt_bHome);
//						tb.cleanUp();
					} catch (Exception ex) {
						Debug.errNoExit(ex, "test7");
					}
				}
				System.out.println("test8");
				if (opt_berkeleyFalse) {
					try {
//						LocalTestbed tb = new LocalTestbed(opt_bHome, false);
						engine = "Berkeley to disk";
						testServletRecordBerkeley(false, apa, engine);
						deleteBerkeley(opt_bHome);
//						tb.cleanUp();
					} catch (Exception ex) {
						Debug.errNoExit(ex, "test8");
					}
				}
			}

			store.printTimeMap(recServlOut, recServlMap);
			store.printTimeMap(recServlShutOut, recServlShutMap);
			recServlOut.close();
			recServlShutOut.close();
//			out.close();
		} catch (Exception ex) {
			Debug.err(ex, "");
		}
	}

	public void testMySQLStore(
			MySQLStore store, 
//			MySQLLocalTestBed testBed,
			Element assertion, 
			String passertionType,
//			ActorStatePAssertion apa,
			String pref
	) throws Exception {

		List<Long> recStoreList = new ArrayList<Long>();
//		List<Long> recServlList = new ArrayList<Long>();
		List<Long> retList = new ArrayList<Long>();
		List<Long> cgList = new ArrayList<Long>();
		List<Long> cpList = new ArrayList<Long>();

		List<Long> indIRList = new ArrayList<Long>();
		List<Long> indPAList = new ArrayList<Long>();
		List<Long> indmVsList = new ArrayList<Long>();
		List<Long> indmVList = new ArrayList<Long>();

//		List<Long> indList = new ArrayList<Long>();
		recStoreMap.put(pref + "", recStoreList);
//		recServlMap.put(pref + "", recServlList);
		retMap.put(pref + "", retList);
		cpMap.put(pref + "", cpList);
		cgMap.put(pref + "", cgList);

		indIRMap.put(pref, indIRList);
		indPAMap.put(pref, indPAList);
		indmVsMap.put(pref, indmVsList);
		indmVMap.put(pref, indmVList);

//		Debug.err("before the loop");
		/*
		for (int i = 0; i < opt_it; i++) {
			String lpU = "" + i;
//			Debug.err("start of the loop");
			if (opt_mysqlInside) store.startTiming();
//			Debug.err("straight record");
			recStoreList.add(i, measureTimeRecordIRs(store, assertion, lpU, passertionType));
//			Debug.err("servlet record");
//			if (opt_preservServlet) recServlList.add(i, measureTimeRecordIRs(testBed, apa, "servlet" + i));
//			Debug.err("retr IRs");
			retList.add(i, measureTimeRetrieveIRs(opt_iik, store));
//			Debug.err("index IRs");
			indIRList.add(measureTimeIndexFIR(store, lpU));
			indPAList.add(measureTimeIndexFPA(store, lpU));
			indmVsList.add(measureTimeIndexMySQLFVs(store, lpU));
			indmVList.add(measureTimeIndexMySQLFV(store, lpU));
			if (opt_mysqlInside) store.stopRecordTiming(miMap, pref);
		}
*/
		testCache(cpList, cgList, opt_it, opt_csn, store, assertion);

	}


	public void testCache(List<Long> cpList, List<Long> cgList, int it, int n, BackendStore store, Element assertion) throws Exception{
		synchronized (store) {
			for (int i = 0; i < it; i++) {
				cpList.add(i, measureCacheTimePut(n, store, DOMWriter.writeToString(assertion)));
			}
			Long l0 = new Long(0L); 
			for (int i = 0; i < it; i++) {
				cgList.add(i, l0);
			}
			for (int i = it - 1; i >= 0; i--) {
				cgList.add(i, measureCacheTimeGet(n, store));
			}
		}
	}

	public void testServletRecordMySQL(
			ActorStatePAssertion apa,
			String pref
	) throws Exception{
		List<Long> recServlList = new ArrayList<Long>();
		List<Long> recServlShutList = new ArrayList<Long>();
		recServlMap.put(pref + "", recServlList);
		recServlShutMap.put(pref + "", recServlShutList);
		MySQLLocalTestBed testbed;
		for (int i = 0; i < opt_it; i++) {
			testbed = new MySQLLocalTestBed();
			long start = System.currentTimeMillis();
			recServlList.add(i, measureTimeRecordIRs(testbed, apa, "servlet" + i));
			testbed.cleanUp();
			recServlShutList.add(System.currentTimeMillis() - start);
		}
	}

	public void testServletRecordBerkeley(
			boolean sync,
			ActorStatePAssertion apa,
			String pref
	) throws Exception{
		List<Long> recServlList = new ArrayList<Long>();
		List<Long> recServlShutList = new ArrayList<Long>();
		recServlMap.put(pref + "", recServlList);
		recServlShutMap.put(pref + "", recServlShutList);
		LocalTestbed testbed;
		for (int i = 0; i < opt_it; i++) {
			testbed = new LocalTestbed(opt_bHome, sync);
			long start = System.currentTimeMillis();
			recServlList.add(i, measureTimeRecordIRs(testbed, apa, "servlet" + i));
			testbed.cleanUp();
			recServlShutList.add(System.currentTimeMillis() - start);
		}
	}

	public void testBerkeley(
			BerkeleyDBJEStorage2 store, 
//			LocalTestbed testBed,
			Element assertion, 
			String passertionType,
//			ActorStatePAssertion apa,
			String pref
	) throws Exception {
		List<Long> recStoreList = new ArrayList<Long>();
//		List<Long> recServlList = new ArrayList<Long>();
		List<Long> retList = new ArrayList<Long>();
		List<Long> cgList = new ArrayList<Long>();
		List<Long> cpList = new ArrayList<Long>();

		recStoreMap.put(pref + "", recStoreList);
		retMap.put(pref + "", retList);
		cpMap.put(pref + "", cpList);
		cgMap.put(pref + "", cgList);
/*
		for (int i = 0; i < opt_it; i++) {
			String lpU = "" + i;
			recStoreList.add(i, measureTimeRecordIRs(store, assertion, lpU, passertionType));
			retList.add(i, measureTimeRetrieveIRs(opt_iik, store));
		}
*/
		testCache(cpList, cgList, opt_it, opt_csn, store, assertion);

	}

	public  long measureCacheTimePut(int n, BackendStore store, String contents) throws Exception {
		long startTime = System.currentTimeMillis();
		for (int i = 0; i < n; i++) {
			CacheableItem ci = new CacheableItem("some path", new StringBuffer(contents));
			store.cache(ci);
		}
		return System.currentTimeMillis() - startTime;
	}

	public  long measureCacheTimeGet(int n, BackendStore store) throws Exception { 
		long startTime = System.currentTimeMillis();
		for (int i = 0; i < n; i++)
			System.out.println(store.getCachedItem());

		return System.currentTimeMillis() - startTime;
	}

	/*
	public  long measureTimeRecordIRs(int n, BackendStore store, ExtremeTest et, Element assertion) throws Exception {
		Element asserter = et.composeAsserter("asserter");
		InteractionKey ik = et.composeInteractionKey("sender" + Math.random(), "receiver" + Math.random(), "intID");
		String lpaid = "locaPAID" + Math.random();
		long start = System.currentTimeMillis();
		for (int i = 0; i < n; i++) {
			store.record(new GlobalPAssertionKey(
					new InteractionKey(
							ik.getMessageSource(), 
							ik.getMessageSource(), 
							ik.getInteractionID() + i
					),
					Constants.SENDER_VIEW_TYPE,
					lpaid + i
			), asserter, assertion, Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME);
		}
		return System.currentTimeMillis() - start;
	}*/
	public long measureTimeRecordIRs(BackendStore store, Element assertion, String lpU, String passertionType) throws Exception {
		long start = System.currentTimeMillis();
		for (int iik = 0; iik < iks.length; iik++) {
			for (int ivk = 0; ivk < viewKinds.length; ivk++) {
				for (int ias = 0; ias < asserters.length; ias++) {
					for (int ilp = 0; ilp < lpaids.length; ilp++) {
						store.record(new GlobalPAssertionKey(
								new InteractionKey(iks[iik].getMessageSource(), 
										iks[iik].getMessageSink(), iks[iik].getInteractionID() + lpU),
//										iks[iik],
										viewKinds[ivk],
										lpaids[ilp] + lpU
						), asserters[ias], assertion, passertionType);
					}
				}
			}
		}
		return System.currentTimeMillis() - start;
	}

	public long measureTimeRecordIRs(Testbed testBed, ActorStatePAssertion apa, String lpU) throws Exception {
		long start = System.currentTimeMillis();
		for (int iik = 0; iik < iks.length; iik++) {
			for (int ivk = 0; ivk < viewKinds.length; ivk++) {
				for (int ias = 0; ias < asserters.length; ias++) {
					for (int i = 0; i < opt_ilp; i++) {
						testBed.record(
								new Record(
										new ActorStatePAssertion(lpaids[i] + lpU, apa.getContent()),
										new InteractionKey(iks[iik].getMessageSource(), 
												iks[iik].getMessageSink(), iks[iik].getInteractionID() + lpU),
//												iks[iik], 
												viewKinds[ivk], 
												asserters[ias]));
					}
				}
			}
		}
		return System.currentTimeMillis() - start;
	}


	public long measureTimeRetrieveIRs(int n, BackendStore store) throws Exception {
		long start = System.currentTimeMillis();
		ExtremeTest.lastInsertedNoSave(store, n);
		return System.currentTimeMillis() - start;
	}

	public long measureTimeIndexFIR(Index store, String lpU) throws Exception {
		long start = System.currentTimeMillis();
		for (int iik = 0; iik < iks.length; iik++) {
//			store.findInteractionRecord(iks[iik]);
			store.findInteractionRecord(new InteractionKey(iks[iik].getMessageSource(), 
					iks[iik].getMessageSink(), iks[iik].getInteractionID() + lpU));
		}
		return System.currentTimeMillis() - start;
	}

	public  long measureTimeIndexFPA(Index store, String lpU) throws Exception {
		long start = System.currentTimeMillis();
		for (int iik = 0; iik < iks.length; iik++) {
			for (int ivk = 0; ivk < viewKinds.length; ivk++) {
				for (int ilp = 0; ilp < lpaids.length; ilp++) {
					store.findPAssertion(
							new GlobalPAssertionKey (
									new InteractionKey(iks[iik].getMessageSource(), 
											iks[iik].getMessageSink(), iks[iik].getInteractionID() + lpU),
//											iks[iik],
											viewKinds[ivk],
											lpaids[ilp] + lpU
							)
					);
				}
			}
		}
		return System.currentTimeMillis() - start;
	}

	public  long measureTimeIndexMySQLFVs(MySQLStore store, String lpU) throws Exception {
		long start = System.currentTimeMillis();
		for (int iik = 0; iik < iks.length; iik++) {
			for (int ivk = 0; ivk < viewKinds.length; ivk++) {
				store.findViews(
						new InteractionKey(iks[iik].getMessageSource(), 
								iks[iik].getMessageSink(), iks[iik].getInteractionID() + lpU),
//								iks[iik], 
								viewKinds[ivk]);
			}
		}
		return System.currentTimeMillis() - start;
	}

	public  long measureTimeIndexMySQLFV(MySQLStore store, String lpU) throws Exception {
		long start = System.currentTimeMillis();
		for (int iik = 0; iik < iks.length; iik++) {
			for (int ivk = 0; ivk < viewKinds.length; ivk++) {
				for (int ias = 0; ias < asserters.length; ias++) {
					store.findView(
							new InteractionKey(iks[iik].getMessageSource(), 
									iks[iik].getMessageSink(), iks[iik].getInteractionID() + lpU),
//									iks[iik], 
									viewKinds[ivk], asserters[ias]);
				}
			}
		}
		return System.currentTimeMillis() - start;
	}

	public  long measureTimeIndexFV(Index store, String lpU) throws Exception {
		long start = System.currentTimeMillis();
		for (int iik = 0; iik < iks.length; iik++) {
			for (int ivk = 0; ivk < viewKinds.length; ivk++) {
				store.findView(
						new InteractionKey(iks[iik].getMessageSource(), 
								iks[iik].getMessageSink(), iks[iik].getInteractionID() + lpU),
//								iks[iik], 
								viewKinds[ivk]);
			}
		}
		return System.currentTimeMillis() - start;
	}


}
