package org.pasoa.preserv.storage.mysql.test.scalability;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.pasoa.common.Constants;
import org.pasoa.preserv.index.DefaultIndex;
import org.pasoa.preserv.index.Index;
import org.pasoa.preserv.storage.BackendStore;
import org.pasoa.preserv.storage.je.BerkeleyDBJEStorage2;
import org.pasoa.preserv.storage.mysql.Debug;
import org.pasoa.preserv.index.MyIndex;
import org.pasoa.preserv.storage.mysql.MySQLRetrieval;
import org.pasoa.preserv.storage.mysql.MySQLStore;
import org.pasoa.preserv.storage.mysql.test.ExtremeTest;
import org.pasoa.preserv.storage.mysql.test.MySQLLocalTestBed;
import org.pasoa.preserv.test.LocalTestbed;
import org.pasoa.preserv.test.Testbed;
import org.pasoa.pstructure.ExposedInteractionMetadata;
import org.pasoa.pstructure.GlobalPAssertionKey;
import org.pasoa.pstructure.InteractionKey;
import org.pasoa.pstructure.InteractionRecord;
import org.pasoa.pstructure.PAssertion;
import org.pasoa.pstructure.RelationshipPAssertion;
import org.pasoa.pstructure.View;
import org.pasoa.simpledom.DOMWriter;
import org.w3c.dom.Element;

public class RecordModel {

	List<Map<String, List<Long>>> _data;
	PrintStream[] _outs;
	private int tests = 18;
	File _parent;
	int _it;
//	String _bHome;

	public static void main(String[] args) {
		try {
			//new RecordModel(5, 30, new File("e:/outPreserv/20060906/test1"), "c:/brkl/1", "c:/brkl/2", new boolean[] {false, false, false, false, true, true, true, true});
			new RecordModel(5, 3, new File("e:/outPreserv/20060918/dummy"), "c:/brkl/1", "c:/brkl/2", new boolean[] {true, true, true, true, true, true, true, true});
//			Thread.sleep(7000);
//			new RecordModel(10, 50, new File("e:/outPreserv/20060906/test2-10-50"), "c:/brkl/1", "c:/brkl/2", new boolean[] {true, true, true, true, true, true, true, true});
			/*
			new RecordModel(5, 50, new File("e:/outPreserv/20060905/test3-5-50"), "c:/brkl/1", "c:/brkl/2", new boolean[] {true, true, true, true, true, true, false, false});
			Thread.sleep(7000);
			new RecordModel(5, 100, new File("e:/outPreserv/20060905/test3-5-100"), "c:/brkl/1", "c:/brkl/2", new boolean[] {true, true, true, true, true, true, false, false});
			Thread.sleep(7000);
			new RecordModel(10, 100, new File("e:/outPreserv/20060905/test3-10-100"), "c:/brkl/1", "c:/brkl/2", new boolean[] {true, true, true, true, true, true, false, false});
			*/
		}catch (Exception ex) {
			Debug.errNoExit(ex, "main");
		}
	}

	private boolean testClear(BackendStore store) throws Exception {
		return store.getNumberOfInteractionRecords() == 0;
	}

	private RecordModel(
			int maxSize, 
			int it, 
			File parent, 
			String bHome1, 
			String bHome2, 
			boolean[] run
	) throws Exception{

//		this._bHome = bHome;
		this._it = it;
//		this.tests = tests;
		this._parent = parent;
		parent.mkdirs();
		PrintStream output = new PrintStream(new File(_parent, "output.txt"));
		System.setErr(output);
		System.setOut(output);
		initMaps();
		ExtremeTest et = new ExtremeTest(null);
		et.setMaxSize(maxSize);
		et.setRandomSize(false);
//		List<Long> ipaT = new ArrayList<Long>();
//		List<Long> apaT = new ArrayList<Long>();
//		List<Long> rpaT = new ArrayList<Long>();
//		List<Long> eimT = new ArrayList<Long>();
//		List<Long> sfT = new ArrayList<Long>();

		PrintStream outMeta = new PrintStream(new File(_parent, "meta.txt"));
		int nt = 0;
		InteractionRecord ir = createIR(et);
		outMeta.println("_it: " + _it);
		outMeta.println("maxSize: " + maxSize);
		outMeta.println("SenderView");
		View view = ir.getSenderView();
		outMeta.println("SF: " + view.getNumberOfExpectedPAssertions());
		outMeta.println("APAs: " + view.getActorStatePAssertions().size());
		outMeta.println("IPAs: " + view.getInteractionPAssertions().size());
		outMeta.println("RPAs: " + view.getRelationshipPAssertions().size());
		outMeta.println("EIMs: " + view.getExposedInteractionMetadata().size());
		outMeta.println("ReceiverView");
		view = ir.getReceiverView();
		outMeta.println("SF: " + view.getNumberOfExpectedPAssertions());
		outMeta.println("APAs: " + view.getActorStatePAssertions().size());
		outMeta.println("IPAs: " + view.getInteractionPAssertions().size());
		outMeta.println("RPAs: " + view.getRelationshipPAssertions().size());
		long count = 0L;
		for (RelationshipPAssertion rpa: (List<RelationshipPAssertion>)view.getRelationshipPAssertions()) {
			count += rpa.getObjectIDs().size(); 
		}
		outMeta.println("RPA Children: " + count);
		outMeta.println("EIMs: " + view.getExposedInteractionMetadata().size());
		count = 0L;
		for (ExposedInteractionMetadata eim: (List<ExposedInteractionMetadata>)view.getExposedInteractionMetadata()) {
			count += eim.getInteractionMetadata().size(); 
		}
		outMeta.println("EIM Children: " + count);
		outMeta.close();

		MySQLStore store1 = new MySQLStore("preserv1");
		MySQLStore store2 = new MySQLStore("preserv2");

		MySQLRetrieveTime.deleteBerkeley(bHome1);
		MySQLRetrieveTime.deleteBerkeley(bHome2);

		BerkeleyDBJEStorage2 store3 = new BerkeleyDBJEStorage2(bHome1, true);
		BerkeleyDBJEStorage2 store4 = new BerkeleyDBJEStorage2(bHome2, false);
		
		DefaultIndex index3 = new DefaultIndex(store3);
		DefaultIndex index4 = new DefaultIndex(store4);

		store1.delete("engine=innodb");
		store2.delete("engine=myisam");

		if (	testClear(store1) && 
				testClear(store2) &&
				testClear(store3) &&
				testClear(store4)
		) {
			for (int round = 0; round < _it; round++) {
				System.out.println("Round: " + round);
				nt = 0;
				ir = createIR(et);
				if (run[nt]) {
					String pref = "InnoDB";
					System.out.println("test" + nt);
					try {
						recordIR(store1, pref, ir);
						retrieveIR(store1, pref);
						testIndex(store1, pref, ir);
					} catch(Exception ex) {
						Debug.errNoExit(ex, "test" + nt);
					}
				}
				nt++;
				if (run[nt]) {
					String pref = "MyISAM";
					System.out.println("test" + nt);
					try {
						recordIR(store2, pref, ir);
						retrieveIR(store2, pref);
						testIndex(store2, pref, ir);
					} catch(Exception ex) {
						Debug.errNoExit(ex, "test" + nt);
					}
				}

				nt++;
				if (run[nt]) {
					String pref = "Berkeley to OS buffers";
					System.out.println("test" + nt);
					try {
						recordIR(store3, pref, ir);
						retrieveIR(store3, pref);
//						testIndex(store3, pref, ir);
						testIndex(index3, pref, ir);
					} catch(Exception ex) {
						Debug.errNoExit(ex, "test" + nt);
					}
				}

				nt++;
				if (run[nt]) {
					String pref = "Berkeley to disk";
					System.out.println("test" + nt);
					try {
						recordIR(store4, pref, ir);
						retrieveIR(store4, pref);
//						testIndex(store4, pref, ir);
						testIndex(index4, pref, ir);
					} catch(Exception ex) {
						Debug.errNoExit(ex, "test" + nt);
					}
				}
			} // end for
		} else { // end if clear
			Debug.err("Store not clear");
		}

		store3.shutdown();
		store4.shutdown();

		MySQLRetrieveTime.deleteBerkeley(bHome1);
		MySQLRetrieveTime.deleteBerkeley(bHome2);

		store3 = new BerkeleyDBJEStorage2(bHome1, true);
		store4 = new BerkeleyDBJEStorage2(bHome2, false);

		store1.delete("engine=innodb");
		store2.delete("engine=myisam");

		MySQLLocalTestBed testbed1 = new MySQLLocalTestBed(store1);
		MySQLLocalTestBed testbed2 = new MySQLLocalTestBed(store2);
		LocalTestbed testbed3 = new LocalTestbed(bHome1, true);
		LocalTestbed testbed4 = new LocalTestbed(bHome2, false);

		int ntf = ++nt;
		if (	testClear(store1) && 
				testClear(store2) &&
				testClear(store3) &&
				testClear(store4)
		) {
			for (int round = 0; round < _it; round++) {
				System.out.println("Round: " + round);
				nt = ntf;
				ir = createIR(et);
				if (run[nt]) {
					System.out.println("test" + nt);
					String pref = "InnoDB";
					try {
						recordIR(testbed1, pref, ir);
						retrieveIR(testbed1, pref);
					} catch(Exception ex) {
						Debug.errNoExit(ex, "test" + nt);
					}
				}

				nt++;
				if (run[nt]) {
					System.out.println("test" + nt);
					String pref = "MyISAM";
					try {
						recordIR(testbed2, pref, ir);
//						testbed2.cleanUp();
						retrieveIR(testbed2, pref);
					} catch(Exception ex) {
						Debug.errNoExit(ex, "test" + nt);
					}
				}

				nt++;
				if (run[nt]) {
					System.out.println("test" + nt);
					String pref = "Berkeley to OS buffers";
					try {
						recordIR(testbed3, pref, ir);
//						testbed3.cleanUp();
						retrieveIR(testbed3, pref);
					} catch(Exception ex) {
						Debug.errNoExit(ex, "test" + nt);
					}
				}

				nt++;
				if (run[nt]) {
					System.out.println("test" + nt);
					String pref = "Berkeley to disk";
					try {
						recordIR(testbed4, pref, ir);
//						testbed4.cleanUp();
						retrieveIR(testbed4, pref);
					} catch(Exception ex) {
						Debug.errNoExit(ex, "test" + nt);
					}
				}
			} // end for
		} else { // end if clear
			Debug.err("Store not clear");
		}
		testbed1.cleanUp();
		testbed2.cleanUp();
		testbed3.cleanUp();
		testbed4.cleanUp();

		store3.shutdown();
		store4.shutdown();

		MySQLRetrieveTime.deleteBerkeley(bHome1);
		MySQLRetrieveTime.deleteBerkeley(bHome2);

		store1.delete("engine=innodb");
		store2.delete("engine=myisam");

		store1.shutdown();
		store2.shutdown();

		write();
	}


	private InteractionRecord createIR(ExtremeTest et) throws Exception {
		Element sender = MySQLRetrieval.string2Element("<ps:asserter xmlns:ps=\"" + Constants.PSTRUCT_NS + "\"> <sender>sender " + Math.random() + "</sender></ps:asserter>");
		Element receiver = MySQLRetrieval.string2Element("<ps:asserter xmlns:ps=\"" + Constants.PSTRUCT_NS + "\"> <receiver>receiver " + Math.random() + "</receiver></ps:asserter>");
		return et.composeInteractionRecord(sender, receiver, null, null, null, null);
	}

	private void testIndex(
			Index store,
			String pref,
			InteractionRecord ir
	) throws Exception {
		List<Long> findPAapa;
		List<Long> findPAipa;
		List<Long> findPArpa;
		List<Long> findIR;
		List<Long> findV;
		List<Long> findVs;
		if (!_data.get(11).containsKey(pref)) {
			findPAapa = new ArrayList<Long>();
			findPAipa = new ArrayList<Long>();
			findPArpa = new ArrayList<Long>();
			findIR = new ArrayList<Long>();
			findV = new ArrayList<Long>();
			findVs = new ArrayList<Long>();
			_data.get(11).put(pref, findPAapa);
			_data.get(12).put(pref, findPAipa);
			_data.get(13).put(pref, findPArpa);
			_data.get(14).put(pref, findIR);
			_data.get(15).put(pref, findV);
			_data.get(16).put(pref, findVs);
		} else {
			findPAapa = _data.get(11).get(pref);
			findPAipa = _data.get(12).get(pref);
			findPArpa = _data.get(13).get(pref);
			findIR = _data.get(14).get(pref);
			findV = _data.get(15).get(pref);
			findVs = _data.get(16).get(pref);
		}
		measureTimeIndexFPA(
				store, 
				ir.getSenderView(), 
				Constants.SENDER_VIEW_TYPE, 
				ir.getInteractionKey(), 
				findPAapa, 
				findPAipa, 
				findPArpa
		);
		measureTimeIndexFPA(
				store, 
				ir.getReceiverView(), 
				Constants.RECEIVER_VIEW_TYPE, 
				ir.getInteractionKey(), 
				findPAapa, 
				findPAipa, 
				findPArpa
		);

		findIR.add(measureTimeIndexFIR(store, ir.getInteractionKey()));
		
		if (store instanceof MyIndex) {
			MyIndex new_store = (MyIndex) store;
			findV.add(measureTimeIndexMySQLFV(new_store, ir.getInteractionKey(), Constants.SENDER_VIEW_TYPE, ir.getSenderView().getAsserter()));
			findV.add(measureTimeIndexMySQLFV(new_store, ir.getInteractionKey(), Constants.RECEIVER_VIEW_TYPE, ir.getReceiverView().getAsserter()));

			findVs.add(measureTimeIndexMySQLFVs(new_store, ir.getInteractionKey(), Constants.SENDER_VIEW_TYPE));
			findVs.add(measureTimeIndexMySQLFVs(new_store, ir.getInteractionKey(), Constants.RECEIVER_VIEW_TYPE));
		}
	}

	private long measureTimeIndexFIR(
			Index store, 
			InteractionKey ik
	) throws Exception {

		long start = System.currentTimeMillis();
		store.findInteractionRecord(ik);
		return System.currentTimeMillis() - start;
	}

	private void measureTimeIndexFPA(
			Index store,
			View view,
			String viewkind,
			InteractionKey ik,
			List<Long> findPAapa,
			List<Long> findPAipa,
			List<Long> findPArpa
	) throws Exception {
		findPAapa.add(measureTimeIndexFPA(store, view.getActorStatePAssertions(), viewkind, ik));
		findPAipa.add(measureTimeIndexFPA(store, view.getInteractionPAssertions(), viewkind, ik));
		findPArpa.add(measureTimeIndexFPA(store, view.getRelationshipPAssertions(), viewkind, ik));
	}

	private long measureTimeIndexFPA(
			Index store,
			List<PAssertion> list,
			String viewkind,
			InteractionKey ik		
	) throws Exception {
		long start = System.currentTimeMillis();
		for (PAssertion pa: list) {
			store.findPAssertion(
					new GlobalPAssertionKey (
							ik,
							viewkind,
							pa.getLocalPAssertionID()
					)
			);
		}
		return System.currentTimeMillis() - start;
	}

	private  long measureTimeIndexMySQLFVs(
			MyIndex store,
			InteractionKey ik,
			String viewkind
	) throws Exception {
		long start = System.currentTimeMillis();
		store.findViews(ik, viewkind);
		return System.currentTimeMillis() - start;
	}

	private long measureTimeIndexMySQLFV(
			MyIndex store,
			InteractionKey ik,
			String viewkind,
			Element asserter
	) throws Exception {
		long start = System.currentTimeMillis();
		store.findView(ik, viewkind, asserter);
		return System.currentTimeMillis() - start;
	}

	private void retrieveIR(
			BackendStore store,
			String pref		
	) throws Exception {
		List<Long> retT;
		if (!_data.get(5).containsKey(pref)) {
			retT = new ArrayList<Long>();
			_data.get(5).put(pref, retT);
		} else {
			retT = _data.get(5).get(pref);
		}
		long start = System.currentTimeMillis();
		ExtremeTest.lastInsertedNoSave(store, 1);
		retT.add(System.currentTimeMillis() - start);
	}

	private void retrieveIR(
			Testbed testbed,
			String pref		
	) throws Exception {
		List<Long> retT;
		if (!_data.get(17).containsKey(pref)) {
			retT = new ArrayList<Long>();
			_data.get(17).put(pref, retT);
		} else {
			retT = _data.get(17).get(pref);
		}
		long start = System.currentTimeMillis();
//		Document doc = testbed.xquery("$ps:pstruct/ps:interactionRecord[0]");
		testbed.xquery("$ps:pstruct/ps:interactionRecord[0]");
//		Document doc = testbed.xquery("$ps:pstruct");
		retT.add(System.currentTimeMillis() - start);
//		Debug.msg(DOMWriter.writeToString(doc, true));
	}


	private void recordIR(
			BackendStore store, 
			String pref,
			InteractionRecord ir
	) throws Exception {
		List<Long> ipaT;
		List<Long> apaT;
		List<Long> rpaT;
		List<Long> eimT;
		List<Long> sfT;
		if (!_data.get(0).containsKey(pref)) {
			ipaT = new ArrayList<Long>();
			apaT = new ArrayList<Long>();
			rpaT = new ArrayList<Long>();
			eimT = new ArrayList<Long>();
			sfT = new ArrayList<Long>();
			_data.get(0).put(pref, ipaT);
			_data.get(1).put(pref, apaT);
			_data.get(2).put(pref, rpaT);
			_data.get(3).put(pref, eimT);
			_data.get(4).put(pref, sfT);
		} else {
			ipaT = _data.get(0).get(pref);
			apaT = _data.get(1).get(pref);
			rpaT = _data.get(2).get(pref);
			eimT = _data.get(3).get(pref);
			sfT = _data.get(4).get(pref);
		}
		ExtremeTest _et = new ExtremeTest(store);
		_et.recordView(
				ir.getSenderView(), 
				ir.getInteractionKey(), 
				Constants.SENDER_VIEW_TYPE, 
				ipaT, 
				apaT, 
				rpaT, 
				eimT, 
				sfT
		);

		_et.recordView(
				ir.getReceiverView(), 
				ir.getInteractionKey(), 
				Constants.RECEIVER_VIEW_TYPE, 
				ipaT, 
				apaT, 
				rpaT, 
				eimT, 
				sfT
		);

	}

	private void recordIR(
			Testbed testbed, 
			String pref,
			InteractionRecord ir
	) throws Exception {
		List<Long> ipaT;
		List<Long> apaT;
		List<Long> rpaT;
		List<Long> eimT;
		List<Long> sfT;
		if (!_data.get(6).containsKey(pref)) {
			ipaT = new ArrayList<Long>();
			apaT = new ArrayList<Long>();
			rpaT = new ArrayList<Long>();
			eimT = new ArrayList<Long>();
			sfT = new ArrayList<Long>();
			_data.get(6).put(pref, ipaT);
			_data.get(7).put(pref, apaT);
			_data.get(8).put(pref, rpaT);
			_data.get(9).put(pref, eimT);
			_data.get(10).put(pref, sfT);
		} else {
			ipaT = _data.get(6).get(pref);
			apaT = _data.get(7).get(pref);
			rpaT = _data.get(8).get(pref);
			eimT = _data.get(9).get(pref);
			sfT = _data.get(10).get(pref);
		}
//		ExtremeTest _et = new ExtremeTest(store);
		Debug.msg(DOMWriter.writeToString(ir.getSenderView().getAsserter(), true));
		ExtremeTest.recordView(
				testbed, 
				ir.getSenderView(), 
				ir.getInteractionKey(), 
				Constants.SENDER_VIEW_TYPE, 
				ipaT, 
				apaT, 
				rpaT, 
				eimT, 
				sfT
		);

		ExtremeTest.recordView(
				testbed, 
				ir.getReceiverView(), 
				ir.getInteractionKey(), 
				Constants.RECEIVER_VIEW_TYPE, 
				ipaT, 
				apaT, 
				rpaT, 
				eimT, 
				sfT
		);
	}



	private void initMaps(){
		_data = new ArrayList<Map<String, List<Long>>>();
		_outs = new PrintStream[tests];
		for (int i = 0; i < tests; i++) {
			_data.add(i, new HashMap<String, List<Long>>());
		}
	}

	private void write() throws FileNotFoundException {
		int o = 0;
		_outs[o++] = new PrintStream(new File(_parent, "ipa.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "apa.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "rpa.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "eim.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "sf.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "ret.txt"));

		_outs[o++] = new PrintStream(new File(_parent, "disp_ipa.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "disp_apa.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "disp_rpa.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "disp_eim.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "disp_sf.txt"));

		_outs[o++] = new PrintStream(new File(_parent, "find_pa_apa.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "find_pa_ipa.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "find_pa_rpa.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "find_ir.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "find_v.txt"));
		_outs[o++] = new PrintStream(new File(_parent, "find_vs.txt"));

		_outs[o++] = new PrintStream(new File(_parent, "xquery.txt"));

		for (int i = 0; i < tests; i++) {
			MySQLStore.printTimeMap(_outs[i], _data.get(i));
		}
	}

}
