package org.pasoa.preserv.xquery.laxquery;

import java.io.Writer;
import java.util.List;
import java.util.Map;
import org.pasoa.laxquery.Context;
import org.pasoa.laxquery.XQuery;
import org.pasoa.laxquery.XQueryException;
import org.pasoa.preserv.xquery.QueryProblem;
import org.pasoa.preserv.xquery.XQueryResolver;

public class XQueryEngine implements XQueryResolver {
    public List resolve (String query, Map documents, Map variables) throws QueryProblem {
        try {
            Context context = new Context (documents, variables);
            XQuery xquery = new XQuery (query, null);

            return xquery.resolve (context);
        } catch (XQueryException ex) {
            throw new QueryProblem ("Error in resolving XQuery", ex);
        }
    }
    
    public void resolve (String query, Map documents, Map variables, Writer output) throws QueryProblem {
        try {
            Context context = new Context (documents, variables);
            XQuery  xquery  = new XQuery (query, output);

            xquery.resolve (context);
        } catch (XQueryException ex) {
            throw new QueryProblem ("Error in resolving XQuery", ex);
        }
    }
}
