package org.pasoa.preserv.xquery.test;

import java.io.IOException;
import java.io.StringReader;
import java.util.HashMap;
import java.util.Map;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.pasoa.common.Constants;
import org.pasoa.preserv.xquery.ipsixq.XQueryUtilities;
import org.pasoa.simpledom.DOMWriter;
import org.pasoa.simpledom.test.TestResources;
import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class XQueryTest {
    public void test () throws IOException, ParserConfigurationException, SAXException {
        TestResources   resources = new TestResources ();
        DOMWriter       writer1   = new DOMWriter (System.out);
        
        try {
            Map varMap = new HashMap ();
            String   pasoaNS   = "declare namespace " + "ps" + " = \"" + Constants.PSTRUCT_NS + "\"; ";
            //SimpleElement element6 = new SimpleElement (new SimpleDocument (), resources.element5 ());
            String databaseRecord = DOMWriter.writeToString (resources.element5 ());
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance ();
            factory.setNamespaceAware (true);
            DocumentBuilder builder = factory.newDocumentBuilder ();
            Document doc = builder.parse (new InputSource (new StringReader (databaseRecord)));
            varMap.put (new QName (Constants.PSTRUCT_NS, "x"), doc.getDocumentElement ());//document5 ().getDocumentElement ());
            writer1.write ((Document) new XQueryUtilities ().resolve (pasoaNS + "$ps:x", new HashMap (), varMap).get (0));
        } catch (Exception p) {p.printStackTrace ();}
    }
    
    public static void main (String[] arguments) throws Exception {
        new XQueryTest ().test ();
    }
    
}
