/*
 * AsserterIdentity.java
 *
 * Created on 25 juillet 2006, 19:50
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview;

import java.util.Vector;

/**
 * An Interface which can be implemented to create a new AsserterIdentity.
 * This interface is used to store an asserter (or actor).
 * @author tibo
 */
public interface AsserterIdentity {
    
    /**
     * Accessor which return the short name of this asserter identity.
     * @return a String
     */
    String getShortName();
    /**
     * Accessor which return the long name of this asserter identity.
     * @return a String
     */
    String getLongName();
    /**
     * Accessor which return the real name of this asserter identity.
     * Used to compare an asserter identity with an asserter in the store.
     * @return a String
     */
    String getRealName();
    /**
     * Method to compare 2 AddressAsserterIdentity.
     * @param obj an AsserterIdentity
     * @return return true if the two asserter Identity are the same, else return false
     */
    public boolean equals(Object obj);

}
