/*
 * OpenStore.java
 *
 * Created on 28 juillet 2006, 11:22
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.lang.reflect.InvocationTargetException;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.util.Vector;
import java.util.prefs.Preferences;
import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextPane;
import javax.swing.SwingUtilities;
import org.gridprovenance.client.exception.DataConstructorException;
import org.gridprovenance.client.exception.XQueryException;
import org.pasoa.preview.history.HistoryOpenNew;
import org.pasoa.preview.history.HistoryPrintStore;
import org.pasoa.preview.tableview.TableView;
import org.pasoa.preview.treetable.MyTreeTable;
import org.pasoa.preview.treetable.XMLTreeTableCellRenderer;
import org.pasoa.preview.treetable.XMLTreeTableModel;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.Progression;
import org.pasoa.simpledom.DOMWriter;


/**
 * create and display a little window to open or print a store
 * @author tibo
 */
public class OpenStore extends javax.swing.JDialog implements ActionListener{
    
    private JTabbedPane jTabbedPane1;
    private static String [] stores = null;
    JFrame jf;

    private boolean printStore;

    private JPanel jPanel1;
    /**
     * Creates new instance of OpenStore dialog
     * @param parent parent JFrame
     * @param modal boolean
     * @param jTabbedPane JTabbedPane where you to open the store
     * @param print if true JDialog is for printing a store
     * else JDialog open a new store
     */
    public OpenStore(java.awt.Frame parent, boolean modal, JTabbedPane jTabbedPane, boolean print) {
        super(parent, modal);
        this.jf = (JFrame) parent;
        this.jTabbedPane1 = jTabbedPane;
        this.setLocationRelativeTo(parent);
        this.setResizable(false);
        this.printStore = print;
        
        initComponents();
    }
    
    private void initComponents() {
	jComboBox1 = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jPanel1 = new javax.swing.JPanel();

	 
	    //        jTextField1 = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        if(printStore) setTitle(":: Print all the content of a store ::");
        else setTitle(":: Open a new store ::");
        
        
        Preferences prefs = Preferences.userRoot();
        int nb = prefs.getInt("nbStoresAddress", 1);

        stores = new String[nb];
        
        for (int i = 0; i < nb ; i++){
            stores[i] = prefs.get("StoreAddress" + i, "http://localhost:8080/preserv");
        }
        String [] tmpString = stores.clone();
        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(tmpString));

        jComboBox1.setEditable(true);
        jComboBox1.addActionListener(this);
        
        //jTextField1.setText(prefs.get("StoreAddresse", "http://localhost:8080/preserv"));
        //jTextField1.setToolTipText("Example : \"http://localhost:8080/preserv\"");
        //jTextField1.addActionListener(this);
        
        jLabel1.setText("Enter your store URL:");
        

        ButtonGroup group = new ButtonGroup();
        
        jRadioButton1.setText("Text");
        jRadioButton1.setSelected(false);
        jRadioButton1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton2.setText("TreeTable");
        jRadioButton2.setSelected(true);
        jRadioButton2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        
        group.add(jRadioButton1);
        group.add(jRadioButton2);        

        if(printStore){
            jRadioButton1.setVisible(true);
            jRadioButton2.setVisible(true);
            jButton1.setText("Print");
        }
        else {
                
            jRadioButton1.setVisible(false);
            jRadioButton2.setVisible(false);
            jButton1.setText("Open");
        }
        jButton1.addActionListener(this);

        jButton2.setText("Cancel");
        jButton2.addActionListener(this);

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jRadioButton1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 91, Short.MAX_VALUE)
                .add(jRadioButton2)
                .add(59, 59, 59))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jRadioButton1)
                    .add(jRadioButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(105, 105, 105)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(jButton1)
                                .add(62, 62, 62)
                                .add(jButton2))
                            .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(layout.createSequentialGroup()
                        .add(34, 34, 34)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jComboBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 342, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel1))))
                .addContainerGap(31, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(26, 26, 26)
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jComboBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 29, Short.MAX_VALUE)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(19, 19, 19)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton1)
                    .add(jButton2))
                .add(21, 21, 21))
        );
        pack();
    }// </editor-fold>

    /**
     * A static method to open a new store
     * @param jframe the main frame
     * @param add store address
     * @param jTabbedPane tabbedpane where you want to open your store
     * @param is_history if this method is called from the history menu
     * @throws java.net.URISyntaxException CSL exception
     * @throws org.gridprovenance.client.exception.DataConstructorException CSL exception
     * @throws org.gridprovenance.client.exception.XQueryException CSL exception
     * @throws java.lang.Exception general exception
     */
    public static void openNewStoreImpl(final JFrame jframe, final String add, final JTabbedPane jTabbedPane, final boolean is_history) throws URISyntaxException, DataConstructorException, XQueryException, Exception{
        
            Controller control = new Controller(add);

            Vector columnNames = control.mi.getAsserters();
            Vector<Vector> data = control.mi.getInteractions(columnNames);
            TableView tv = new TableView(control, jframe, columnNames,  data, jTabbedPane,add);

            SwingUtilities.invokeAndWait(tv); 

            if(!is_history) ((View)jframe).getHistoryDialog().addElementHistory(new HistoryOpenNew(add));

            Preferences prefs = Preferences.userRoot();
            boolean change = true;
            int nb = 0;
            if(stores == null){
                nb = prefs.getInt("nbStoresAddress", 1);
                stores = new String[nb];
                for (int i = 0; i < nb ; i++){
                    stores[i] = prefs.get("StoreAddress" + i, "http://localhost:8080/preserv");
                }
            }
            else{
                nb = prefs.getInt("nbStoresAddress", 0);
            }

            int i;
            for(i = 0; i < nb && change; i++){
                if(stores[i].equals(add))
                    change = false;
            }
            if(change && (i == (nb))){
                prefs.put("StoreAddress"+ nb, add);
                nb++;
                prefs.putInt("nbStoresAddress", nb);
            }
    }
    
    /**
     * add waiting bar to openNewStoreImpl
     * @param jframe the main frame
     * @param add store address
     * @param jTabbedPane tabbedpane where you want to open your store
     * @param is_history if this method is called from the history menu
     */
    public static void openNewStore(final JFrame jframe, final String add, final JTabbedPane jTabbedPane, final boolean is_history){
        
            Runnable go = new Runnable() {
                public void run() {
                    Progression pgr = new Progression(jframe);
                    try {
                        pgr.startProgress();
                        openNewStoreImpl(jframe, add, jTabbedPane, is_history);
	    		pgr.stopProgress();
                    } catch (InvocationTargetException ex) {
                         if(Controller.debug)ErreurDialog.afficher(jframe, "InvocationTargetException", 
                            ex.getMessage(),ex.getStackTrace());
                         else ErreurDialog.afficher(jframe, "InvocationTargetException", ex.getMessage());
                         pgr.stopProgress();
                    } catch (InterruptedException ex) {
                         if(Controller.debug)ErreurDialog.afficher(jframe, "InterruptedException", 
                            ex.getMessage(),ex.getStackTrace());
                         else ErreurDialog.afficher(jframe, "InterruptedException", ex.getMessage());
                         pgr.stopProgress();
                    } catch (Exception ex) {
                        if(Controller.debug)ErreurDialog.afficher(jframe, "Unable to create a \"new Controller\"", 
                            ex.getMessage(),ex.getStackTrace());
                        else ErreurDialog.afficher(jframe, "Unable to create a \"new Controller\"", ex.getMessage());
                        pgr.stopProgress();
                    }
                    ((View)jframe).getHistoryDialog().addElementHistory(new HistoryPrintStore(add, "text"));
                   
                }
            };
            Thread t = new Thread(go);
            t.start();
    } 
    
    /**
     * A static method to display the full content of a store
     * @param jframe main frame
     * @param add store address
     * @param jTabbedPane tabbedpane where you want to open your store
     * @param type can be "text" or "treetable"
     * @param is_history if this method is called from the history menu
     * @throws java.net.URISyntaxException CSL exception
     * @throws org.gridprovenance.client.exception.DataConstructorException CSL exception
     * @throws org.gridprovenance.client.exception.XQueryException CSL exception
     * @throws java.lang.Exception CSL exception
     */
    public static void openFullStoreImpl(final JFrame jframe, final String add, final JTabbedPane jTabbedPane, final String type, final boolean is_history) throws URISyntaxException, DataConstructorException, XQueryException, Exception{
        
        Controller control = new Controller(add, null);
        JScrollPane jscrollpane = new JScrollPane();
        if(type.equals("text")){
            JTextPane jtextpane = new JTextPane();
            jtextpane.setText(DOMWriter.writeToString(((control.mi).getPStruct()).getDocumentElement(), true));
            jscrollpane.setViewportView(jtextpane);
            ((View)jframe).getHistoryDialog().addElementHistory(new HistoryPrintStore(add, "text"));

        }
        else {
            XMLTreeTableModel xmltreetablemodel = new XMLTreeTableModel(
                    ((control.mi).getPStruct()).getDocumentElement());
            MyTreeTable treeTable = new MyTreeTable(xmltreetablemodel, jframe);
            treeTable.getTree().setCellRenderer(new XMLTreeTableCellRenderer());
            jscrollpane.setViewportView(treeTable);
            ((View)jframe).getHistoryDialog().addElementHistory(new HistoryPrintStore(add, "treetable"));
        }
        jTabbedPane.addTab("Full store at "+add, null, jscrollpane, "Full store store at " + add);
        jTabbedPane.setSelectedIndex(jTabbedPane.getTabCount()-1);
        jframe.repaint();

        if(!is_history)((View)jframe).getHistoryDialog().addElementHistory(new HistoryOpenNew(add));

        Preferences prefs = Preferences.userRoot();
        boolean change = true;
        int nb = 0;
        if(stores == null){
            nb = prefs.getInt("nbStoresAddress", 1);
            stores = new String[nb];
            for (int i = 0; i < nb ; i++){
                stores[i] = prefs.get("StoreAddress" + i, "http://localhost:8080/preserv");
            }
        }
        else{
            nb = prefs.getInt("nbStoresAddress", 0);
        }

        int i;
        for(i = 0; i < nb && change; i++){
            if(stores[i].equals(add))
                change = false;
        }
        if(change && (i == (nb))){
            prefs.put("StoreAddress"+ nb, add);
            nb++;
            prefs.putInt("nbStoresAddress", nb);
        }
    }
    
    /**
     * add waiting bar to openFullStoreImpl
     * @param jframe main frame
     * @param add store address
     * @param jTabbedPane tabbedpane where you want to open your store
     * @param type can be "text" or "treetable"
     * @param is_history if this method is called from the history menu
     */
    public static void openFullStore(final JFrame jframe, final String add, final JTabbedPane jTabbedPane, final String type, final boolean is_history){
        
            Runnable go = new Runnable() {
                public void run() {
                    Progression pgr = new Progression(jframe);
                    try {
                        pgr.startProgress();
                        openFullStoreImpl(jframe, add, jTabbedPane, type, is_history);
	    		pgr.stopProgress();
                    } catch (InvocationTargetException ex) {
                         if(Controller.debug)ErreurDialog.afficher(jframe, "InvocationTargetException", 
                            ex.getMessage(),ex.getStackTrace());
                         else ErreurDialog.afficher(jframe, "InvocationTargetException", ex.getMessage());
                         pgr.stopProgress();
                    } catch (InterruptedException ex) {
                         if(Controller.debug)ErreurDialog.afficher(jframe, "InterruptedException", 
                            ex.getMessage(),ex.getStackTrace());
                         else ErreurDialog.afficher(jframe, "InterruptedException", ex.getMessage());
                         pgr.stopProgress();
                    } catch (Exception ex) {
                        if(Controller.debug)ErreurDialog.afficher(jframe, "Unable to create a \"new Controller\"", 
                            ex.getMessage(),ex.getStackTrace());
                        else ErreurDialog.afficher(jframe, "Unable to create a \"new Controller\"", ex.getMessage());
                        pgr.stopProgress();
                    }
                   
                }
            };
            Thread t = new Thread(go);
            t.start();
    } 
    
    /**
     * click on a button or hit enter key
     * @param e action event
     */
    public void actionPerformed(ActionEvent e) {
        if(e.getSource() == jButton1 || (e.getSource() == jComboBox1 && !jComboBox1.isPopupVisible())){
            execCommand();
        }
        else {
            if(e.getSource() == jButton2){
                this.dispose();
            }
        }

    }

    /**
     * open what you have selected
     */
    public void execCommand(){
        
        Runnable go = new Runnable() {
            public void run() {
                Progression pgr = new Progression(jf);
                String add = jComboBox1.getSelectedItem().toString();

                Controller control;
                try {
                    setVisible(false);

                    pgr.startProgress();

                    if(!printStore) {
                        control = new Controller(add);

                        Vector columnNames = control.mi.getAsserters();
                        Vector<Vector> data = control.mi.getInteractions(columnNames);
                        TableView tv = new TableView(control, jf, columnNames,  data, jTabbedPane1,add);

                        SwingUtilities.invokeAndWait(tv); 

                        ((View)jf).setAddressList(((View)jf).getAddressList() + add + "\n" + "new" + "\n");
                        ((View)jf).getHistoryDialog().addElementHistory(new HistoryOpenNew(add));
                    }
                    else {
                        control = new Controller(add, null);
                        JScrollPane jscrollpane = new JScrollPane();
                        if(jRadioButton1.isSelected()){
                            JTextPane jtextpane = new JTextPane();
                            jtextpane.setText(DOMWriter.writeToString(((control.mi).getPStruct()).getDocumentElement(), true));
                            jscrollpane.setViewportView(jtextpane);
                            ((View)jf).getHistoryDialog().addElementHistory(new HistoryPrintStore(add, "text"));
                            ((View)jf).setAddressList(((View)jf).getAddressList() + add + "\n" + "text" + "\n");

                        }
                        else {
                            XMLTreeTableModel xmltreetablemodel = new XMLTreeTableModel(
                                    ((control.mi).getPStruct()).getDocumentElement());
                            MyTreeTable treeTable = new MyTreeTable(xmltreetablemodel, jf);
                            treeTable.getTree().setCellRenderer(new XMLTreeTableCellRenderer());
                            jscrollpane.setViewportView(treeTable);
                            ((View)jf).getHistoryDialog().addElementHistory(new HistoryPrintStore(add, "treetable"));
                            ((View)jf).setAddressList(((View)jf).getAddressList() + add + "\n" + "treetable" + "\n");
                        }
                        jTabbedPane1.addTab("Full store at "+add, null, jscrollpane, "Full store store at " + add);
                        jTabbedPane1.setSelectedIndex(jTabbedPane1.getTabCount()-1);
                        jf.repaint();

                    }


                    Preferences prefs = Preferences.userRoot();

                    int nb = prefs.getInt("nbStoresAddress", 0);

                    boolean change = true;
                    int i;
                    for(i = 0; i < stores.length && i < nb && change; i++){
                        if(stores[i].equals(add))
                            change = false;
                    }
                    if(change && (i == (nb))){
                        prefs.put("StoreAddress"+ nb, add);
                        nb++;
                        prefs.putInt("nbStoresAddress", nb);
                    }

                    pgr.stopProgress();
                    dispose(); 
                } catch (InvocationTargetException ex) {
                     if(Controller.debug)ErreurDialog.afficher(jf, "InvocationTargetException", 
                        ex.getMessage(),ex.getStackTrace());
                     else ErreurDialog.afficher(jf, "InvocationTargetException", ex.getMessage());
                     pgr.stopProgress();
                     setVisible(true); 
                } catch (InterruptedException ex) {
                     if(Controller.debug)ErreurDialog.afficher(jf, "InterruptedException", 
                        ex.getMessage(),ex.getStackTrace());
                     else ErreurDialog.afficher(jf, "InterruptedException", ex.getMessage());
                     pgr.stopProgress();
                     setVisible(true); 
                } catch (Exception ex) {
                    if(Controller.debug)ErreurDialog.afficher(jf, "Unable to create a \"new Controller\"", 
                        ex.getMessage(),ex.getStackTrace());
                    else ErreurDialog.afficher(jf, "Unable to create a \"new Controller\"", ex.getMessage());
                    pgr.stopProgress();
                    setVisible(true); 
                }

            }
        };
        Thread t = new Thread(go);
        t.start();
    }
    
    // Variables declaration - do not modify
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    //private javax.swing.JTextField jTextField1;
    
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    // End of variables declaration
    
}
