package org.pasoa.preview._old;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.net.URL;
import java.util.LinkedList;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;

import org.pasoa.common.Constants;
import org.pasoa.pstructure.Record;
import org.pasoa.pstructure.ActorStatePAssertion;
import org.pasoa.pstructure.GlobalPAssertionKey;
import org.pasoa.pstructure.InteractionKey;
import org.pasoa.pstructure.InteractionPAssertion;
import org.pasoa.pstructure.ObjectID;
import org.pasoa.pstructure.RelationshipPAssertion;
import org.pasoa.simpledom.DOMWriter;
import org.pasoa.storeclient.ClientLib;
import org.pasoa.util.httpsoap.WSAddressEndpoint;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.InputSource;

import org.pasoa.storeclient.test.ClientLibExample;


import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import org.pasoa.common.Constants;
//import org.pasoa.dommap.DOMWriter;

import org.pasoa.simpledom.DOMWriter;
import org.pasoa.storeclient.ClientLib;
import org.pasoa.util.httpsoap.WSAddressEndpoint;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
//import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import edu.uci.ics.jung.graph.Edge;
import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.Vertex;
import edu.uci.ics.jung.graph.decorators.EdgeStringer;
import edu.uci.ics.jung.graph.decorators.StringLabeller;
import edu.uci.ics.jung.graph.decorators.VertexStringer;
import edu.uci.ics.jung.graph.impl.DirectedSparseEdge;
import edu.uci.ics.jung.graph.impl.DirectedSparseGraph;
import edu.uci.ics.jung.graph.impl.DirectedSparseVertex;
import edu.uci.ics.jung.graph.impl.SimpleUndirectedSparseVertex;
import edu.uci.ics.jung.graph.impl.UndirectedSparseEdge;
import edu.uci.ics.jung.graph.impl.UndirectedSparseGraph;
import edu.uci.ics.jung.utils.Pair;
import edu.uci.ics.jung.utils.UserData;
import edu.uci.ics.jung.visualization.FRLayout;
import edu.uci.ics.jung.visualization.GraphZoomScrollPane;
import edu.uci.ics.jung.visualization.Layout;
import edu.uci.ics.jung.visualization.PluggableRenderer;
import edu.uci.ics.jung.visualization.Renderer;
import edu.uci.ics.jung.visualization.VisualizationViewer;
import edu.uci.ics.jung.visualization.ZoomPanGraphMouse;
import edu.uci.ics.jung.visualization.contrib.DAGLayout;
import edu.uci.ics.jung.visualization.control.DefaultModalGraphMouse;
import edu.uci.ics.jung.visualization.control.PluggableGraphMouse;
import edu.uci.ics.jung.visualization.control.ViewScalingGraphMousePlugin;


public class Preview {
    
    public static boolean EUCSL = false;
    
    public static URL provenanceStore;
    public static URL provenanceStoreQuery;
        
    public VertexStringer _vertexStringerBB;
    public EdgeStringer _edgeStringerBB;
    public VertexStringer _vertexStringerCL;

    public static void main(String[] args) throws Exception {
        
        if (args.length == 2) {
            if (args[1].equals("CSL")) {
                EUCSL = true;
            }
        }
        
        if (args.length != 1) {
            System.out.println ("Usage: java org.pasoa.preview.Preview <provenance store url>");
            System.out.println ("       example url: http://localhost:8080/preserv");
            System.out.println ("       There should be NO trailing / behind preserv");
            System.exit(0);
        }
        
        provenanceStore = new URL (args[0] + "/record");
        provenanceStoreQuery = new URL (args[0] + "/xquery");
        
        // Here we create the urls for recording and querying the provenance store
        // send record messages to the record port (provenanceStore)
        // send query messages to the xquery port (proveanceStoreQuery)
       
        
//        ClientLibExample cle = new ClientLibExample();
        
        
        System.out.println("Starting Preview...");

        Preview preview = new Preview();

        Graph graphBB = preview.makeRelationshipDiagram(provenanceStoreQuery);
        Layout layoutBB = new DAGLayout(graphBB);
        layoutBB.resize(new Dimension(1000, 1000));

        PluggableRenderer rendererBB = new PluggableRenderer();
        rendererBB.setVertexStringer(preview._vertexStringerBB);
        rendererBB.setEdgeStringer(preview._edgeStringerBB);
        VisualizationViewer vvBB = new VisualizationViewer(layoutBB, rendererBB);
        DefaultModalGraphMouse graphMouseBB = new DefaultModalGraphMouse();
        graphMouseBB.add(new ViewScalingGraphMousePlugin());
        vvBB.setGraphMouse(graphMouseBB);
        vvBB.setSize(800, 800);
        GraphZoomScrollPane bigBangPane = new GraphZoomScrollPane(vvBB);

        Graph graphCL = preview.makeColloborationDiagram(provenanceStoreQuery);
       //Graph graphCL = preview.makeColloborationDiagram(new URL(args[0]));
        Layout layoutCL = new FRLayout(graphCL);
        PluggableRenderer rendererCL = new PluggableRenderer();
        rendererCL.setVertexStringer(preview._vertexStringerCL);
        VisualizationViewer vvCL = new VisualizationViewer(layoutCL, rendererCL);
        GraphZoomScrollPane collabPane = new GraphZoomScrollPane(vvCL);

        JTabbedPane jtp = new JTabbedPane();
        jtp.addTab("Colloboration", collabPane);
        jtp.addTab("BigBang", bigBangPane);
        JFrame jf = new JFrame("Preview");

        jf.getContentPane().add(jtp);

        JMenuBar jmb = new JMenuBar();
        jmb.add(graphMouseBB.getModeMenu());
        jf.setJMenuBar(jmb);
        jf.setSize(600, 600);

        jf.setVisible(true);

    }

    public Preview() {
    }

    /*
     * public Graph makeRelationshipDiagram() throws Exception { String xquery = "<result>{for
     * $n in $ps:pstruct return $n}</result>"; ClientLib cl = new ClientLib();
     * 
     * String qdhXPath =
     * "/ps:pstruct/ps:interactionRecord/ps:interactionKey/ps:messageSink/wsa:EndpointReference[wsa:Address=\"http://pasoa-vmware1.ecs.soton.ac.uk/experiments/ace/Driver\"]/../../../ps:receiver/ps:interactionPAssertion/ps:content/psproxy:data[ace:efficiency=\"0.16970534034062584\"]";
     * String scopeXPath = "/pq:relationshipTarget/ps:interactionPAssertion";
     * 
     * HashMap spaces = new HashMap (); //namespaces
     * 
     * spaces.put ("ps", Constants.PSTRUCT_NS); spaces.put ("pq",
     * Constants.PQUERY_NS); spaces.put ("ph", Constants.PHEADER_NS); spaces.put
     * ("wsa", WSAddressEndpoint.wsaNamespace); spaces.put ("ace",
     * "http://pasoa-vmware1.ecs.soton.ac.uk/experiments/ace/"); spaces.put
     * ("psproxy",
     * "http://pasoa-vmware1.ecs.soton.ac.uk/experiments/ace/psproxy");
     * 
     * 
     * Document result = cl.provenanceQuery(qdhXPath, scopeXPath, spaces, new
     * URL("http://localhost:10000/preserv/pquery"));
     * 
     * System.out.println (DOMWriter.writeToString (result, true));
     * 
     * Graph graph = new DirectedSparseGraph(); return graph; }
     */

    public Graph makeRelationshipDiagram(URL pStoreXQueryPort) throws Exception {
        String xquery = "$ps:pstruct";
        ClientLib cl = new ClientLib();
        Document result = cl.query(xquery, pStoreXQueryPort);

        NodeList iks = result.getElementsByTagNameNS(Constants.PSTRUCT_NS, "relationshipPAssertion");

        Graph graph = new DirectedSparseGraph();
        MapStringer mapStringer = new MapStringer();
        _vertexStringerBB = mapStringer;

        MapEdgeStringer edgeNames = new MapEdgeStringer();
        _edgeStringerBB = edgeNames;

        HashMap interactionIds = new HashMap();

        Vector edgesAdded = new Vector();

        System.out.println(iks.getLength());
        for (int i = 0; i < iks.getLength(); i++) {

            Vertex subjVertex;
            Vector objIdVertexes = new Vector();

            Element n = (Element) iks.item(i);
            String rel = ((Element) n.getElementsByTagNameNS(Constants.PSTRUCT_NS, "relation").item(
                    0)).getFirstChild().getNodeValue();

            int slashIndex = rel.lastIndexOf("/");
            rel = rel.substring(slashIndex + 1);
            // Vertex relVertex = new DirectedSparseVertex();
            // graph.addVertex (relVertex);
            // mapStringer.addLabel(relVertex, rel);

            Element interactionRecord = (Element) n.getParentNode()
                    .getParentNode();
            Element interactionKey = (Element) interactionRecord
                    .getElementsByTagNameNS(Constants.PSTRUCT_NS, "interactionKey").item(0);
            String subjIId = interactionKey.getElementsByTagNameNS(
                    Constants.PSTRUCT_NS, "interactionId").item(0).getFirstChild().getNodeValue();

            if (!interactionIds.containsKey(subjIId)) {
                subjVertex = new DirectedSparseVertex();
                interactionIds.put(subjIId, subjVertex);
                graph.addVertex(subjVertex);
                // mapStringer.addLabel(subjVertex, subjIId);
            } else {
                subjVertex = (Vertex) interactionIds.get(subjIId);
            }

            NodeList objectIds = n.getElementsByTagNameNS(Constants.PSTRUCT_NS, "objectId");
            for (int j = 0; j < objectIds.getLength(); j++) {
                Element objId = (Element) objectIds.item(j);
                String objIId = objId.getElementsByTagNameNS(Constants.PSTRUCT_NS, "interactionId")
                        .item(0).getFirstChild().getNodeValue();
                Vertex objIdVertex;
                if (!interactionIds.containsKey(objIId)) {
                    objIdVertex = new DirectedSparseVertex();
                    interactionIds.put(objIId, objIdVertex);
                    graph.addVertex(objIdVertex);
                    // mapStringer.addLabel(objIdVertex, objIId);
                } else {
                    objIdVertex = (Vertex) interactionIds.get(objIId);
                }
                objIdVertexes.add(objIdVertex);
                Edge edge = new DirectedSparseEdge(subjVertex, objIdVertex);
                graph.addEdge(edge);
                edgeNames.addLabel(edge, rel);
            }

            // graph.addEdge(new DirectedSparseEdge (relVertex, subjVertex));

        }

        return graph;
    }

    public Graph makeColloborationDiagram(URL pStoreXQueryPort)
            throws Exception {
        System.out.println("Making colloboration diagram");
        
        String xquery = "<result>{for $n in $ps:pstruct return $n}</result>";
        ClientLib cl = new ClientLib();
        Document result = cl.query(xquery, pStoreXQueryPort);

        NodeList iks = result.getElementsByTagNameNS(Constants.PSTRUCT_NS, "interactionKey");

        Graph graph = new DirectedSparseGraph();
        StringLabeller sl = StringLabeller.getLabeller(graph);
        _vertexStringerCL = sl;

        Vector edgesAdded = new Vector();

        System.out.println(iks.getLength());
        for (int i = 0; i < iks.getLength(); i++) {
            Element n = (Element) iks.item(i);
            String msgSourceName;
            String msgSinkName;
            if (EUCSL) {
                msgSourceName = ((Element) n.getElementsByTagName("ps:messageSource").item(0)).getElementsByTagName("URL").item(0).getFirstChild().getNodeValue();
                msgSinkName = ((Element) n.getElementsByTagName("ps:messageSink").item(0)).getElementsByTagName("URL").item(0).getFirstChild().getNodeValue();
            } else {
                Element msgSrc = (Element) n.getElementsByTagNameNS(Constants.PSTRUCT_NS, "messageSource").item(0);
                System.out.println(DOMWriter.writeToString(msgSrc, true));
               
                Element msgSnk = (Element) n.getElementsByTagNameNS(Constants.PSTRUCT_NS, "messageSink").item(0);
                System.out.println(DOMWriter.writeToString(msgSnk, true));
               
                
                msgSourceName = ((Element) n.getElementsByTagNameNS(Constants.PSTRUCT_NS, "messageSource").item(0)).getElementsByTagNameNS(WSAddressEndpoint.wsaNamespace, "Address").item(0).getFirstChild().getNodeValue();
                msgSinkName = ((Element) n.getElementsByTagNameNS(Constants.PSTRUCT_NS, "messageSink").item(0)).getElementsByTagNameNS(WSAddressEndpoint.wsaNamespace, "Address").item(0).getFirstChild().getNodeValue();
            }
            //System.out.println(msgSourceName + " " + msgSinkName);
            boolean addEdge = false;

            Vertex msgSource;
            if ((msgSource = sl.getVertex(msgSourceName)) == null) {

                msgSource = new DirectedSparseVertex();
                graph.addVertex(msgSource);
                sl.setLabel(msgSource, msgSourceName);

            }
            Vertex msgSink;
            if ((msgSink = sl.getVertex(msgSinkName)) == null) {
                msgSink = new DirectedSparseVertex();
                graph.addVertex(msgSink);
                sl.setLabel(msgSink, msgSinkName);
            }

            String edgeKey = msgSourceName + " " + msgSinkName;
            if (!edgesAdded.contains(edgeKey)) {
                addEdge = true;
                edgesAdded.add(edgeKey);
            }

            if (addEdge) {
                graph.addEdge(new DirectedSparseEdge(msgSource, msgSink));
                //System.out.println("Edge added");
            }

        }

        return graph;
    }
    
}
