/*
 * AsserterDrawable.java
 *
 * Created on 27 juillet 2006, 16:09
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.asserterview;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Rectangle2D;
import java.util.Iterator;
import java.util.List;
import org.pasoa.preview.AsserterIdentity;
import org.pasoa.simpledom.DOMWriter;
import org.w3c.dom.Element;

/**
 * a class to draw the "grey boxes" the asserter boxes for the actor view
 * @author tibo
 */
public abstract class AsserterDrawable implements IDrawable {
    
    protected Shape shape;
    protected Color color;
    protected boolean isSelected;
    protected boolean isDrawable;
    /**
     * XML Element of the interactionRecord
     */
    protected Element elem;
    /**
     * AsserterIdentity of the current actor
     */
    public AsserterIdentity ai;
    
    
    /**
     * Creates a new instance of FormDrawable
     * @param c the color of the box (default grey)
     * @param pt th left top corner point of the box
     * @param dim width and height of the box
     * @param e the XML element of the interaction record for this actor
     * @param ai AsserterIdentity of this actor
     */
    public AsserterDrawable(Color c, Point pt, Dimension dim, Element e, AsserterIdentity ai) {
        this.color = c;
        this.isSelected = false;
        this.isDrawable = true;
        this.elem = e;
        this.ai = ai;
        //this.rect = new Rectangle(pt, dim);
        this.shape = new Rectangle2D.Double(pt.x, pt.y, dim.width, dim.height);
    }

    public AsserterIdentity getAi() {
        return ai;
    }

    public Element getElem() {
        return elem;
    }

    
    public boolean isSelected() {
        return this.isSelected;
    }
    
    public void setSelected(boolean tf) {
        this.isSelected = tf;
    }
    
    public void setColor(Color c){
        this.color = c;
        
    }
    
    public abstract void draw (Graphics g);

    public void setDrawable(boolean tf) {
        this.isDrawable = tf;
    }
    
    public boolean isDrawable() {
        return isDrawable;
    }

    public Shape getShape() {
        return this.shape;
    }
}
