/*
 * FormDrawable.java
 *
 * Created on 27 juillet 2006, 16:00
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.asserterview;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Rectangle2D;

/**
 * an abstract class for all the drawables objects
 * @author tibo
 */
public abstract class FormDrawable implements IDrawable {
    
    protected Shape shape;
    protected Color color;
    protected boolean isSelected;
    
    /**
     * Creates a new instance of FormDrawable
     * @param color color of this object
     * @param pt top left corner of this object
     * @param dim width and height of this object
     */
    public FormDrawable(Color color, Point pt, Dimension dim) {
        this.color = color;
        this.isSelected = false;
        //this.rect = new Rectangle(pt, dim);
        this.shape = new Rectangle2D.Double(pt.x, pt.y, dim.width, dim.height);
    }

    public boolean isSelected() {
        return this.isSelected;
    }
    
    public void setSelected(boolean tf) {
        this.isSelected = tf;
    }
    
    public void setColor(Color c){
        this.color = c;
        
    }
    
    public abstract void draw (Graphics g);
    
    public Shape getShape() {
        return this.shape;
    }
}
