/*
 * JCanvasMouseAdapter.java
 *
 * Created on 10 aot 2006, 15:59
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.asserterview;

import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.awt.geom.Point2D;
import java.util.List;
import javax.swing.SwingUtilities;

/**
 * a mouse adapter for the actor view
 * @author tibo
 */
public class JCanvasMouseAdapter extends JCanvasMouseListener implements MouseMotionListener{
    
    protected Point2D pt;

    private boolean ResizeActor;
    private int min_width;
    private int min_height;
    private int maxNbActors;
    
    /**
     * Creates a new instance of JCanvasMouseAdapter
     * @param canvas the actor view
     */
    public JCanvasMouseAdapter(AsserterView canvas) {
        super(canvas);
        maxNbActors = Math.max(canvas.sender.size(), canvas.receiver.size());
        int tmp = (maxNbActors * (canvas.actorHeightInit + canvas.betweenInteractionInit) + canvas.betweenInteractionInit);
        if(tmp >= canvas.bord) this.min_width = canvas.bord;
        else this.min_width = tmp;
        this.min_height = tmp;
        
        canvas.addMouseMotionListener(this);
        
    }

    public void mouseDragged(MouseEvent e) {
        if(!ResizeActor){
            if(pt != null) {
                canvas.moveX = e.getPoint().getX() - pt.getX();
                canvas.moveY = e.getPoint().getY() - pt.getY();
                canvas.repaint();
                canvas.revalidate();
            }
        }
        else {
            if(pt != null) {
                int canvas_Width = (int) (((e.getPoint().getX() - canvas.moveX)/canvas.scaleX) - pt.getX());
                int canvas_Height = (int) (((e.getPoint().getY()- canvas.moveY)/canvas.scaleY) - pt.getY());
                if(canvas_Width >= min_width){
		    canvas.Width = canvas_Width;
                    //canvas.prefWidth = canvas.Width + 2*canvas.actorWidth + 2 * canvas.bord;
		}
		if(canvas_Height >= min_height) {
                    canvas.Height = canvas_Height;
                    canvas.actorHeight = (int) ((canvas.Height)/(1.5*maxNbActors + 0.5));
                    canvas.actorWidth = (int) (3*canvas.actorHeight/2);
                    canvas.betweenInteraction = canvas.actorHeight/2;
                    //canvas.prefHeight = canvas.Height + 2 * canvas.bord;
		}
		canvas.reset();
		canvas.repaint();
		canvas.revalidate();
                
            }
        }
    }

    public void mouseReleased(MouseEvent e) {
        if(ResizeActor) {
            ResizeActor = false;
        }
        pt = null;
    }

    public void mousePressed(MouseEvent e) {
        if ((SwingUtilities.isLeftMouseButton(e) && e.isControlDown()) || SwingUtilities.isRightMouseButton(e)) {
            rightPressAction(e);
        } else {
            leftPressAction(e);
        }
    }
    
    public void mouseMoved(MouseEvent e) {
    }

    private void rightPressAction(MouseEvent e) {
        Point p = new Point();

            p.setLocation(
                    (e.getPoint().getX() - canvas.moveX)/canvas.scaleX,
                    (e.getPoint().getY() - canvas.moveY)/canvas.scaleY);

//        if(p.getX() > (canvas.bord + canvas.Width - 3)
//        && p.getX() < (canvas.bord + canvas.Width + 3)){
            ResizeActor = true;
            pt = new Point2D.Double(
                    (p.getX() - canvas.Width), 
                    (p.getY() - canvas.Height));
//        }
    }

    private void leftPressAction(MouseEvent e) {
        Point p = new Point();

            p.setLocation(
                    (e.getPoint().getX() - canvas.moveX)/canvas.scaleX,
                    (e.getPoint().getY() - canvas.moveY)/canvas.scaleY);

       
        List selectedDrawables = canvas.findDrawables(p);
        if (selectedDrawables.size() == 0) {
            pt = new Point2D.Double((e.getPoint().getX() - canvas.moveX), (e.getPoint().getY() - canvas.moveY));
        }
    }
    
}
