/*
 * JCanvasMouseListener.java
 *
 * Created on 27 juillet 2006, 21:00
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.asserterview;

/**
 *
 * @author tibo
 */
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.*;
import java.util.List;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.SwingUtilities;
import org.pasoa.preview.AsserterIdentity;

/**
 * a mouse listener for the actor view
 * @author tibo
 */
public class JCanvasMouseListener extends MouseAdapter {

	protected AsserterView canvas;

    /**
     * Creates a new instance of JCanvasMouseListener
     * @param canvas the actor view
     */
	public JCanvasMouseListener(AsserterView canvas) {
		super();
		this.canvas = canvas;
		canvas.addMouseListener(this);
	}
		
	public AsserterView getCanvas() {
		return canvas;
	}

	public void mouseClicked(MouseEvent e) {
		if ((SwingUtilities.isLeftMouseButton(e) && e.isControlDown()) || SwingUtilities.isRightMouseButton(e)) {
                    rightClickAction(e);
		} else {
                    leftClickAction(e);
		}
	}

	protected void rightClickAction(MouseEvent e) {
            
            JPopupMenu labelPopupMenu = new MyMenu(canvas, e);
            labelPopupMenu.show(e.getComponent(), e.getX(), e.getY());
            canvas.repaint();
	}

	protected void leftClickAction(MouseEvent e) {
            Point p = new Point();
            p.setLocation(
                    (e.getPoint().getX() - canvas.moveX)/canvas.scaleX,
                    (e.getPoint().getY() - canvas.moveY)/canvas.scaleY);

            if(e.getClickCount() == 1) {
                
                List selectedDrawables = canvas.findDrawables(p);
		if (selectedDrawables.size() == 0) {
                    canvas.setSelectedAll(false);
                    canvas.setDrawableAll(true);
                }
                else {
                    IDrawable d = (IDrawable) selectedDrawables.get(selectedDrawables.size()-1);
                    //System.out.println(selectedDrawables.size());
                    if(d instanceof AsserterDrawable) {
                        if(d.isSelected()) {
                            canvas.setSelectedAll(false);
                            canvas.setDrawableAll(true);
                        }
                        else {
                            canvas.setSelectedAll(false);
                            canvas.setDrawableAll(false);
                            List selectedRelationship = canvas.findRelationship((AsserterDrawable)d, true, true);
                            d.setDrawable(true);
                            d.setSelected(true);
                        }
                    }
                    else {
                        if(d.isSelected()){
                            canvas.setSelectedAll(false);
                            canvas.setDrawableAll(true);
                        }
                        else{
                            canvas.setSelectedAll(false);
                            canvas.setDrawableAll(false);
                            d.setSelected(true);
                            d.setDrawable(true);
                            IDrawable tmp = canvas.findInteractionSenderFromRelationship(d);
                            tmp.setSelected(true);
                            tmp.setDrawable(true);
                            tmp = canvas.findInteractionReceiverFromRelationship(d);
                            tmp.setSelected(true);
                            tmp.setDrawable(true);
                            List selectedRelationship = canvas.findRelationship((RelationshipElement)d, true, true);
                            
                        }
                    }
                }
                canvas.repaint();
            }
            else {
                if(e.getClickCount() == 2) {
                    List selectedDrawables = canvas.findDrawables(p);
                    if (selectedDrawables.size() != 0) {
                        IDrawable d = (IDrawable) selectedDrawables.get(selectedDrawables.size()-1);
                        //System.out.println(selectedDrawables.size());
                        if(d instanceof AsserterDrawable) {
                            AsserterIdentity tmp = ((AsserterDrawable)d).getAi();
                            canvas.goToAsserter(tmp);
                        }
                    }
                    canvas.repaint();
                }
                else {
                    
                    canvas.getGraphics().drawRect(
                            (int)((e.getPoint().getX() - canvas.moveX)/canvas.scaleX ),
                            (int)((e.getPoint().getY() - canvas.moveY)/canvas.scaleY), 
                            2,
                            2);
        
                }
            }
        }
        
      
}