/*
 * SenderDrawable.java
 *
 * Created on 27 juillet 2006, 16:09
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.asserterview;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.Iterator;
import java.util.List;
import javax.swing.JTable;
import org.pasoa.preview.AsserterIdentity;
import org.pasoa.simpledom.DOMWriter;
import org.w3c.dom.Element;

/**
 * an implementation of an asserterDrawable for the receiver
 * @author tibo
 */
public class SenderDrawable extends AsserterDrawable{
    
    
    /**
     * Creates a new instance of SenderDrawable
     * @param c color of the box
     * @param p top left corner of the box
     * @param dim width and height of the box
     * @param e XML element contains an interaction record
     * @param ai asserterIdentity for this actor
     */
    public SenderDrawable(Color c, Point p, Dimension dim, Element e, AsserterIdentity ai) {
        super(c, p, dim, e, ai);
    }
    
    public void draw(Graphics g) {
        Graphics2D g2d = (Graphics2D) g;
        g2d.setStroke(new BasicStroke(1, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
        Color c = g2d.getColor();
        
        Rectangle rec = getShape().getBounds();
        
        if(!this.isSelected()) g2d.setColor(color);
        else g2d.setColor(selectColor);
        g2d.fill(shape);
        
        Font f = g2d.getFont();
        g2d.setFont(new Font("TimeRoman", Font.PLAIN, (int)(f.getSize()/2)));
        //if(ai == null)g2d.drawString("nothing", (int) (rec.x + rec.width - rec.height/3), (int)(rec.y - 2));
        g2d.drawString(ai.getShortName(), (int) (rec.x + rec.width - rec.width/3), (int)(rec.y - 2));
        g2d.setFont(f);
        
        int [] x = {rec.x+(rec.width/5), rec.x+(rec.width/5), rec.x+(rec.width/2)};
        int [] y = {rec.y+(rec.height/5), (-(rec.height/5)) + (rec.y+rec.height), (rec.y+(rec.height/2))};
        //int [] x ={rec.x+5, rec.x+5, rec.x+7};
        //int [] y ={rec.y+5, rec.y+10, rec.y+7};
        int nbPoint = 3;
        g2d.setColor(g2d.getBackground());
        g2d.fillPolygon(x, y, nbPoint);
        
        g2d.setColor(c);
        
        //g2d.drawRect(rect.x, rect.y, rect.width, rect.height);
    }
    
}
