/*
 * HistoryDialog.java
 *
 * Created on 1 septembre 2006, 16:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.history;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Vector;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.ListCellRenderer;
import javax.swing.ListSelectionModel;
import org.pasoa.preview.View;

/**
 * A JDialog which contains all the history
 * @author tibo
 */
public class HistoryDialog extends JDialog implements ActionListener{
    
    private JList jList;
    private Vector history;
    
    private JScrollPane jListscrollpane;

    private JFrame _jf;

    private JTabbedPane _jt;
    
    /**
     * Creates a new instance of HistoryDialog
     * @param jf main JFrame
     * @param jt the store JTabbedPane (with tab on top)
     */
    public HistoryDialog(JFrame jf, JTabbedPane jt) {
        super(jf, false);
        this._jt = jt;
        this._jf = jf;
        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e){
                View._historyVisible = false;
                ((View)_jf).jrb.setSelected(false);
                setVisible(false);
            }
        });
        initialize();
    }

    public void initialize(){
        
        history = new Vector();
        
        jListscrollpane = new JScrollPane();
        setTitle(":: History ::");
        createNewJList();
        jListscrollpane.setViewportView(jList);

        setPreferredSize(new Dimension (350, 250));
        add(jListscrollpane);
        pack();
    }
    
    public boolean addElementHistory(Object o){
        boolean r = history.add(o);
        createNewJList();
        validate();
        return r;
    }
    
    public boolean removeElementHistory(Object o){
        boolean r = history.remove(o);
        createNewJList();
        validate();
        return r;
    }
    
    public void resetHistory(){
        history.removeAllElements();
        createNewJList();
        validate();
    }
    
    public Vector getHistory(){
        return history;
    }

    public void actionPerformed(ActionEvent e) {
    }

    private void createNewJList() {
        jList = null;
        jList = new JList(history);
        
        MouseListener mouselistener = new MouseAdapter(){
            public void mouseClicked(MouseEvent e){
                if( e.getClickCount() == 2){
                    int index = jList.locationToIndex( e.getPoint());
                    if(index >= 0){
                        HistoryElement he = (HistoryElement) jList.getModel().getElementAt(index);
                        he.action(_jf, _jt);
                    }
                }
            }
        };
        jList.addMouseListener(mouselistener);
        jList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        jList.setToolTipText("History of all your actions");
        
        jList.setSelectedIndex(jList.getModel().getSize() - 1);
        jList.setCellRenderer(new MyListCellRenderer(jList));
        jListscrollpane.setViewportView(jList);
        jListscrollpane.setWheelScrollingEnabled(true);
        
        jListscrollpane.getVerticalScrollBar().setValue(
            jListscrollpane.getVerticalScrollBar().getMaximum()
        );
    }
    
}
