/*
 * HistoryElement.java
 *
 * Created on 1 septembre 2006, 10:58
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.history;

import javax.swing.JFrame;
import javax.swing.JTabbedPane;

/**
 * An interface for the element of the history
 * @author tibo
 */
public interface HistoryElement {

    public static boolean IS_HISTORY = true;
    
    /**
     * the title of this history element
     * @return title
     */
    public String getString();
    
    /**
     * action done on double click
     * @param jf main JFrame
     * @param jt JTabbedPane (with tab on the left)
     */
    public void action(JFrame jf, JTabbedPane jt);

    /**
     * category can be "actor", "provenance", "infobox", "interaction", "collaboration", "new", "print"
     * @return the category
     */
    String getCategory();

    /**
     * a short text to give more details about the history element
     * @return the description
     */
    String getDescription();

}
