/*
 * HistoryOpenNew.java
 *
 * Created on 1 septembre 2006, 11:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.history;

import java.awt.Component;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import org.pasoa.preview.AsserterIdentity;
import javax.swing.JFrame;
import javax.swing.JTabbedPane;
import org.pasoa.preview.Controller;
import org.pasoa.preview.OpenStore;
import org.pasoa.preview.asserterview.AsserterView;
import org.pasoa.preview.tableview.TableView;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.Progression;


/**
 * Implementation of the History Element for the event "open actor"
 * @author tibo
 */
public class HistoryOpenActor implements HistoryElement {
    
    private String _name;
    private String _categ;
    private String _desript;
    private AsserterIdentity _ai;

    private String _address;
    
    /**
     * Creates a new instance of HistoryOpenActor
     * @param add store address
     * @param ai asserter identity of the actor view
     */
    public HistoryOpenActor(String add, AsserterIdentity ai) {
        this._ai      = ai;
        this._address = add;
        this._name    = ai.getShortName();
        this._categ   = "actor"; 
        this._desript = "New actor : " + ai.getLongName();
    }
    
    public String getString(){
        return this._name;
    }

    public void action(final JFrame jf, final JTabbedPane jt) {
        
        int removeTab = -1;
        removeTab = jt.indexOfTab(_address);
        if(removeTab!=-1){
            jt.setSelectedIndex(removeTab);
            Component c = jt.getComponentAt(removeTab);
            if(c instanceof JTabbedPane){
                final JTabbedPane tmp = (JTabbedPane) c;
                int viewTab = -1;
                viewTab = tmp.indexOfTab(_ai.getShortName() + "View");
                if(viewTab!=-1){
                    tmp.setSelectedIndex(viewTab);
                }
                else {
                    Runnable go = new Runnable() {
                        public void run() {
                            Progression pgr = new Progression(jf);
                            try {
                                pgr.startProgress();
                                openActorView(jf, tmp);
                                pgr.stopProgress();
                            } catch (Exception ex) {
                                if(Controller.debug)ErreurDialog.afficher(jf, "Problem with history", 
                                    ex.getMessage(),ex.getStackTrace());
                                else ErreurDialog.afficher(jf, "Problem with history", ex.getMessage());
                             pgr.stopProgress();
                            }
                        }
                    };
                    Thread t = new Thread(go);
                    t.start();
                }
            }
        }
        else {
            
            Runnable go = new Runnable() {
                public void run() {
                    Progression pgr = new Progression(jf);
                    try {
                        pgr.startProgress();
                        OpenStore.openNewStoreImpl(jf, _address, jt, IS_HISTORY);
                        int removeTab2 = jt.getSelectedIndex();
                        jt.setSelectedIndex(removeTab2);
                        Component c = jt.getComponentAt(removeTab2);
                        if(c instanceof JTabbedPane){
                            JTabbedPane tmp = (JTabbedPane) c;
                            openActorView(jf, tmp);
                        }
                        pgr.stopProgress();
                    } catch (Exception ex) {
                        if(Controller.debug)ErreurDialog.afficher(jf, "Problem with history", 
                            ex.getMessage(),ex.getStackTrace());
                        else ErreurDialog.afficher(jf, "Problem with history", ex.getMessage());
                     pgr.stopProgress();
                    }
                }
            };
            Thread t = new Thread(go);
            t.start();
        }
    }

    public String getCategory() {
        return this._categ;
    }

    public String getDescription() {
        return this._desript;
    }

    private void openActorView(final JFrame jf, final JTabbedPane tmp) throws Exception {
        
        Component c = tmp.getComponentAt(0);
        if(c instanceof TableView){
            final TableView tv = (TableView) c;

            JScrollPane asserter = new JScrollPane();
            AsserterView av = new AsserterView(
                    tv.getControl(), 
                    _ai, 
                    tv.getColumnNames(), 
                    jf, 
                    tmp, 
                    tv.getInfobox(),
                    tv.getData(),
                    IS_HISTORY);

            asserter.setViewportView(av);
            tmp.addTab(
                    _ai.getShortName() + "View", 
                    null, 
                    asserter,
                    "This is one Asserter View");
            tmp.setSelectedIndex(tmp.getTabCount()-1);
            av.requestFocusInWindow();
        }
    }
}

