/*
 * HistoryOpenNew.java
 *
 * Created on 1 septembre 2006, 11:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.history;

import java.awt.Component;
import java.util.Set;
import javax.swing.JScrollPane;
import org.pasoa.preview.Controller;
import org.pasoa.preview.OpenStore;
import org.pasoa.preview.provenanceview.CollaborationView;
import org.pasoa.preview.provenanceview.ProvenanceView;
import org.pasoa.preview.tableview.TableView;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.PReViewUtilities;
import org.pasoa.preview.utils.Progression;
import org.pasoa.pstructure.ObjectID;
import org.w3c.dom.Element;
import javax.swing.JFrame;
import javax.swing.JTabbedPane;


/**
 * Implementation of the History Element for the event "open collaboration"
 * @author tibo
 */
public class HistoryOpenCollaboration implements HistoryElement {
    
    private String _name;
    private String _categ;
    private String _desript;

    private String _address;
    private String _type;

    private Set _currentsAsserter;

    private String _longName;
    
    /**
     * Creates a new instance of HistoryOpenCollaboration
     * @param add store address
     * @param currents a list of all the current Asserter Identity
     * @param rootName the name of the root in the provenance view
     * @param longN a long name of the root
     */
    public HistoryOpenCollaboration(String add, Set currents, String rootName, String longN) {
        this._name     = rootName ; 
        this._longName = longN;
        this._currentsAsserter = currents;
        this._categ    = "collaboration"; 
        this._address  = add;
        this._desript  = "New provenance view for " + this._name;
    }
    
    public String getString(){
        return this._name;
    }

    public void action(final JFrame jf, final JTabbedPane jt) {
        
        int removeTab = -1;
        removeTab = jt.indexOfTab(_address);
        if(removeTab!=-1){
            jt.setSelectedIndex(removeTab);
            Component c = jt.getComponentAt(removeTab);
            if(c instanceof JTabbedPane){
                final JTabbedPane tmp = (JTabbedPane) c;
                int viewTab = -1;
                viewTab = tmp.indexOfTab(_name + " - Collaboration");
                if(viewTab!=-1){
                    tmp.setSelectedIndex(viewTab);
                }
                else {
                    Runnable go = new Runnable() {
                        public void run() {
                            Progression pgr = new Progression(jf);
                            try {
                                pgr.startProgress();
                                openCollaborationView(jf, tmp);
                                pgr.stopProgress();

                            } catch (Exception ex) {
                                if(Controller.debug)ErreurDialog.afficher(jf, "Unable to initialize CollaborationView", 
                                    ex.getMessage(),ex.getStackTrace());
                                else ErreurDialog.afficher(jf, "Unable to initialize CollaborationView", ex.getMessage());
                                pgr.stopProgress();
                            }
                        }
                    };
                    Thread t = new Thread(go);
                    t.start();
                }
            }
        }
        else {
            
            Runnable go = new Runnable() {
                public void run() {
                    Progression pgr = new Progression(jf);
                    try {
                        pgr.startProgress();
                        OpenStore.openNewStoreImpl(jf, _address, jt, IS_HISTORY);
                        int removeTab2 = jt.getSelectedIndex();
                        jt.setSelectedIndex(removeTab2);
                        Component c = jt.getComponentAt(removeTab2);
                        if(c instanceof JTabbedPane){
                            JTabbedPane tmp = (JTabbedPane) c;
                            openCollaborationView(jf, tmp);
                        }
                        pgr.stopProgress();
                    } catch (Exception ex) {
                        if(Controller.debug)ErreurDialog.afficher(jf, "Problem with history", 
                            ex.getMessage(),ex.getStackTrace());
                        else ErreurDialog.afficher(jf, "Problem with history", ex.getMessage());
                     pgr.stopProgress();
                    }
                }
            };
            Thread t = new Thread(go);
            t.start();
        }
    }

    public String getCategory() {
        return this._categ;
    }

    public String getDescription() {
        return this._desript;
    }

    private void openCollaborationView(final JFrame jf, final JTabbedPane tmp) throws Exception {
        
        Component c = tmp.getComponentAt(0);
        if(c instanceof TableView){
            final TableView tv = (TableView) c;
            JScrollPane nextview = new JScrollPane();
            
            /* Nextview */
            CollaborationView nv = new CollaborationView(
                    tv.getControl(),
                    jf, 
                    tmp, 
                    tv.getInfobox(), 
                    tv.getColumnNames(), 
                    _currentsAsserter, 
                    tv.getData(),
                    _name,
                    _longName, 
                    IS_HISTORY);

            nextview.setViewportView(nv);
            tmp.addTab(
                    _name + " - Collaboration", 
                    null, 
                    nextview,
                    "This is one Collaboration View for "+_longName);
            tmp.setSelectedIndex(tmp.getTabCount()-1);
            nv.requestFocusInWindow();
            nextview.repaint();
        }
    }
}