/*
 * HistoryOpenNew.java
 *
 * Created on 1 septembre 2006, 11:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.history;

import java.awt.Component;
import javax.swing.JScrollPane;
import org.pasoa.preview.AsserterIdentity;
import javax.swing.JFrame;
import javax.swing.JTabbedPane;
import org.pasoa.preview.Controller;
import org.pasoa.preview.OpenStore;
import org.pasoa.preview.tableview.DrawInfoBox;
import org.pasoa.preview.tableview.TableView;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.Progression;


/**
 * Implementation of the History Element for the event "open infobox"
 * @author tibo
 */
public class HistoryOpenInfobox implements HistoryElement {
    
    private String _name;
    private String _categ;
    private String _desript;
    private AsserterIdentity _sender;
    private AsserterIdentity _receiver;

    private String _address;
    
    /**
     * Creates a new instance of HistoryOpenInfobox
     * @param add store address
     * @param sender asserter identity as sender
     * @param receiver asserter identity as receiver
     */
    public HistoryOpenInfobox(String add, AsserterIdentity sender, AsserterIdentity receiver) {
        this._sender   = sender;
        this._receiver = receiver;
        this._address    = add;
        this._name     = sender.getShortName()+"/"+receiver.getShortName();
        this._categ    = "Infobox";
        this._desript  = "List of all interactions between " + sender.getLongName()+" and "+receiver.getLongName();
                
    }
    
    public String getString(){
        return this._name;
    }

    public void action(final JFrame jf, final JTabbedPane jt) {
        
        int removeTab = -1;
        removeTab = jt.indexOfTab(_address);
        if(removeTab!=-1){
            jt.setSelectedIndex(removeTab);
            Component c = jt.getComponentAt(removeTab);
            if(c instanceof JTabbedPane){
                JTabbedPane tmp = (JTabbedPane) c;
                openInfoboxView(jf, tmp);
            }
        }
        else {
            
            Runnable go = new Runnable() {
                public void run() {
                    Progression pgr = new Progression(jf);
                    try {
                        pgr.startProgress();
                        OpenStore.openNewStoreImpl(jf, _address, jt, IS_HISTORY);
                        int removeTab2 = jt.getSelectedIndex();
                        jt.setSelectedIndex(removeTab2);
                        Component c = jt.getComponentAt(removeTab2);
                        if(c instanceof JTabbedPane){
                            JTabbedPane tmp = (JTabbedPane) c;
                            openInfoboxView(jf, tmp);
                        }
                        pgr.stopProgress();
                    } catch (Exception ex) {
                        if(Controller.debug)ErreurDialog.afficher(jf, "Problem with history", 
                            ex.getMessage(),ex.getStackTrace());
                        else ErreurDialog.afficher(jf, "Problem with history", ex.getMessage());
                     pgr.stopProgress();
                    }
                }
            };
            Thread t = new Thread(go);
            t.start();
        }
    }

    public String getCategory() {
        return this._categ;
    }

    public String getDescription() {
        return this._desript;
    }

    private void openInfoboxView(final JFrame jf, final JTabbedPane tmp) {
        Component c = tmp.getComponentAt(0);
        if(c instanceof TableView){
            final TableView tv = (TableView) c;

            DrawInfoBox dib = new DrawInfoBox(tv.getInfobox(), tv.getControl(), jf, IS_HISTORY, tmp);
            dib.go(_sender, _receiver, null);

            tmp.setSelectedIndex(0);

        }
    }
}