/*
 * HistoryOpenNew.java
 *
 * Created on 1 septembre 2006, 11:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.history;

import java.awt.Component;
import javax.swing.JFrame;
import javax.swing.JTabbedPane;
import org.pasoa.preview.Controller;
import org.pasoa.preview.OpenStore;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.Progression;

/**
 * Implementation of the History Element for the event "Open new"
 * @author tibo
 */
public class HistoryOpenNew implements HistoryElement {
    
    private String _name;
    private String _address;
    private String _categ;
    private String _desript;
    
    /**
     * Creates a new instance of HistoryOpenNew
     * @param add store address
     */
    public HistoryOpenNew(String add) {
        this._address = add;
        this._name    = this._address; 
        this._categ   = "store"; 
        this._desript = "Open a new store at " + this._address;
    }
    
    public String getString(){
        return this._name;
    }

    public void action(final JFrame jf, final JTabbedPane jt) {
        //System.out.println("Action !!!");
        int removeTab = -1;
        removeTab = jt.indexOfTab(_address);
        if(removeTab!=-1){
            jt.setSelectedIndex(removeTab);

            Component c = jt.getComponentAt(removeTab);

            if(c instanceof JTabbedPane){
                JTabbedPane tmp = (JTabbedPane) c;
                tmp.setSelectedIndex(0);
            }
            //jt.repaint();
        }
        else {
            OpenStore.openNewStore(jf, _address, jt, IS_HISTORY);
        }

    }

    public String getCategory() {
        return this._categ;
    }

    public String getDescription() {
        return this._desript;
    }
    
}
