/*
 * HistoryOpenNew.java
 *
 * Created on 1 septembre 2006, 11:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.history;

import java.awt.Component;
import javax.swing.JScrollPane;
import org.pasoa.preview.Controller;
import org.pasoa.preview.OpenStore;
import org.pasoa.preview.provenanceview.ProvenanceView;
import org.pasoa.preview.tableview.TableView;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.PReViewUtilities;
import org.pasoa.preview.utils.Progression;
import org.pasoa.pstructure.ObjectID;
import org.w3c.dom.Element;
import javax.swing.JFrame;
import javax.swing.JTabbedPane;


/**
 * Implementation of the History Element for the event "open provenance"
 * @author tibo
 */
public class HistoryOpenProvenance implements HistoryElement {
    
    private String _name;
    private String _categ;
    private String _desript;
    private ObjectID _objectID;

    private String _address;
    private String _type;
    
    /**
     * Creates a new instance of HistoryOpenProvenance
     * @param add store address
     * @param dataItem an ObjectID which is the root of the provenance view
     * @param s type can be "SUBJECT_ID" or "OBJECT_ID"
     */
    public HistoryOpenProvenance(String add, ObjectID dataItem, String s) {
        this._type     = s;
        this._name     = dataItem.getParameterName() ; 
        this._objectID = dataItem;
        this._categ    = "provenance"; 
        this._address  = add;
        this._desript  = "New provenance view for " + this._name;
    }
    
    public String getString(){
        return this._name;
    }

    public void action(final JFrame jf, final JTabbedPane jt) {
        
        int removeTab = -1;
        removeTab = jt.indexOfTab(_address);
        if(removeTab!=-1){
            jt.setSelectedIndex(removeTab);
            Component c = jt.getComponentAt(removeTab);
            if(c instanceof JTabbedPane){
                
                final JTabbedPane tmp = (JTabbedPane) c;
                int viewTab = -1;
                viewTab = tmp.indexOfTab(_name + " - Collaboration");
                if(viewTab!=-1){
                    tmp.setSelectedIndex(viewTab);
                }
                else {
                    Runnable go = new Runnable() {
                        public void run() {
                            Progression pgr = new Progression(jf);
                            try {
                                pgr.startProgress();
                                openProvenanceView(jf, tmp);
                                pgr.stopProgress();

                            } catch (Exception ex) {
                                if(Controller.debug)ErreurDialog.afficher(jf, "Unable to initialize CollaborationView", 
                                    ex.getMessage(),ex.getStackTrace());
                                else ErreurDialog.afficher(jf, "Unable to initialize CollaborationView", ex.getMessage());
                                pgr.stopProgress();
                            }
                        }
                    };
                    Thread t = new Thread(go);
                    t.start();
                }
            }
        }
        else {
            
            Runnable go = new Runnable() {
                public void run() {
                    Progression pgr = new Progression(jf);
                    try {
                        pgr.startProgress();
                        OpenStore.openNewStoreImpl(jf, _address, jt, IS_HISTORY);
                        int removeTab2 = jt.getSelectedIndex();
                        jt.setSelectedIndex(removeTab2);
                        Component c = jt.getComponentAt(removeTab2);
                        if(c instanceof JTabbedPane){
                            JTabbedPane tmp = (JTabbedPane) c;
                            openProvenanceView(jf, tmp);
                        }
                        pgr.stopProgress();
                    } catch (Exception ex) {
                        if(Controller.debug)ErreurDialog.afficher(jf, "Problem with history", 
                            ex.getMessage(),ex.getStackTrace());
                        else ErreurDialog.afficher(jf, "Problem with history", ex.getMessage());
                     pgr.stopProgress();
                    }
                }
            };
            Thread t = new Thread(go);
            t.start();
        }
    }

    public String getCategory() {
        return this._categ;
    }

    public String getDescription() {
        return this._desript;
    }

    private void openProvenanceView(final JFrame jf, final JTabbedPane tmp) throws Exception {
        
        Component c = tmp.getComponentAt(0);
        if(c instanceof TableView){
            final TableView tv = (TableView) c;

            JScrollPane provenanceview = new JScrollPane();
            ProvenanceView pv = new ProvenanceView(
                    tv.getControl(), 
                    _objectID, 
                    tv.getColumnNames(), 
                    jf, 
                    tmp, 
                    tv.getInfobox(),
                    tv.getData(),
                    _type,
                    IS_HISTORY);

            provenanceview.setViewportView(pv);
            tmp.addTab(
                    PReViewUtilities.getLastPartURL(_objectID.getParameterName()) + " - Provenance", 
                    null, 
                    provenanceview,
                    "This is one Provenance View for "+_objectID.getParameterName());
            tmp.setSelectedIndex(tmp.getTabCount()-1);
            pv.requestFocusInWindow();

            provenanceview.repaint();
        }
    }
}