/*
 * HistoryOpenNew.java
 *
 * Created on 1 septembre 2006, 11:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.history;

import java.awt.Component;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextPane;
import org.pasoa.preview.Controller;
import org.pasoa.preview.OpenStore;
import org.pasoa.preview.treetable.JTreeTable;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.Progression;

/**
 * Implementation of the History Element for the event "print store"
 * @author tibo
 */
public class HistoryPrintStore implements HistoryElement {
    
    private String _name;
    private String _address;
    private String _categ;
    private String _desript;
    private String _type;
    
    /**
     * Creates a new instance of HistoryPrintStore
     * @param add store address
     * @param type can be "text" or "treetable"
     */
    public HistoryPrintStore(String add, String type) {
        this._address = add;
        this._type    = type;
        this._name    = this._address; 
        this._categ   = "print"; 
        this._desript = "Print the full content of a store at " + this._address + " as " + type;
    }
    
    public String getString(){
        return this._name;
    }

    public void action(JFrame jf, JTabbedPane jt) {
        
        int removeTab = -1;
        removeTab = jt.indexOfTab("Full store at "+_address);
        if(removeTab!=-1){
            Component c = jt.getComponentAt(removeTab);

            if(c instanceof JScrollPane){
                JScrollPane tmp = (JScrollPane) c;
                if(tmp.getViewport().getComponentCount() == 1){
                    Component c2 = tmp.getViewport().getComponent(0);
                    if(_type.equals("text")){
                        if(c2 instanceof JTextPane) 
                            jt.setSelectedIndex(removeTab);
                    }
                    else {
                        if(c2 instanceof JTreeTable) 
                            jt.setSelectedIndex(removeTab);
                    }
                }
            }
            //jt.repaint();
        }
        else {
            OpenStore.openFullStore(jf, _address, jt, _type, IS_HISTORY);
        }

    }

    public String getCategory() {
        return this._categ;
    }

    public String getDescription() {
        return this._desript;
    }
}
