/*
 * MyListCellRenderer.java
 *
 * Created on 15 septembre 2006, 11:15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.history;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.ListCellRenderer;

/**
 * a renderer the History dialog
 * @author tibo
 */
   
public class MyListCellRenderer extends JPanel implements ListCellRenderer {

    private JLabel name;
    private JLabel category;
    private JTextArea description;
    private JPanel container;

    public MyListCellRenderer( JList list ) {

         super(new BorderLayout());
         setBorder( BorderFactory.createCompoundBorder(
           BorderFactory.createMatteBorder( 0, 0, 1, 0, Color.lightGray ),
           BorderFactory.createEmptyBorder( 3, 3, 3, 3 ) ) );
         setOpaque( false );

         Font styleSimple = (new JLabel( "font" )).getFont();
         Font styleGras = new Font( styleSimple.getName(),
           Font.BOLD, styleSimple.getSize() );
         Font styleItalik = new Font( styleSimple.getName(),
           Font.ITALIC, styleSimple.getSize() );
         
         name = new JLabel();
         name.setFont( styleGras );
         name.setOpaque( false );

         category = new JLabel();
         category.setFont( styleSimple );
         category.setOpaque( false );

         description = new JTextArea();
         description.setBorder( BorderFactory.createEmptyBorder( 5, 0, 0, 0 ) );
         description.setEditable( false );
         description.setFont( styleItalik );
         description.setOpaque( false );
         description.setLineWrap( true );
         description.setWrapStyleWord( true );

         JPanel p1 = new JPanel( new BorderLayout() );
         p1.add( name, BorderLayout.WEST );
         p1.add( category, BorderLayout.EAST );
         p1.setOpaque( false );

//         JPanel p2 = new JPanel( new BorderLayout() );
//         p2.add( p1, BorderLayout.WEST );
//         p2.setOpaque( false );

         container = new JPanel( new BorderLayout() );
         container.add( p1, BorderLayout.NORTH );
         container.add( description, BorderLayout.SOUTH );
         container.setBorder( BorderFactory.createEmptyBorder( 5, 5, 5, 5 ) );

         Dimension d = description.getPreferredSize();
         int t = description.getFontMetrics(description.getFont()).stringWidth(description.getText());
         t = (t > 0)? t : 300;
         d.setSize(t , d.getHeight() );
         description.setPreferredSize( d );

         add( container, BorderLayout.CENTER );
    }

    public Component getListCellRendererComponent(
          JList list,
          Object value,
          int index,
          boolean isSelected,
          boolean cellHasFocus ) {

         if( isSelected || list.getSelectedIndex()==index ) {
              name.setForeground( list.getSelectionForeground() );
              category.setForeground( list.getSelectionForeground() );
              description.setForeground( list.getSelectionForeground() );
              container.setBackground( list.getSelectionBackground() );
         } else {
              name.setForeground( (new JLabel()).getForeground() );
              category.setForeground( (new JLabel()).getForeground() );
              description.setForeground( (new JLabel()).getForeground() );
              container.setBackground( list.getBackground() );
         }

         if( value instanceof HistoryElement ) {
              HistoryElement elem = (HistoryElement) value;
              name.setText( elem.getString() );
              category.setText( " [ " + elem.getCategory() + " ]" );
              description.setText( elem.getDescription() );

              int largeurTexte = (description.getFontMetrics( description.getFont() )).stringWidth( description.getText() );
              int hauteurFont = description.getFontMetrics( description.getFont() ).getHeight();
              int largeurContainer = (int) description.getPreferredSize().getWidth();
              int hauteurTexte = (int) ( largeurTexte / largeurContainer ) + 1;
              description.setRows( hauteurTexte );

         }

         return this;
    }

}
