/*
 * TreeViewControl.java
 *
 * Created on 24 aot 2006, 15:56
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.provenanceview;

import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.pdf.DefaultFontMapper;
import com.lowagie.text.pdf.PdfContentByte;
import com.lowagie.text.pdf.PdfTemplate;
import com.lowagie.text.pdf.PdfWriter;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.Iterator;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import org.pasoa.preview.AsserterIdentity;
import org.pasoa.preview.Controller;
import org.pasoa.preview.asserterview.AsserterView;
import org.pasoa.preview.tableview.DrawInfoBox;
import org.pasoa.preview.tableview.TableView;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.Progression;
import org.pasoa.pstructure.ObjectID;
import prefuse.controls.ControlAdapter;
import prefuse.data.Edge;
import prefuse.data.Node;
import prefuse.util.ColorLib;
import prefuse.visual.EdgeItem;
import prefuse.visual.VisualItem;

/**
 * a controller for the Collaboration view
 * @author tibo
 */
public class GraphViewControl extends ControlAdapter {
    
    protected CollaborationView _nextview;
   
    /**
     * Creates a new instance of GraphViewControl
     * @param nv a collaboration view
     */
    public GraphViewControl(CollaborationView nv) {
        super();
        this._nextview = nv;
    }

    public void mouseClicked(MouseEvent mouseEvent) {
        //System.out.println("Click!");
    }
    
    public void goToAsserter(final AsserterIdentity ai){
    
        final JScrollPane asserter = new JScrollPane();

        Runnable go = new Runnable() {
            public void run() {
                Progression pgr = new Progression(_nextview._jframe);
                try {
                    pgr.startProgress();
                    AsserterView av = new AsserterView(
                            _nextview._control, ai, _nextview._asserterNames, _nextview._jframe, _nextview._jtabbedpane, _nextview._infobox, _nextview._interactionsDataGrid, false);

                    int removeTab = -1;
                    removeTab = _nextview._jtabbedpane.indexOfTab(ai.getShortName() + "View");
                    if(removeTab!=-1){
                        _nextview._jtabbedpane.removeTabAt(removeTab);
                    }

                    asserter.setViewportView(av);
                    _nextview._jtabbedpane.addTab(
                            ai.getShortName() + "View", 
                            null, 
                            asserter,
                            "This is one Asserter View");
                    _nextview._jtabbedpane.setSelectedIndex(_nextview._jtabbedpane.getTabCount()-1);
                    av.requestFocusInWindow();
                    
                    pgr.stopProgress();

                } catch (Exception ex) {
                    if(Controller.debug)ErreurDialog.afficher(_nextview._jframe, "Unable to initialize Asserterview", 
                        ex.getMessage(),ex.getStackTrace());
                    else ErreurDialog.afficher(_nextview._jframe, "Unable to initialize Asserterview", ex.getMessage());
                    pgr.stopProgress();
                }

                asserter.repaint();
            }
        };
        Thread t = new Thread(go);
        t.start();
    }
    
    public JMenuItem buildInteractionMenu(Edge e){
        Node s = e.getSourceNode();
        Node t = e.getTargetNode();

        final AsserterIdentity sender = (AsserterIdentity) s.get(CollaborationView.ASSERTER_IDENTITY);
        final AsserterIdentity receiver = (AsserterIdentity) t.get(CollaborationView.ASSERTER_IDENTITY) ;

        JMenuItem item = new JMenuItem("from \"" + sender.getShortName() + "\" " +
                "to \"" + receiver.getShortName() + "\"");
        item.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {

                int tableTab = _nextview._jtabbedpane.indexOfTab(TableView.TABLE_NAME);
                if(tableTab != -1){
                    DrawInfoBox dib = new DrawInfoBox(_nextview._infobox, _nextview._control, _nextview._jframe, false, _nextview._jtabbedpane);
                    dib.go(sender, receiver, null);

                    _nextview._jtabbedpane.setSelectedIndex(tableTab);
                }
            }
        }); 
        return item;
              
    }
    
    public void itemClicked(VisualItem visualItem, MouseEvent mouseEvent) {
        if(mouseEvent.isShiftDown()){
            if(visualItem.getGroup().equals(RadialGraphView.treeNodes)){
                
                final JPopupMenu labelPopupMenu = new JPopupMenu();
                final AsserterIdentity ai = (AsserterIdentity) visualItem.get(CollaborationView.ASSERTER_IDENTITY);
                if(ai != null){
                    JMenu AsserterMenu = new JMenu("GoToAsserter");
                    JMenuItem item = new JMenuItem(visualItem.getString(CollaborationView.LABEL));
                    item.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent ae) {
                            goToAsserter(ai);
                        }
                    }); 
                    AsserterMenu.add(item);
                    labelPopupMenu.add(AsserterMenu);
                }
                Iterator iter = ((Node)visualItem).edges();
                JMenu interactionMenu = new JMenu("GoToInteractions");
                int i = 0;
                while(iter.hasNext()){
                    final Edge e = (Edge) iter.next();
                    interactionMenu.add(buildInteractionMenu(e));
                    i++;
                }
                if(i>0) labelPopupMenu.add(interactionMenu);
                labelPopupMenu.show(mouseEvent.getComponent(), mouseEvent.getX(), mouseEvent.getY());
            
            }
        }
    }
    
}
