/*
 * ProvenanceView.java
 *
 * Created on 18 aot 2006, 13:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.provenanceview;

//import com.sleepycat.je.tree.Tree;
import java.awt.BasicStroke;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Vector;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.SwingConstants;
import org.pasoa.accessors.AccessorException;
import org.pasoa.accessors.DataAccessorRegistry;
import org.pasoa.accessors.snxpath.SingleNodeXPathManager;
import org.pasoa.common.BestPractice;
import org.pasoa.preserv.pquery.FullRelationship;
import org.pasoa.preserv.pquery.ProvenanceQueryDeserialiser;
import org.pasoa.preserv.pquery.ProvenanceQueryResults;
import org.pasoa.preview.Controller;
import org.pasoa.preview.View;
import org.pasoa.preview.history.HistoryOpenProvenance;
import org.pasoa.preview.utils.DocumentWrapper;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.PReViewUtilities;
import org.pasoa.preview.utils.Progression;
import org.pasoa.pstructure.GlobalPAssertionKey;
import org.pasoa.pstructure.InteractionKey;
import org.pasoa.pstructure.InteractionRecord;
import org.pasoa.pstructure.ObjectID;
import org.pasoa.pstructure.PAssertionDataKey;
import org.pasoa.pstructure.RelationshipPAssertion;
import org.pasoa.pstructure.SubjectID;
import org.pasoa.pstructure.deserialiser.PStructureDeserialiser;
import org.pasoa.simpledom.DOMWriter;
import org.w3c.dom.Element;
import prefuse.Visualization;
import prefuse.controls.ControlAdapter;
import prefuse.data.Node;
import prefuse.data.Table;
import prefuse.data.Tree;
import prefuse.data.io.TreeMLReader;
import prefuse.render.RendererFactory;
import prefuse.util.ColorLib;
import prefuse.util.FontLib;
import prefuse.util.ui.JFastLabel;
import prefuse.util.ui.JSearchPanel;
import prefuse.visual.VisualItem;


/**
 * The provenance view
 * @author tibo
 */
public class ProvenanceView extends JPanel{
	
    protected Controller    _control;
    protected JFrame        _jframe;
    protected JTabbedPane   _jtabbedpane;
    protected JScrollPane   _infobox;
    protected ObjectID      _ObjectId;
    protected List          _relationships = new LinkedList();
    protected List          _listLeaf = new LinkedList();
    protected List          _listNode = new LinkedList();
    public TreeView      tview = null;
    
    private static Color    BACKGROUND = Color.WHITE;
    private static Color    FOREGROUND = Color.BLACK;
    protected static String label = "name";
    protected static String type = "type";
    protected static String longname = "longname";
    protected static String nbSame = "number";
    
    protected static String OBJECT_ID = "OBJECT_ID";
    protected static String SUBJECT_ID = "SUBJECT_ID";
    protected static String RELATIONSHIP = "RELATIONSHIP";
    protected static String PQUERYMODE = "PQUERYMODE";
    protected static String XQUERYMODE = "XQUERYMODE";
    protected static String XMLMODE = "XMLMODE";
    
    protected String MODE;
    
    protected int currentSameDataItem = 0;
            
    private Tree            m_tree;
    private Node            m_activeNode = null;

    private JSearchPanel    search;
    private Table           m_nodes;

    private Set assertersList = new HashSet();
    private Vector _asserterNames;

    private JFastLabel title = new JFastLabel("                 ");

    private Vector<Vector> interactionsDataGrid;

    private boolean first;

    private InteractionRecord _currentIt;

    /**
     * Creates a new instance of ProvenanceView from an objectID
     * @param control a controller
     * @param obID an objectID
     * @param asserters a vector of all the asserter identity
     * @param jframe main JFrame
     * @param jtabbedpane jtabbedpane which contains this view
     * @param infobox a scrollpane to be abble to open a new infobox
     * @param interactionsDataGrid Vector<Vector<int>> of the number of interaction record between each asserter Identity
     * @param s can be "OBJECT_ID" or "SUBJECT_ID"
     * @param is_history to know if the constructor is called from the history menu
     * @throws java.lang.Exception Exception thrown by the model interface
     */
    public ProvenanceView(Controller control, ObjectID obID, Vector asserters, JFrame jframe,JTabbedPane jtabbedpane,JScrollPane infobox,Vector<Vector> interactionsDataGrid, String s, final boolean is_history) throws Exception {

        this._asserterNames = asserters;
        this._control = control;
        this._jframe = jframe;
        this._jtabbedpane = jtabbedpane;
        this._infobox = infobox;
        this.interactionsDataGrid = interactionsDataGrid;
        this.first = true;
		
        this.MODE = XQUERYMODE;
        
        setOpaque(true);
        setBackground(BACKGROUND);
       
        this._ObjectId = obID;
        
        buildTreeRoot(s);
                
        if(!_relationships.isEmpty()){ 
            
            int max = buildTree(this._relationships, s);
            this.add(buildTreeView(max));
        }
        else {
            this.add(buildTreeView(1));
        }
        
        if(!is_history)
            ((View)_jframe).getHistoryDialog().addElementHistory(new HistoryOpenProvenance(control.address,this._ObjectId, s));
    }
    
    /**
     * Creates a new instance of ProvenanceView from an XML element which contains an objectID
     * @param ObjectId XML element which contains an objectID
     * @param control a controller
     * @param asserters a vector of all the asserter identity
     * @param jframe main JFrame
     * @param jtabbedpane jtabbedpane which contains this view
     * @param infobox a scrollpane to be abble to open a new infobox
     * @param interactionsDataGrid Vector<Vector<int>> of the number of interaction record between each asserter Identity
     * @throws java.lang.Exception Exception thrown by the model interface
     */
    public ProvenanceView(Controller control,JFrame jframe,JTabbedPane jtabbedpane,JScrollPane infobox, Vector asserters, Element ObjectId, Vector<Vector> interactionsDataGrid) throws Exception {
        
        this._asserterNames = asserters;
        this._control = control;
        this._jframe = jframe;
        this._jtabbedpane = jtabbedpane;
        this._infobox = infobox;
        this.interactionsDataGrid = interactionsDataGrid;
        this.first = true;
		
        this.MODE = XQUERYMODE;
        
        setOpaque(true);
        setBackground(BACKGROUND);
       
        PStructureDeserialiser pStructureDeserialiser = new PStructureDeserialiser();
        this._ObjectId = pStructureDeserialiser.deserialiseObjectID(ObjectId);
        
        this._relationships = getRelationships(this._ObjectId);
        
        //System.out.println("Hey !");
        buildTreeRoot(OBJECT_ID);
                
        if(!_relationships.isEmpty()){ 
            
            int max = buildTree(this._relationships, OBJECT_ID);
            this.add(buildTreeView(max));
        }
        else {
            this.add(buildTreeView(1));
        }
        ((View)_jframe).getHistoryDialog().addElementHistory(new HistoryOpenProvenance(control.address,this._ObjectId, OBJECT_ID));
    }

    
    /**
     * Creates a new instance of ProvenanceView from an subjectID
     * @param interactionRecord XML element which contains the interaction record of the given subjectID
     * @param rela XML element which contains the relationship of the given subjectID
     * @param control a controller
     * @param asserters a vector of all the asserter identity
     * @param jframe main JFrame
     * @param jtabbedpane jtabbedpane which contains this view
     * @param infobox a scrollpane to be abble to open a new infobox
     * @param interactionsDataGrid Vector<Vector<int>> of the number of interaction record between each asserter Identity
     * @throws java.lang.Exception Exception thrown by the model interface
     */
    public ProvenanceView(Controller control,JFrame jframe,JTabbedPane jtabbedpane,JScrollPane infobox, Vector asserters,Element interactionRecord, Element rela, Vector<Vector> interactionsDataGrid) throws Exception {
        
        this._asserterNames = asserters;
        this._control = control;
        this._jframe = jframe;
        this._jtabbedpane = jtabbedpane;
        this._infobox = infobox;
        this.interactionsDataGrid = interactionsDataGrid;
        this.first = true;
        
        this.MODE = XQUERYMODE;
        	
        setOpaque(true);
        setBackground(BACKGROUND);
       
        PStructureDeserialiser pStructureDeserialiser = new PStructureDeserialiser();
        InteractionRecord it = pStructureDeserialiser.deserialiseInteractionRecord(interactionRecord);
        RelationshipPAssertion relation = pStructureDeserialiser.deserialiseRelationshipPAssertion(rela);
        SubjectID subject = relation.getSubject();
        GlobalPAssertionKey gpak = new GlobalPAssertionKey(it.getInteractionKey(), "senderViewKind", subject.getLocalPAssertionID());
        this._ObjectId = new ObjectID(gpak, subject.getParameterName(), subject.getDataAccessor(), null);
        
        /* for compare interactionKey */
        //String itKey = new PStructureSerialiser().normaliseInteractionKey(it.getInteractionKey());
        /* dataAccessor */
        
        this._relationships = getRelationships(this._ObjectId);
        
        buildTreeRoot(SUBJECT_ID);
                
        if(!_relationships.isEmpty()){ 
            
            int max = buildTree(this._relationships, SUBJECT_ID);
            this.add(buildTreeView(2));
        }
        else {
            this.add(buildTreeView(1));
        }
        ((View)_jframe).getHistoryDialog().addElementHistory(new HistoryOpenProvenance(control.address,this._ObjectId, SUBJECT_ID));
    }
    
    /**
     * Creates a new instance of ProvenanceView from a xml file
     * @param pQuery a XML element on the PQuery form
     * @param jframe main JFrame
     * @param jtabbedpane jtabbedpane which contains this view
     * @throws java.lang.Exception Exception thrown by the model interface
     */
    public ProvenanceView(JFrame jframe,JTabbedPane jtabbedpane,Element pQuery) throws Exception {
    
        this._jframe = jframe;
        this._jtabbedpane = jtabbedpane;
        	
        this.MODE = XMLMODE;
        
        setOpaque(true);
        setBackground(BACKGROUND);
        
        ProvenanceQueryDeserialiser pqd = new ProvenanceQueryDeserialiser();
        ProvenanceQueryResults pQueryResults = pqd.deserialiseProvenanceQueryResults(pQuery);
        Collection starts = pQueryResults.getStarts();
        if(!starts.isEmpty()) {
            Iterator i = starts.iterator();
            PAssertionDataKey padk = (PAssertionDataKey) i.next();
            Collection fullRelationships = pQueryResults.getFullRelationships();
            DataAccessorRegistry dar = DataAccessorRegistry.getDefaultRegistry();
            if(!fullRelationships.isEmpty()){
                boolean end = false;
                FullRelationship fr = null;
                for(Iterator iter = fullRelationships.iterator(); iter.hasNext() && !end;){
                    fr = (FullRelationship) iter.next();
                    ObjectID o = fr.getSubject();
                    if(o.getGlobalPAssertionKey().equals(padk.getGlobalPAssertionKey())
                        && dar.equalDataAccessors(o.getObjectDataAccessor(), BestPractice.VERBATIM_STYLE,
                            padk.getDataAccessor(), BestPractice.VERBATIM_STYLE))
                        end = true;
                }
                if(end){
                    this._ObjectId = new ObjectID(padk, fr.getObject().getParameterName(), null);
                    buildTreeRoot(SUBJECT_ID);
                    buildTree(getRelationships(fullRelationships, this._ObjectId), fullRelationships, SUBJECT_ID);
                    
                    this.add(buildTreeView(2));
                    
                    
                }
                else {
                    throw new Exception("Can not find SubjectID matching with start.");
                }
            }
        }
    }
    
    /**
     * build the root of the tree
     * @param t can be "OBJECT_ID" or a "SUBJECT_ID"
     */
    public void buildTreeRoot(String t){
        /* Beginning of the tree */
        m_tree = new Tree();
        /* declaration */
        m_nodes = m_tree.getNodeTable();
        m_nodes.addColumn(label, String.class);
        m_nodes.addColumn(type, String.class);
        m_nodes.addColumn(nbSame, Integer.class);
        m_nodes.addColumn(longname, String.class);
        m_nodes.addColumn(OBJECT_ID, ObjectID.class);
        /* end of declaration */
        Node n;
        n = m_tree.addRoot();
        m_activeNode = n;
        m_activeNode.set(label, PReViewUtilities.getLastPartURL(this._ObjectId.getParameterName()));
        m_activeNode.set(type, t);
        m_activeNode.set(nbSame, 0);
        m_activeNode.set(longname, this._ObjectId.getParameterName());
        m_activeNode.set(OBJECT_ID, this._ObjectId);
        /* End of the beginning of the tree */
            
    }
    
    
    public void paint(Graphics g) {
        super.paint(g);
        Graphics2D g2d = (Graphics2D) g;
        //g2d.setStroke(new BasicStroke(2, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        
        if(tview != null) {
            
            Dimension d = new Dimension((int)(_jtabbedpane.getSize().getWidth() - 70) , (int)(_jtabbedpane.getSize().getHeight() - 90));
            title.setSize(new Dimension(d.width, 18));
            title.repaint();
            tview.setSize(d);
            tview.repaint();
        }
        
    }
    
    /**
     * get the all the relationship from the store with the given objetcID
     * @param o an objectID
     * @throws java.lang.Exception Exceptions from model interface
     * @return a list of all the relationship
     */
    public List getRelationships(ObjectID o) throws Exception{
        List r = new LinkedList();
        
        Element tmp = _control.mi.getInteractionRecord(o);
        
        PStructureDeserialiser pStructureDeserialiser = new PStructureDeserialiser();
        
        _currentIt = pStructureDeserialiser.deserialiseInteractionRecord(tmp);
        //System.out.println(DOMWriter.writeToString(interactionRecord, true));
        
        //o.getGlobalPAssertionKey().getLocalPAssertionID().equals();
        
        if(first){
            org.pasoa.pstructure.View receiverV = _currentIt.getReceiverView();
            if(receiverV != null) assertersList.add(new DocumentWrapper(receiverV.getAsserter()));
            first = false;
        }
        org.pasoa.pstructure.View SenderV = _currentIt.getSenderView();
        if(SenderV != null){
            //System.out.print(DOMWriter.writeToString(SenderV.getAsserter(), true));
            assertersList.add(new DocumentWrapper(SenderV.getAsserter()));
            List relationships = SenderV.getRelationshipPAssertions();
            DataAccessorRegistry dar = DataAccessorRegistry.getDefaultRegistry();
            //SingleNodeXPathManager snxm = new SingleNodeXPathManager();
            for (Iterator iter = relationships.iterator(); iter.hasNext();){
                RelationshipPAssertion relationship = (RelationshipPAssertion) iter.next();
                SubjectID subject = relationship.getSubject();
                if(dar.equalDataAccessors(o.getDataAccessor(), BestPractice.VERBATIM_STYLE, subject.getDataAccessor(), BestPractice.VERBATIM_STYLE)){
                    r.add(relationship);
                }
            }
        }
        else {
            JOptionPane.showMessageDialog(this, "No sender view for the interactionRecord");
        }
    
        return r;
    }

    /**
     * get the all the relationship from the xml file with the given objetcID
     * @param fullRelationships all the relationship from the file
     * @param starting an objectID
     * @throws java.lang.Exception Exceptions
     * @return a list of all the relationship
     */
    public Map getRelationships(Collection fullRelationships, ObjectID starting) throws Exception{
        FullRelationship fr = null;
        
        Map<String, List<FullRelationship>> list = new HashMap<String, List<FullRelationship>>();
        DataAccessorRegistry dar = DataAccessorRegistry.getDefaultRegistry();
        
        for(Iterator iter = fullRelationships.iterator(); iter.hasNext();){
            fr = (FullRelationship) iter.next();   
            ObjectID currentSubjectID = fr.getSubject();
            if(currentSubjectID != null){
                if(currentSubjectID.getGlobalPAssertionKey().equals(starting.getGlobalPAssertionKey())
                        && dar.equalDataAccessors(currentSubjectID.getObjectDataAccessor(), BestPractice.VERBATIM_STYLE, starting.getObjectDataAccessor(), BestPractice.VERBATIM_STYLE)){
                
                    String lpaid = fr.getLocalPAssertionID();
                    if(!list.containsKey(lpaid)){
                        list.put(lpaid, new LinkedList());
                    }

                    list.get(lpaid).add(fr);
                    
                }
            }
        }
        return list;
    }

        
    /**
     * build the tree from the xml file
     */
    public int buildTree(Map relas, Collection fullRelationships, String t) throws Exception{
        Node n;
        
        for(Iterator iter = relas.keySet().iterator(); iter.hasNext(); ){
            String r = (String)iter.next();

            List<FullRelationship> relationships = (List<FullRelationship>)relas.get(r);
            boolean first = true;
            for(FullRelationship fr : relationships){
                if(first){
                    first = false;
                    
                    if(t.equals(OBJECT_ID)){
                        /* SubjectId */
                        ObjectID tmp = fr.getSubject();
                        n = m_tree.addChild(m_activeNode);
                        m_activeNode = n;
                        m_activeNode.set(label, PReViewUtilities.getRelationName(tmp.getParameterName()));
                        m_activeNode.set(longname, tmp.getParameterName());
                        m_activeNode.set(type, this.SUBJECT_ID);
                    }
                    
                    n = m_tree.addChild(m_activeNode);
                    m_activeNode = n;
                    m_activeNode.set(label, PReViewUtilities.getRelationName(fr.getRelation()));
                    m_activeNode.set(longname, fr.getRelation());
                    m_activeNode.set(type, this.RELATIONSHIP);
                }
                
                ObjectID tmp = fr.getObject();
                
                Node node = getSameDataItem(tmp);
                n = m_tree.addChild(m_activeNode);
                m_activeNode = n;
                
                if(node == null){
                    m_activeNode.set(nbSame, 0);
                    m_activeNode.set(label, PReViewUtilities.getRelationName(tmp.getParameterName()));
                }
                else {
                    int nb = (Integer)(node.get(nbSame));
                    /* Add a edge between these two node... Doesn't work*/
                    //m_tree.addEdge(node, m_activeNode);
                    if(nb == 0){
                        currentSameDataItem ++;
                        node.set(nbSame, currentSameDataItem);
                        node.set(label, currentSameDataItem + "- " + node.get(label));
                        m_activeNode.set(nbSame, currentSameDataItem);
                        m_activeNode.set(label, currentSameDataItem + "- " + PReViewUtilities.getRelationName(tmp.getParameterName()));
                    }
                    else {
                        m_activeNode.set(nbSame, nb);
                        m_activeNode.set(label, nb + "- " + PReViewUtilities.getRelationName(tmp.getParameterName()));
                    }
                }
                //m_activeNode.set(label, PReViewUtilities.getLastPartURL(tmp.getParameterName()));
                m_activeNode.set(longname, tmp.getParameterName());
                m_activeNode.set(type, this.OBJECT_ID);
                m_activeNode.set(OBJECT_ID, tmp);
                /* Recursive tree building */
                 buildTree(getRelationships(fullRelationships, tmp), fullRelationships, OBJECT_ID);
                
                m_activeNode = m_activeNode.getParent();
            }
            m_activeNode = m_activeNode.getParent();
            if(t.equals(OBJECT_ID)){m_activeNode = m_activeNode.getParent();}
        }
        return 1;
    }
    
    
    /**
     * build the tree from a list of relationship
     */
    public int buildTree(List relas, String t) throws Exception{
        Node n;
        
        int j = 0;
        int i = 0;
        for(Iterator iter = relas.iterator(); iter.hasNext(); i++){
            RelationshipPAssertion r = (RelationshipPAssertion)iter.next();

            if(t.equals(OBJECT_ID)){
                /* add SubjectId */
                SubjectID s = r.getSubject();
               
                n = m_tree.addChild(m_activeNode);
                m_activeNode = n;
                
                //m_activeNode.set(nbSame, 0);
                m_activeNode.set(label, PReViewUtilities.getRelationName(s.getParameterName()));
                m_activeNode.set(longname, s.getParameterName());
                m_activeNode.set(type, SUBJECT_ID);
                
                GlobalPAssertionKey gpak = new GlobalPAssertionKey(_currentIt.getInteractionKey(), "senderViewKind", s.getLocalPAssertionID());
                m_activeNode.set(OBJECT_ID, new ObjectID(gpak, s.getParameterName(), s.getDataAccessor(), null));
                

                /* End SubjectId */
            }
            n = m_tree.addChild(m_activeNode);
            
            m_activeNode = n;
            
            m_activeNode.set(label, PReViewUtilities.getRelationName(r.getRelation()));
            m_activeNode.set(longname, r.getRelation());
            m_activeNode.set(type, this.RELATIONSHIP);
            
            /* get ObjectIds = leafs */
            List listObjectsId = r.getObjectIDs();
            int j2 =0;
            for(Iterator iterObject = listObjectsId.iterator(); iterObject.hasNext();j2++){
                ObjectID tmpO = (ObjectID) iterObject.next();
                
                Node node = getSameDataItem(tmpO);
                
                n = m_tree.addChild(m_activeNode);
                m_activeNode = n;
                
                if(node == null){
                    m_activeNode.set(nbSame, 0);
                    m_activeNode.set(label, PReViewUtilities.getRelationName(tmpO.getParameterName()));
                }
                else {
                    int nb = (Integer)(node.get(nbSame));
                    if(nb == 0){
                        currentSameDataItem ++;
                        node.set(nbSame, currentSameDataItem);
                        node.set(label, currentSameDataItem + "- " + node.get(label));
                        m_activeNode.set(nbSame, currentSameDataItem);
                        m_activeNode.set(label, currentSameDataItem + "- " + PReViewUtilities.getRelationName(tmpO.getParameterName()));
                    }
                    else {
                        m_activeNode.set(nbSame, nb);
                        m_activeNode.set(label, nb + "- " + PReViewUtilities.getRelationName(tmpO.getParameterName()));
                    }
                }

                m_activeNode.set(longname, tmpO.getParameterName());
                m_activeNode.set(type, OBJECT_ID);
                m_activeNode.set(OBJECT_ID, tmpO);
                
                _listLeaf.add(tmpO);
                _listNode.add(m_activeNode);
                /* Create the full tree recursivly */
//                List tmpL = getRelationships(tmpO);
//                if(!tmpL.isEmpty()) {
//                    buildTree(tmpL);
//                }
                
                m_activeNode = m_activeNode.getParent();
            }
            j = Math.max(j, j2);
            /* end of ObjectIds */
            
            m_activeNode = m_activeNode.getParent();
            if(t.equals(OBJECT_ID)) m_activeNode = m_activeNode.getParent();
            
        }
        
        return Math.max(i, j);
    }
    
    /**
     * compare the data to know if there is more one time the same data item
     */
    public Node getSameDataItem(ObjectID s ) throws AccessorException{
        
        DataAccessorRegistry dar = DataAccessorRegistry.getDefaultRegistry();
        for(Iterator tmp = m_tree.nodes(); tmp.hasNext();){
            Node node = (Node) tmp.next();
            /* Have a look only on ObjectID */
            //if(node.get(type).equals(SUBJECT_ID) || 
            if(node.get(type).equals(OBJECT_ID)){
                ObjectID o = (ObjectID) node.get(OBJECT_ID);
                if(dar.equalDataAccessors(o.getObjectDataAccessor(), BestPractice.VERBATIM_STYLE, s.getObjectDataAccessor(), BestPractice.VERBATIM_STYLE) 
                    && o.getGlobalPAssertionKey().getInteractionKey().equals(s.getGlobalPAssertionKey().getInteractionKey())){
                    return node;
                }
            }
        }
       return null;
    }
    
    /**
     * create the tree view
     */
    public JComponent buildTreeView(int max) {
        
        // create a new treemap
        tview = new TreeView(m_tree, label, max, this);
        //System.out.println(_jtabbedpane.getPreferredSize() +" --- "+ _jtabbedpane.getSize());
        tview.setBackground(BACKGROUND);
        tview.setForeground(FOREGROUND);
        
        // create a search panel for the tree map
        search = new JSearchPanel(tview.getVisualization(),
            TreeView.treeNodes, Visualization.SEARCH_ITEMS, label, true, true);
        search.setShowResultCount(true);
        search.setBorder(BorderFactory.createEmptyBorder(5,5,4,0));
        search.setFont(FontLib.getFont("Tahoma", Font.PLAIN, 11));
        search.setBackground(BACKGROUND);
        search.setForeground(FOREGROUND);
        
        title.setVerticalAlignment(SwingConstants.TOP);
        title.setBorder(BorderFactory.createEmptyBorder(3,0,0,0));
        title.setFont(FontLib.getFont("Tahoma", Font.PLAIN, 12));
        title.setPreferredSize(new Dimension((int)title.getFontMetrics(title.getFont()).stringWidth("                 "), 18));
        title.setBackground(BACKGROUND);
        title.setForeground(FOREGROUND);
        
        tview.addControlListener(new ControlAdapter() {
            public void itemEntered(VisualItem item, MouseEvent e) {
                if ( item.canGetString(label) ){
                    String o = (String) item.get(type);
                    //title.setSize(new Dimension(
                    //        (int)title.getFontMetrics(title.getFont()).stringWidth("                " + item.getString(longname)), 16));
                    if(o.equals(OBJECT_ID))  title.setText("ObjectID : " + item.getString(longname));
                    else if(o.equals(SUBJECT_ID)) title.setText("SubjectID : " + item.getString(longname));
                    else title.setText("Relationship : " + item.getString(longname));
                }
            }
            public void itemExited(VisualItem item, MouseEvent e) {
                title.setText(null);
            }
        });
        
        Box box = new Box(BoxLayout.X_AXIS);
        
        if(!MODE.equals(XMLMODE)){
            JButton nextView = new JButton("CollaborationView");
            nextView.setVerticalAlignment(SwingConstants.BOTTOM);
            nextView.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    gotoNextView();
                }
            });
            box.add(nextView);
            JButton fullView = new JButton("Full expanded Tree");
            fullView.setVerticalAlignment(SwingConstants.BOTTOM);
            fullView.setToolTipText("It could take a long time to get the full tree..");
            fullView.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    /**/
                    int tmp = JOptionPane.showConfirmDialog(_jframe, "It may take a long time, do you want to continue ?", "Are you sure ?", JOptionPane.YES_NO_OPTION);
                    if(tmp == JOptionPane.YES_OPTION){
                        Runnable go = new Runnable() {
                            public void run() {
                                Progression pgr = new Progression(_jframe);
                                Controller control;
                                try {
                                    pgr.startProgress();
                                    /**/
                                    for(Iterator iterObject = _listLeaf.iterator(); iterObject.hasNext(); iterObject = _listLeaf.iterator()){
                                        ObjectID tmp = (ObjectID) iterObject.next();
                                        addBranch(tmp);
                                    }
                                    pgr.stopProgress();
                                } catch (Exception ex) {
                                    if(Controller.debug)ErreurDialog.afficher(_jframe, "Problem during the all provenance", 
                                        ex.getMessage(),ex.getStackTrace());
                                    else ErreurDialog.afficher(_jframe, "Problem during the all provenance", ex.getMessage());
                                    pgr.stopProgress();
                                }

                                tview.getVisualization().run("filter");
                            }
                        };
                        Thread t = new Thread(go);
                        t.start();
                    }
                }
            });
            box.add(fullView);
        }
        //box.add(Box.createHorizontalStrut(10));
        box.add(Box.createHorizontalGlue());
        box.add(search);
        //box.add(Box.createHorizontalStrut(3));
        box.setBackground(BACKGROUND);
        
        Box box2 = new Box(BoxLayout.X_AXIS);
        box2.add(title);
        box2.setBackground(BACKGROUND);
        
        JPanel panel = new JPanel(new BorderLayout());
        panel.setBackground(BACKGROUND);
        panel.setForeground(FOREGROUND);
        panel.add(tview, BorderLayout.CENTER);
        panel.add(box, BorderLayout.SOUTH);
        panel.add(box2, BorderLayout.NORTH);
        return panel;
    }
    
    /**
     * go to the collaboration view
     */
    public void gotoNextView(){
        
        final JScrollPane nextview = new JScrollPane();

        Runnable go = new Runnable() {
            public void run() {
                Progression pgr = new Progression(_jframe);
                try {
                    pgr.startProgress();
                    /* Nextview */
                    String longName = m_tree.getRoot().get(longname).toString();
                    String rootName = m_tree.getRoot().get(label).toString();
                    CollaborationView nv = new CollaborationView(
                            _control, _jframe, 
                            _jtabbedpane, _infobox, 
                            _asserterNames, assertersList, 
                            interactionsDataGrid, rootName, longName, false);
                    int removeTab = -1;
                    removeTab = _jtabbedpane.indexOfTab(rootName + " - Collaboration");
                    if(removeTab!=-1){
                        _jtabbedpane.removeTabAt(removeTab);
                    }

                    nextview.setViewportView(nv);
                    _jtabbedpane.addTab(
                            rootName + " - Collaboration", 
                            null, 
                            nextview,
                            "This is one Collaboration View for "+longName);
                    _jtabbedpane.setSelectedIndex(_jtabbedpane.getTabCount()-1);
                    nv.requestFocusInWindow();
                    
                    pgr.stopProgress();

                } catch (Exception ex) {
                    if(Controller.debug)ErreurDialog.afficher(_jframe, "Unable to initialize CollaborationView", 
                        ex.getMessage(),ex.getStackTrace());
                    else ErreurDialog.afficher(_jframe, "Unable to initialize CollaborationView", ex.getMessage());
                    pgr.stopProgress();
                }

                nextview.repaint();
            }
        };
        Thread t = new Thread(go);
        t.start();
    }

    /**
     * add a branch to the tree
     * @param o a clicked objectID 
     */
    public void addBranch(final ObjectID o){
        boolean test = true;
        int i = 0;
        for(Iterator iterObject = _listLeaf.iterator(); iterObject.hasNext() && test ; i++){
            ObjectID tmpO = (ObjectID) iterObject.next();
            if(tmpO == o) {
                final int index = i;
                //System.out.println("addBranch !");
                test = false;
				
                tview.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

                try {
                    _relationships = getRelationships(o);

                    if(!_relationships.isEmpty()){ 
                        m_activeNode = (Node) _listNode.get(index);
                        int max = buildTree(_relationships, OBJECT_ID);
                        _listLeaf.remove(index);
                        _listNode.remove(index);
                        tview._max = max;
                        tview._t = m_tree;
                        search = new JSearchPanel(tview.getVisualization(),
                                TreeView.treeNodes, Visualization.SEARCH_ITEMS, label, true, true);
                        tview.fishEye.setDistance(m_tree.getNodeCount());
                        //System.out.println(m_tree.getNodeCount() +" ; "+m_tree.getEdgeCount());

                    }
                    else {
                        _listLeaf.remove(index);
                        _listNode.remove(index);
                    }

                    tview.setCursor(Cursor.getDefaultCursor());
                    
                } catch (Exception ex) {
                    if(Controller.debug)ErreurDialog.afficher(_jframe, "Error while getting news relationship from an ObjectID", 
                            ex.getMessage(),ex.getStackTrace());
                    else ErreurDialog.afficher(_jframe, "Error while getting news relationship from an ObjectID", ex.getMessage());
                    tview.setCursor(Cursor.getDefaultCursor());
                }
            }
        }
    }
    
}
