/*
 * TreeViewControl.java
 *
 * Created on 24 aot 2006, 15:56
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.provenanceview;

import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.pdf.DefaultFontMapper;
import com.lowagie.text.pdf.PdfContentByte;
import com.lowagie.text.pdf.PdfTemplate;
import com.lowagie.text.pdf.PdfWriter;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.pasoa.accessors.DataAccessorRegistry;
import org.pasoa.accessors.XPath;
import org.pasoa.common.Constants;
import org.pasoa.preview.Controller;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.pstructure.ActorStatePAssertion;
import org.pasoa.pstructure.InteractionPAssertion;
import org.pasoa.pstructure.InteractionRecord;
import org.pasoa.pstructure.ObjectID;
import org.pasoa.pstructure.SubjectID;
import org.pasoa.pstructure.deserialiser.PStructureDeserialiser;
import org.pasoa.simpledom.DOMDeserialiser;
import org.pasoa.simpledom.DOMWriter;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import prefuse.controls.ControlAdapter;
import prefuse.util.ColorLib;
import prefuse.visual.VisualItem;

/**
 * A controller for mouse event in the provenance view.
 * @author tibo
 */
public class TreeViewControl extends ControlAdapter {
    
    protected ProvenanceView _provenanceview;
   
    /**
     * Creates a new instance of TreeViewControl
     * @param pv Corresponding ProvenanceView
     */
    public TreeViewControl(ProvenanceView pv) {
        super();
        this._provenanceview = pv;
    }

    /**
     * Interface method
     * @param mouseEvent mouse event
     */
    public void mouseClicked(MouseEvent mouseEvent) {
        //System.out.println("Hey !");
    }

    /**
     * Print the content of a given data item. 
     * Called when the user hold "shift" key and left click on a data item in the provenance view.
     * @param visualItem given data item
     * @throws java.lang.Exception from the CSL
     */
    public void printContentDataItem(VisualItem visualItem) throws Exception{
        String o = (String) visualItem.get(ProvenanceView.type);
        List l = new LinkedList();
        if(o.equals(ProvenanceView.OBJECT_ID) || o.equals(ProvenanceView.SUBJECT_ID)) {
            ObjectID ob = (ObjectID) visualItem.get(ProvenanceView.OBJECT_ID);
            Element tmp = _provenanceview._control.mi.getInteractionRecord(ob);
            PStructureDeserialiser pStructureDeserialiser = new PStructureDeserialiser();
            InteractionRecord inteRecord = pStructureDeserialiser.deserialiseInteractionRecord(tmp);

            org.pasoa.pstructure.View view = null;
            //System.out.println(ob.getGlobalPAssertionKey().getViewKind());
            if(ob.getGlobalPAssertionKey().getViewKind().contains("eceiver")){
                view = inteRecord.getReceiverView();
            }
            else {
                view = inteRecord.getSenderView();
            }
            if(view != null) {
                l = view.getInteractionPAssertions();
            }
            boolean end = false;
            InteractionPAssertion intePAssert = null;
            for(Iterator iter = l.iterator(); iter.hasNext() && !end;){
                intePAssert = (InteractionPAssertion) iter.next();
                if(intePAssert.getLocalPAssertionID().equals(ob.getGlobalPAssertionKey().getLocalPAssertionID()))
                    end = true;
            }
            if(end){
                /* Get the good piece of XML from the ObjectID XPath */
//                Element dataAccessor = ob.getObjectDataAccessor();
//                if(dataAccessor != null){
//                    XPath xPath = DataAccessorRegistry.createDefaultRegistry().convertToXPath(dataAccessor);
//                    DOMDeserialiser reader = new DOMDeserialiser (Constants.PSTRUCT_NS);
//                    Element content = reader.single (reader.single (((InteractionPAssertion) intePAssert).getContent (), "content")); 
//                    System.out.println(DOMWriter.writeToString(content, true));
//                    System.out.println(xPath.getPath());
//                    System.out.println(xPath.getNamespaces());
//                    Collection Lelem = org.pasoa.preserv.xquery.laxquery.XPathUtilities.resolveNodeSet(
//                            content, 
//                            xPath.getPath(), 
//                            xPath.getNamespaces());
////                    List Lelem = org.pasoa.util.xpath.jaxen.XPathUtilities.resolveNodeSet(
////                            content, 
////                            xPath.getPath(), 
////                            xPath.getNamespaces());
//                    System.out.println(Lelem.size());
//                    DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
//                    factory.setNamespaceAware(true);
//                    DocumentBuilder builder = factory.newDocumentBuilder();
//                    org.w3c.dom.Document doc = builder.newDocument();
//                    Element racine = doc.createElement("racine");
//                    for(Iterator iter = Lelem.iterator(); iter.hasNext();){
//                        racine.appendChild((Element) iter.next());
//                        doc.appendChild(racine);
//                    }
//                    //System.out.println(DOMWriter.writeToString(racine, true));
//                    //Element e = (Element) Lelem.get(0);
//                    //System.out.println(DOMWriter.writeToString(e, true));
//                }
//                else {
                    Element dataAccessor = ob.getObjectDataAccessor();
                    String s = "InteractionPAssertion " + intePAssert.getLocalPAssertionID();
                    if(dataAccessor != null){
                        XPath xPath = DataAccessorRegistry.getDefaultRegistry().convertToXPath(dataAccessor);
                        s = xPath.getPath();
                    }
                    new PopupPAssertionWindow(
                            _provenanceview._jframe, 
                            intePAssert.getContent(), 
                            s);
                    //System.out.println(DOMWriter.writeToString(intePAssert.getContent(), true));
//                }
            }
            else {
                if(view != null) {
                    l = view.getActorStatePAssertions();
                }
                ActorStatePAssertion actorPAssert = null;
                for(Iterator iter = l.iterator(); iter.hasNext() && !end;){
                    actorPAssert = (ActorStatePAssertion) iter.next();
                    if(actorPAssert.getLocalPAssertionID().equals(ob.getGlobalPAssertionKey().getLocalPAssertionID()))
                        end = true;
                }
                if(end){
                    /* Do the same as before to get only the good xml thing from the ObjectID Xpath */
                    Element dataAccessor = ob.getObjectDataAccessor();
                    String s = "ActorStatePAssertion " + actorPAssert.getLocalPAssertionID();
                    if(dataAccessor != null){
                        XPath xPath = DataAccessorRegistry.getDefaultRegistry().convertToXPath(dataAccessor);
                        s = xPath.getPath();
                    }
                    new PopupPAssertionWindow(
                            _provenanceview._jframe, 
                            actorPAssert.getContent(), 
                            s);
                }
                else{
                    JOptionPane.showMessageDialog(
                            _provenanceview, 
                            "Cannot find any PAssertion for the localPAssertionID : " + ob.getGlobalPAssertionKey().getLocalPAssertionID());
                }
            }
        }
    }
    
    /**
     * Get the item clicked and called the good action to use with it.
     * You can add a branch to a leaf.
     * You can display the content of a data item.
     * @param visualItem visual object clicked
     * @param mouseEvent event from mouse
     */
    public void itemClicked(VisualItem visualItem, MouseEvent mouseEvent) {
        if(!_provenanceview.MODE.equals(ProvenanceView.XMLMODE) 
                && visualItem.getGroup().equals(TreeView.treeNodes)
                && SwingUtilities.isLeftMouseButton(mouseEvent)
                && mouseEvent.isShiftDown()){
            _provenanceview.tview.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
            try {
                printContentDataItem(visualItem);
                _provenanceview.tview.setCursor(Cursor.getDefaultCursor());
            } catch (Exception ex) {
                if(Controller.debug)ErreurDialog.afficher(_provenanceview._jframe, "Error while getting news relationship from an ObjectID", 
                        ex.getMessage(),ex.getStackTrace());
                else ErreurDialog.afficher(_provenanceview._jframe, "Error while getting news relationship from an ObjectID", ex.getMessage());
                _provenanceview.tview.setCursor(Cursor.getDefaultCursor());
            }
        
        }
        else{
            if(_provenanceview.MODE.equals(ProvenanceView.XQUERYMODE)
                    && visualItem.getGroup().equals(TreeView.treeNodes)){
                String o = (String) visualItem.get(ProvenanceView.type);
                if(o.equals(ProvenanceView.OBJECT_ID)) {
    //                int tmp = visualItem.getTextColor();
    //                int t = ColorLib.color(Color.RED);
    //                visualItem.setTextColor(t);
    //                visualItem.getVisualization().repaint();

                    _provenanceview.addBranch((ObjectID) visualItem.get(ProvenanceView.OBJECT_ID));
                }
            }
        }
    }
    
}
