/*
 * DrawInfoBox.java
 *
 * Created on 10 aot 2006, 18:02
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.tableview;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Iterator;
import java.util.Vector;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;
import javax.swing.ScrollPaneLayout;
import javax.swing.SwingUtilities;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import org.pasoa.common.Constants;
import org.pasoa.preview.*;
import org.pasoa.preview.history.HistoryChangeInteractionInfobox;
import org.pasoa.preview.history.HistoryOpenInfobox;
import org.pasoa.preview.treetable.MyTreeTable;
import org.pasoa.preview.treetable.TreeTableModel;
import org.pasoa.preview.treetable.TreeTableUtilities;
import org.pasoa.preview.treetable.XMLTreeTableCellRenderer;
import org.pasoa.preview.treetable.XMLTreeTableModel;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.Progression;
import org.pasoa.simpledom.DOMDeserialiser;
import org.pasoa.simpledom.DOMWriter;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * to draw an infobox
 * @author tibo
 */
public class DrawInfoBox {
    
    protected JScrollPane sp;
    protected Controller control;
    protected Element interaction;
    protected Vector interactionList;

    private JFrame jf;

    private AsserterIdentity sender; 
    private AsserterIdentity receiver;
    private int position = -1;
    private String interactId = null;
    private boolean is_history;
    private TableView tv = null;
    /**
     * Creates a new instance of DrawInfobox
     * @param sp JScrollPane which contains this infobox
     * @param c the controller
     * @param jf main JFrame
     * @param is_history if this constructor is called from the history menu
     * @param jtp the JTabbedPane which contains this infobox
     */
    public DrawInfoBox(JScrollPane sp, Controller c, JFrame jf, boolean is_history, JTabbedPane jtp){
        this.sp = sp;
        this.control = c;
        this.jf = jf;
        this.is_history = is_history;
        
        if(jtp != null){
            Component c1 = jtp.getComponentAt(0);
            if(c1 instanceof TableView){
                tv = (TableView) c1;
            }
        }
    }
 
    public void go(AsserterIdentity send, AsserterIdentity rec, String intId) {
        
        this.sender = send;
        this.receiver = rec;
        if(tv != null){
            tv.changeSelectedIndex(send, rec);
        }
        
        if(intId == null) this.position = 0;
        else this.interactId = intId;
        
        Runnable go = new Runnable() {
            public void run() {
                Progression pgr = new Progression(jf);
                try {

                    
                    
                    sp.setVisible(true);
                    
                    jScrollPane1 = new javax.swing.JScrollPane();
                    jTabbedPane1 = new javax.swing.JTabbedPane();
                    jScrollPane2 = new javax.swing.JScrollPane();
                    jTextArea2 = new javax.swing.JTextArea();
                    jScrollPane3 = new javax.swing.JScrollPane();

                    
                    pgr.startProgress();
                    fillinInteractionList(sender, receiver);
                    if (interactId != null && interactionList.contains(interactId))
                        position = interactionList.indexOf(interactId);
                    else position = 0;
                    
                    fillinIt(sender, receiver, position);

                    final javax.swing.JList jList1 = new javax.swing.JList();

                    jList1.setModel(new javax.swing.AbstractListModel() {
                        public int getSize() { return interactionList.size(); }
                        public Object getElementAt(int i) { return "Interaction (" + interactionList.elementAt(i) + ")"; }
                    });
                    jList1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                    jList1.setSelectedIndex(position);


                    MouseListener mouselistener = new MouseAdapter(){
                        public void mouseClicked(MouseEvent e){
                            if( e.getClickCount() == 2){
                                final int index = jList1.locationToIndex( e.getPoint());
                                Runnable go = new Runnable() {
                                    public void run() {
                                        Progression pgr = new Progression(jf);
                                        try {
                                            //System.out.println("edt : " + SwingUtilities.isEventDispatchThread());
                                            pgr.startProgress();
                                            String id = fillinIt(sender, receiver, index);   
                                            ((View)jf).getHistoryDialog().addElementHistory(new HistoryChangeInteractionInfobox(control.address, sender, receiver, id));
                                            pgr.stopProgress();
                                        } catch (Exception ex) {
                                            if(Controller.debug)ErreurDialog.afficher(jf, "An error has occured while infobox initialisation", 
                                                ex.getMessage(),ex.getStackTrace());
                                            else ErreurDialog.afficher(jf, "An error has occured while infobox initialisation", ex.getMessage());
                                            pgr.stopProgress();
                                        }
                                        sp.repaint();
                                    }
                                };
                                Thread t = new Thread(go);
                                t.start();
                            }
                        }
                    };
                    jList1.addMouseListener(mouselistener);
                    //jScrollPane1.setPreferredSize(new Dimension(100, 50));
                    jScrollPane1.setViewportView(jList1);

                    //jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
                    //jScrollPane1.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);

                    jTabbedPane1.addTab("Node mode", jScrollPane3);
                    jTabbedPane1.addTab("Text mode", jScrollPane2);

                    JSplitPane hSplitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
                                           jScrollPane1, 
                                           jTabbedPane1);

                    sp.setViewportView(hSplitPane);
                    
                    sp.requestFocusInWindow();
                    sp.repaint();
                    sp.getParent().repaint();

                    if(!is_history)((View)jf).getHistoryDialog().addElementHistory(new HistoryOpenInfobox(control.address,sender, receiver));
                    pgr.stopProgress();

                } catch (Exception ex) {
                    if(Controller.debug)ErreurDialog.afficher(jf, "Unable to initialize infobox", 
                        ex.getMessage(),ex.getStackTrace());
                    else ErreurDialog.afficher(jf, "Unable to initialize infobox", ex.getMessage());
                    pgr.stopProgress();

                }
                
            }
        };
        Thread t = new Thread(go);
        t.start();
        
    }
    
    protected String fillinIt(AsserterIdentity sender, AsserterIdentity receiver, int ID) throws Exception{


        String intID = interactionList.elementAt(ID).toString();
        //System.out.println( interactionList.elementAt(0));
        interaction = control.mi.getInteractionRecordBetween(
                    sender, receiver, intID);

        //System.out.println(DOMWriter.writeToString(interaction, true));
        jTextArea2.setEditable(false);
        jTextArea2.setText(DOMWriter.writeToString(interaction, true));
        
        jScrollPane2.setPreferredSize(new Dimension(1, 1));
        jScrollPane2.setViewportView(jTextArea2);
        jTextArea2.setCaretPosition(0);
        jTextArea2.requestFocusInWindow();
        xmltreetablemodel = new XMLTreeTableModel(interaction);
        treeTable = new MyTreeTable(xmltreetablemodel, jf);
        treeTable.getTree().setCellRenderer(new XMLTreeTableCellRenderer());
        
        jScrollPane3.setPreferredSize(new Dimension(1, 1));
        jScrollPane3.setViewportView(treeTable);
        
//        jScrollPane2.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
//        jScrollPane2.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        
//        jScrollPane3.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
//        jScrollPane3.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        return intID;
    }

    
    
    protected void fillinInteractionList(AsserterIdentity sender, AsserterIdentity receiver) throws Exception{
        interactionList = control.mi.getAllInteractionsRecordBetween(sender,receiver);  
    }

    
    // Variables declaration - do not modify  
     /* TreeTable */
    private XMLTreeTableModel xmltreetablemodel;
    private MyTreeTable treeTable = null;

    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea2;
    // End of variables declaration
}
