/*
 * Infobox.java
 *
 * Created on 19 juillet 2006, 11:58
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.tableview;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Iterator;
import java.util.Vector;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;
import javax.swing.ScrollPaneLayout;
import javax.swing.SwingUtilities;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import org.pasoa.common.Constants;
import org.pasoa.preview.*;
import org.pasoa.preview.treetable.MyTreeTable;
import org.pasoa.preview.treetable.XMLTreeTableCellRenderer;
import org.pasoa.preview.treetable.XMLTreeTableModel;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.Progression;
import org.pasoa.simpledom.DOMDeserialiser;
import org.pasoa.simpledom.DOMWriter;
import org.w3c.dom.Element;

/**
 * a cell listener for the main table.
 * @author tibo
 */
public class Infobox extends MouseAdapter {
    
    protected JScrollPane sp;
    protected Controller control;
    private Vector columnNames;

    private JFrame jf;

    /**
     * Creates a new instance of Infobox
     * @param sp JScrollPane which contains the infobox
     * @param c a controller
     * @param ColumnNames a vector wich contains all the asserter identity
     * @param jf main JFrame
     */
    public Infobox(JScrollPane sp, Controller c, Vector ColumnNames, JFrame jf){
        this.sp = sp;
        this.control = c;
        this.columnNames = ColumnNames;
        this.jf = jf;
    }
 
    public void mouseClicked(java.awt.event.MouseEvent e) {
        if ( e.getClickCount() == 1 ) {
            JTable jt = (JTable) e.getSource();
            int rowIndex = jt.getSelectedRow();
            int colIndex = jt.getSelectedColumn();
            
            if(jt.getValueAt(rowIndex, colIndex).equals("X")){
                
                AsserterIdentity sender;
                AsserterIdentity receiver;
                sender = ((AsserterIdentity)columnNames.elementAt(rowIndex));
                receiver = ((AsserterIdentity)columnNames.elementAt(colIndex));
                  
                /* Code InfoBox */
                DrawInfoBox dib = new DrawInfoBox(sp, control, jf, false, null);
                
                dib.go(sender, receiver, null);

                sp.repaint();
                sp.getParent().repaint();
            }
            else
            { 
                sp.setVisible(false);
                sp.repaint();
            }    
        }
    }
}
