/*
 * Mytable.java
 *
 * Created on 14 juillet 2006, 10:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.tableview;

/**
 *
 * @author tibo
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.AffineTransform;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*; 
import org.pasoa.preview.*;

//new original class for own table stuff
/**
 * a JTable which look like a header to be the row header
 * @author tibo
 */
class Mytable extends JTable
{
    private JTable table;
    private Vector columnNames;
    private JTabbedPane jtp;
    private Controller control;
    private JFrame jf;

    private JScrollPane infobox;

    private Vector<Vector> interactionsDataGrid;
    
    public Mytable(JTable table, Vector ColumnNames, JTabbedPane jtp, Controller control, JFrame jf, JScrollPane infobox, Vector<Vector> interactionsDataGrid) {
        
        //custom table settings here
        super();
        
        this.jf = jf;
        this.jtp = jtp;
        this.control = control;
        this.columnNames = ColumnNames;
        this.infobox = infobox;
        this.interactionsDataGrid = interactionsDataGrid;
        
        setAutoCreateColumnsFromModel(false);
        setModel(table.getModel());
        this.table = table;
//      setSelectionModel(jt.getSelectionModel());
        setAutoscrolls(false); 
        //customise row headers here
        addColumn(new TableColumn());
        getColumnModel().getColumn(0).setPreferredWidth(table.getTableHeader().getPreferredSize().height);
        setPreferredScrollableViewportSize(getPreferredSize());
        
        //getColumnModel().getColumn(0).setResizable(true);
        setIntercellSpacing(new Dimension(1,1)); 
        //set row header backgroound color and alignement
        MyHeaderRender mhr = new MyHeaderRender(
                (DefaultTableCellRenderer) table.getTableHeader().getDefaultRenderer());

        getColumnModel().getColumn(0).setCellRenderer(mhr);

        RowListener rl = new RowListener(table, jtp, control, columnNames, jf, infobox, interactionsDataGrid);
        addMouseListener(rl);
    }
    
          
    //Implement table cell tool tips.
    public String getToolTipText(MouseEvent e) {
        java.awt.Point p = e.getPoint();
        int rowIndex = rowAtPoint(p);

        return ((AsserterIdentity)columnNames.elementAt(rowIndex)).getLongName();
    }
    

    public boolean isCellEditable(int row, int column){
        return false;
    }
      
    public Object getValueAt(int row, int column)
    {
        return table.getColumnName(row) + " ";
    } 
}



/**
 * the header renderer
 * @author tibo
 */
class MyHeaderRender extends DefaultTableCellRenderer
{
    private DefaultTableCellRenderer tcr ;
    
    public MyHeaderRender(DefaultTableCellRenderer tcr ){
        this.tcr = tcr;
    }
    
    public Component getTableCellRendererComponent(JTable jt,Object value,
                          boolean isselected, boolean hasfocus,int row,int col)
    {
        tcr.getTableCellRendererComponent(jt,value,isselected,hasfocus,row,col);
        
        tcr.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        tcr.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
        
        tcr.setBorder(UIManager.getBorder("TableHeader.cellBorder"));
        
        return tcr;
    }
}