/*
 * RowListener.java
 *
 * Created on 14 juillet 2006, 10:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.tableview;

/**
 *
 * @author tibo
 */

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*; 
import org.pasoa.preview.*;
import org.pasoa.preview.asserterview.AsserterView;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.Progression;

/**
 * a mouse listener for the row of the main table
 * @author tibo
 */
class RowListener extends MouseAdapter
{
    JTable mainTable;
    JScrollPane asserter;
    JTabbedPane jtp;
    Controller control;
    Vector columnNames;
    JFrame jf;
    Vector<Vector> interactionsDataGrid;

    private JScrollPane infobox;
 
    public RowListener(JTable table, JTabbedPane jtp, Controller control, Vector columnNames, JFrame jf, JScrollPane infobox, Vector<Vector> interactionsDataGrid) {
        this.jtp = jtp;
        this.control = control;
        this.columnNames = columnNames;
        this.jf = jf ;
        this.infobox = infobox;
        mainTable = table;
        this.interactionsDataGrid = interactionsDataGrid;
    }
 
    public void mousePressed(MouseEvent e){
        if(e.getClickCount() == 1) {
            JTable rows = (JTable)e.getSource();
            int rindex = rows.rowAtPoint(e.getPoint());
            Mycellrender mcr = (Mycellrender)mainTable.getCellRenderer(rindex, 0);

            mcr.setrow(rindex);
            mainTable.repaint();
        }
        else {
            if(e.getClickCount()==2){
                this.asserter = new JScrollPane();
                JTable rows = (JTable)e.getSource();
                final int rindex = rows.rowAtPoint(e.getPoint());

                Runnable go = new Runnable() {
                    public void run() {
                        Progression pgr = new Progression(jf);
                        AsserterView av;
                        try {
                            pgr.startProgress();
                            
                            av = new AsserterView(control, ((AsserterIdentity) columnNames.elementAt(rindex)), columnNames, jf, jtp, infobox,interactionsDataGrid, false);

                            int removeTab = -1;
                            removeTab = jtp.indexOfTab(((AsserterIdentity)columnNames.elementAt(rindex)).getShortName() + "View");
                            if(removeTab!=-1){
                                jtp.removeTabAt(removeTab);
                            }

                            asserter.setViewportView(av);
                            jtp.addTab(
                                    ((AsserterIdentity)columnNames.elementAt(rindex)).getShortName() + "View", 
                                    null, 
                                    asserter,
                                    "This is one Asserter View");
                            jtp.setSelectedIndex(jtp.getTabCount()-1);
                            av.requestFocusInWindow();

                            pgr.stopProgress();
                            
                        } catch (Exception ex) {
                            if(Controller.debug)ErreurDialog.afficher(jf, "Unable to initialize Asserterview", 
                                ex.getMessage(),ex.getStackTrace());
                            else ErreurDialog.afficher(jf, "Unable to initialize Asserterview", ex.getMessage());
                            pgr.stopProgress();
                        }

                            asserter.repaint();
                    }
                };
                Thread t = new Thread(go);
                t.start();
            }
        } 
    }
}