/*
 * TableView.java
 *
 * Created on 28 juillet 2006, 10:41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.tableview;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.RenderingHints;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.awt.geom.AffineTransform;
import java.io.File;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import org.pasoa.preview.AsserterIdentity;
import org.pasoa.preview.Controller;
import org.pasoa.preview.MonUI;
import org.pasoa.preview.asserterview.MouseListen;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.MyJTabbedPane;
import org.pasoa.pstructure.View;

/**
 * The table view
 * @author tibo
 */
public class TableView  extends JSplitPane implements Runnable{
    
    public static String TABLE_NAME = "Main Table";
    private javax.swing.JScrollPane scrollpaneTable;
    private javax.swing.JScrollPane infobox;
    private Vector<Vector> data = new Vector<Vector>();
    private Vector columnNames = new Vector();
    private Controller control;
    /* Preferred size for a header cell */
    private int preferredWidth = 16;
    private int preferredHeight = 100;
    private JFrame jf;
    private JTabbedPane jTabb;

    public JTable table;
    public JTable table2;
        
    private String add;

    int max = 0;
        
    /**
     * Creates a new instance of TableView
     * @param c a controller
     * @param jf main JFrame
     * @param coName a vector of asserter identity for the column name of the main table
     * @param d Vector<Vector<int>> data of the main table
     * @param jtabb the jtabbedpane which contains this view
     * @param address the store address
     */
    public TableView(Controller c, JFrame jf, Vector coName, Vector<Vector> d, JTabbedPane jtabb, String address) {
        super();
        this.control = c;
        this.jf = jf;
        this.columnNames = coName;
        this.data = d;
        this.jTabb = jtabb;
        this.add = address;
    }

    public Vector getColumnNames() {
        return columnNames;
    }

    public Vector<Vector> getData() {
        return data;
    }

    public Controller getControl() {
        return control;
    }

    public JScrollPane getInfobox() {
        return infobox;
    }
    
    public void run(){
        
        JTabbedPane jTabbedPane1;
        jTabbedPane1 = new MyJTabbedPane();
        jTabbedPane1.setTabPlacement(javax.swing.JTabbedPane.LEFT);
        jTabbedPane1.setUI(new MonUI());
        jTabbedPane1.setOpaque(true);
        
        drawView(jTabbedPane1);
        
        jTabb.addTab(add, null, jTabbedPane1, "Views for store at " + add);
        //jf.add(jTabb);
        jTabb.setSelectedIndex(jTabb.getTabCount()-1);
        jf.repaint();
    }
    
    public void drawView(JTabbedPane jtp){
        
        
        //javax.swing.JPanel tableView;
        infobox = new javax.swing.JScrollPane();

        /* Table */
        scrollpaneTable = createTable(jtp);

        /* End of Table */
        infobox.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        infobox.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        infobox.setOpaque(false);

        setOrientation(JSplitPane.VERTICAL_SPLIT);
        setLeftComponent(scrollpaneTable);
        setRightComponent(infobox);
        
        File f = new File("files/datatableicon.gif");
        ImageIcon image = null;
        if(f.exists()){
            image = new ImageIcon("files/datatableicon.gif");
        }
        jtp.addTab(TABLE_NAME, image, this, "This is the table view");
    }
    
    public boolean changeSelectedIndex(AsserterIdentity i, AsserterIdentity j){
        int rowIndex = columnNames.indexOf(i);
        int colIndex = columnNames.indexOf(j);
        if(rowIndex != -1 && colIndex != -1){
            table.changeSelection(rowIndex, colIndex, false, false);
            table.repaint();
            return true;
        }
        return false;
    }
    
    protected JScrollPane createTable(JTabbedPane jTabbedPane1){
        
        DefaultTableModel model = new DefaultTableModel(data,columnNames){

            public String getColumnName(int col){
                return ((AsserterIdentity)columnNames.elementAt(col)).getShortName();
            }
        };

        model.fireTableDataChanged();
        table = new JTable(model){
            
            //Implement table cell tool tips.
            public String getToolTipText(MouseEvent e) {
                Point p = e.getPoint();
                int rowIndex = rowAtPoint(p);
                int colIndex = columnAtPoint(p);
                //System.out.println(interactions.elementAt(rowIndex).elementAt(colIndex).toString());
                
                String tmp = data.elementAt(rowIndex).elementAt(colIndex).toString();
                return (tmp.equals("0"))? null:tmp + " interaction(s)";
            }        
            
            public boolean isCellEditable(int row, int column){
                return false;
            }
            
            public Object getValueAt(int row, int column){
                String tmp = data.elementAt(row).elementAt(column).toString(); 
                //int tmpInt = Integer.parseInt(tmp);
                //max = (max > tmpInt)? max : tmpInt;
                return (tmp.equals("0"))?"":"X";
            } 
            
        };
        table.setColumnSelectionAllowed(true);
        table.setRowSelectionAllowed(true);
        table.setCellSelectionEnabled(true);
        table.setOpaque(true);
        SelectionListener sl = new SelectionListener(table);
        table.getSelectionModel().addListSelectionListener(sl);
        table.getColumnModel().getSelectionModel().addListSelectionListener(sl);        

        JTableHeader colheader = table.getTableHeader();
        colheader.setPreferredSize(new Dimension ((16 * (columnNames.size())),preferredHeight));

        //new class for rows header
        table2 = new Mytable(table, columnNames, jTabbedPane1, control, jf, infobox, data);
        JScrollPane sp = new JScrollPane(table);
        TableColumn tcol = null;
        for(int i =0; i< data.size(); i++){
            for(int j =0 ; j < data.elementAt(i).size(); j++){
                int tmp = Integer.parseInt(data.elementAt(i).elementAt(j).toString());
                max = (max >= tmp)? max : tmp ;
            }
        }
        //System.out.println(max);
        Mycellrender mcr = new Mycellrender(data, max); 
        table.getTableHeader().setReorderingAllowed(false);
        table.getTableHeader().setResizingAllowed(false);
        
        /* Change height of headers */
        KeyListener keylistener = new KeyAdapter() {
            public void keyPressed(KeyEvent e){
                JTable jt = ((JTable) e.getSource());
                switch(e.getKeyCode()) {
                    case 61:
                        if(preferredHeight <= 800) {
                            preferredHeight = preferredHeight + 10;
                            jt.getTableHeader()
                                .setPreferredSize(new Dimension ((16 * (columnNames.size())),preferredHeight));
                            table2.setPreferredScrollableViewportSize(
                                new Dimension(preferredHeight, table2.getPreferredSize().height));
                            jt.getTableHeader().resizeAndRepaint();
                            jt.repaint();
                        }
                        break;
                    case 54:
                        if (preferredHeight >= 100) {
                            preferredHeight = preferredHeight - 10;
                            jt.getTableHeader()
                                .setPreferredSize(new Dimension ((16 * (columnNames.size())),preferredHeight));
                            table2.setPreferredScrollableViewportSize(
                                new Dimension(preferredHeight, table2.getPreferredSize().height));
                            jt.getTableHeader().resizeAndRepaint();
                            jt.repaint();
                        }
                        break;
                    default:
                        //System.out.println(e.getKeyCode());
                }
                
            }
        };
        table.addKeyListener(keylistener);
        
        MouseWheelListener wheellistener = new MouseWheelListener() {
            public void mouseWheelMoved(MouseWheelEvent e) {
                 int notches = e.getWheelRotation();
                 JTable jt = ((JTableHeader) e.getSource()).getTable();
                 if(notches < 0){
                 // wheel moved UP 
                    if(preferredHeight <= 800) {
                        preferredHeight = preferredHeight + 10;
                        jt.getTableHeader()
                            .setPreferredSize(new Dimension ((16 * (columnNames.size())),preferredHeight));
                        table2.setPreferredScrollableViewportSize(
                            new Dimension(preferredHeight, table2.getPreferredSize().height));
                        jt.getTableHeader().resizeAndRepaint();
                        jt.repaint();
                    }
                 }
                 else {
                 // wheel moved DOWN
                    if (preferredHeight >= 100) {
                        preferredHeight = preferredHeight - 10;
                        jt.getTableHeader()
                            .setPreferredSize(new Dimension ((16 * (columnNames.size())),preferredHeight));
                        table2.setPreferredScrollableViewportSize(
                            new Dimension(preferredHeight, table2.getPreferredSize().height));
                        jt.getTableHeader().resizeAndRepaint();
                        jt.repaint();
                    }
                 }
            }
        };
        table.getTableHeader().addMouseWheelListener(wheellistener);
        
        
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
       
        /* Tooltips column header */
        ColumnHeaderToolTips tipsCol = new ColumnHeaderToolTips();   
        for(int i=0;i<columnNames.size();i++) {
            tcol = table.getColumnModel().getColumn(i);
            tcol.setPreferredWidth(preferredWidth); 
            tipsCol.setToolTip(tcol, ((AsserterIdentity)columnNames.elementAt(i)).getLongName());
            
            tcol.setCellRenderer(mcr);
            
        } 
        table.getTableHeader().addMouseMotionListener(tipsCol);        
         
        /* Try to put Vertical Text */
        table.getTableHeader().setDefaultRenderer(new VerticalRenderer(control));
        
        ColListener cl = new ColListener( jTabbedPane1, control, columnNames, jf, infobox, data);
        colheader.addMouseListener(cl);
        
        /* Draw left upper corner of the table */
        JPanel TopLeftCorner = new JPanel(){
        
            public void paint(Graphics g){
                //super.paint(g);
                Graphics2D g2 = (Graphics2D) g;
                g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
                AffineTransform at = new AffineTransform();
                g2.setColor(Color.BLACK);
                g2.drawLine(0,0,preferredHeight, preferredHeight);
                g2.setColor(Color.RED);
                at.setToTranslation((preferredHeight/4.5), (preferredHeight / 2));
                g2.transform(at);
                double radianAngle = Math.PI / 4.0;
                at.setToRotation(radianAngle);
                g2.transform(at);
                g2.drawString("Sender", 0.0f, 0.0f);
                at.setToTranslation(-3 , - (preferredHeight / 3));
                g2.transform(at);
                g2.drawString("Receiver", 0.0f, 0.0f);
            }
      
        };
        sp.setCorner(sp.UPPER_LEFT_CORNER, TopLeftCorner);
        sp.setRowHeaderView(table2); 

        
        /* Simple click for InfoBox */
        Infobox celist = new Infobox(infobox, control, columnNames, jf);
        table.addMouseListener(celist);
        
        sp.setPreferredSize(new Dimension ((16 * (columnNames.size()+1))+preferredHeight, (16 * (columnNames.size()+1))+preferredHeight));
        
        table.requestFocusInWindow();
        return sp;
    }
    
    
}
