/*
 * VerticalRenderer.java
 *
 * Created on 14 juillet 2006, 17:03
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.tableview;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.AffineTransform;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.UIManager;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellRenderer;
import org.pasoa.preview.*;

/**
 * a renderer for the column header to set the text vertical
 * @author tibo
 */

public class VerticalRenderer extends JLabel implements TableCellRenderer {

       /* Angle Rotation */
       protected int m_degreesRotation = -90;
       /* Text for displaying */
       protected String texte = "";
       protected Controller control;

       public VerticalRenderer(Controller control) {
            this.control = control;
       }


         public Component getTableCellRendererComponent(JTable table, Object value,
             boolean isSelected, boolean hasFocus, int row, int column) {
           // Inherit the colors and font from the header component
           if (table != null) {
             JTableHeader header = table.getTableHeader();
             //header.setBounds(column*20, 0, 100, 20);
             if (header != null) {
               setForeground(header.getForeground());
               setBackground(header.getBackground());
               setFont(header.getFont());
             }
           }
           setBorder(UIManager.getBorder("TableHeader.cellBorder"));
           setHorizontalAlignment(JLabel.CENTER);
           setVerticalAlignment(JLabel.CENTER);
           
           /* Add text to JPanel */
           /* Double display of text */
           this.texte = (value.toString());
//           char c = value.toString().charAt(value.toString().length() -1);  
//           this.texte = " " + c;
           return this;
           
         }

         public void paint(Graphics g) {
           
           super.paint(g);
           Graphics2D g2 = (Graphics2D) g;
           //g2.setClip(0, 0, 500, 100);
           g2.setBackground(this.getBackground());
           g2.setColor(Color.BLACK);
           g2.setFont(this.getFont());
           g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
           AffineTransform at = new AffineTransform();
           at.setToTranslation(this.getWidth()- 4, this.getHeight()-2);
           g2.transform(at);
           double radianAngle = (((double) m_degreesRotation) / ((double) 180)) * Math.PI;
           at.setToRotation(radianAngle);
           g2.transform(at);
           g2.drawString(this.texte, 0.0f, 0.0f);
//           revalidate();
//           repaint();
         }

     }