/*
 * MyTreeTable.java
 *
 * Created on 20 juillet 2006, 13:56
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.treetable;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.EventObject;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.SwingUtilities;
import org.pasoa.preview.OpenStore;
import org.pasoa.preview.View;
import prefuse.util.ui.BrowserLauncher;

/**
 *
 * @author Santhosh Kumar T - santhosh@in.fiorano.com - tibo
 */

public class MyTreeTable extends JTreeTable{ 
 
    public MyTreeTable(TreeTableModel treeTableModel, final JFrame jf){ 
        super(treeTableModel); 
        
        setShowGrid(true); 
        setGridColor(new Color(234, 234, 234)); 
        setIntercellSpacing(new Dimension(1, 1)); 
        //setDefaultEditor(TreeTableModel.class, new TreeTableCellEditor());
        setAutoResizeMode(AUTO_RESIZE_OFF);
        addMouseListener(new MouseListener() {
            public void mouseClicked(MouseEvent e) {
                if((SwingUtilities.isLeftMouseButton(e) && e.isControlDown()) || SwingUtilities.isRightMouseButton(e)){
                    final int rowIndex = rowAtPoint(e.getPoint());
                    final int colIndex = columnAtPoint(e.getPoint());
                    if(colIndex == 1){
                        final JPopupMenu labelPopupMenu = new JPopupMenu();
                        JMenu gotoMenu = new JMenu("GoTo");
                        JMenuItem item = new JMenuItem("in a Browser");
                        item.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent ae) {
                                String s = (String) getValueAt(rowIndex, colIndex);
                                if(s != null){
                                    BrowserLauncher.showDocument(s);
                                }
                            }
                        }); 
                        gotoMenu.add(item);
                        JMenuItem item2 = new JMenuItem("a new store");
                        item2.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent ae) {
                                String s = (String) getValueAt(rowIndex, colIndex);
                                if(s != null){
                                    if(s.startsWith("http://")) OpenStore.openNewStore(jf, s,((View)jf).getJTabbedPane1(), false);
                                }
                            }
                        }); 
                        gotoMenu.add(item2);
                        labelPopupMenu.add(gotoMenu);
                        labelPopupMenu.show(e.getComponent(), e.getX(), e.getY());
                    }
                }
            }
            public void mouseEntered(MouseEvent e) {
            }
            public void mouseExited(MouseEvent e) {
            }
            public void mousePressed(MouseEvent e) {
            }
            public void mouseReleased(MouseEvent e) {
            }
        });
        //getColumnModel().getColumn(0).setPreferredWidth(300);
        //getColumnModel().getColumn(1).setPreferredWidth(((XMLTreeTableModel)treeTableModel).getMaxWidth());
    } 
 
    public boolean editCellAt(int row, int column, EventObject e){ 
        if(e instanceof MouseEvent){ 
            MouseEvent me = (MouseEvent)e; 
            // If the modifiers are not 0 (or the left mouse button), 
            // tree may try and toggle the selection, and table 
            // will then try and toggle, resulting in the 
            // selection remaining the same. To avoid this, we 
            // only dispatch when the modifiers are 0 (or the left mouse 
            // button). 
            if(me.getModifiers()==0 || 
                    me.getModifiers()==InputEvent.BUTTON1_MASK){ 
                for(int counter = getColumnCount()-1; counter>= 0; 
                    counter--){ 
                    if(getColumnClass(counter)==TreeTableModel.class){ 
                        MouseEvent newME = new MouseEvent 
                                (tree, me.getID(), 
                                        me.getWhen(), me.getModifiers(), 
                                        me.getX()-getCellRect(0, counter, true).x, 
                                        me.getY(), me.getClickCount(), 
                                        me.isPopupTrigger()); 
                        tree.dispatchEvent(newME); 
                        break; 
                    } 
                } 
            } 
            return false; 
        } 
        return super.editCellAt(row, column, e); 
    } 
        // overriden to make the height of scroll match viewpost height if smaller 
    public boolean getScrollableTracksViewportHeight() { 
        return getPreferredSize().height < getParent().getHeight(); 
    } 

    public void paint(Graphics g) {
        super.paint(g);
        TreeTableUtilities.packColumn(this, 0, 2);
        TreeTableUtilities.packColumn(this, 1, 2);
    }
    
}