/*
 * XMLTreeTableCellRenderer.java
 *
 * Created on 20 juillet 2006, 19:17
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.treetable;

import java.awt.Color;
import java.awt.Component;
import java.util.HashMap;
import java.util.Map;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;
import org.w3c.dom.DocumentType;
import org.w3c.dom.Node;

/**
 * 
 * @author Santhosh Kumar T - santhosh@in.fiorano.com 
 * tibo
 */

public class XMLTreeTableCellRenderer extends DefaultTreeCellRenderer{ 
    Color elementColor = new Color(0, 0, 128); 
    Color attributeColor = new Color(0, 128, 0); 
    
 
    public XMLTreeTableCellRenderer(){ 
        setOpenIcon(null); 
        setClosedIcon(null); 
        setLeafIcon(null); 
    } 
 
    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus){ 
        Node node = (Node)value; 
        switch(node.getNodeType()){ 
            case Node.ELEMENT_NODE: 
                value = '<'+node.getNodeName()+'>'; 
                break; 
            case Node.ATTRIBUTE_NODE: 
                value = '@'+node.getNodeName(); 
                break; 
            case Node.TEXT_NODE: 
                value = "# text"; 
                break; 
            case Node.COMMENT_NODE: 
                value = "# comment"; 
                break; 
            case Node.DOCUMENT_TYPE_NODE: 
                DocumentType dtype = (DocumentType)node; 
                value = "# doctype"; 
                break; 
            default: 
                value = node.getNodeName(); 
                
        } 
        super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus); 
        if(!selected){ 
            switch(node.getNodeType()){ 
                case Node.ELEMENT_NODE: 
                    setForeground(elementColor); 
                    break; 
                case Node.ATTRIBUTE_NODE: 
                    setForeground(attributeColor); 
                    break; 
            } 
        } 
        return this; 
    } 
} 