package org.pasoa.preview.utils;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * a class to open an error dialog
 * @author Brack romain
 */
public class ErreurDialog implements ActionListener
	{
	
	private JDialog dialog;
	
	private JLabel[] tabLab;
	
	private JButton[] tabCmd;
	
	private JTextArea areaDetails;
	
	private JScrollPane scrollDetails;
	
	private JFrame parent;
	
	private final Dimension dimNormal = new Dimension(475,125);
	
	private final Dimension dimDetails = new Dimension(475,250);
	
	private boolean details = true;
	
	private ErreurDialog(JFrame parent, String message, String details1, StackTraceElement[] details2)
		{
		this.parent = parent;		
		this.init_details();
		this.init_tabCmd();
		this.init_tabLab();
		this.init_dialog();
		
		if(details2 != null)
			this.dialogVisible(message,details1,details2);
		else this.dialogVisible(message,details1);
		}
	
	
	private void init_details()
		{
		// construction du textarea
		this.areaDetails = new JTextArea();
		this.areaDetails.setEditable(false);
		this.areaDetails.setForeground(Color.RED);
		
		// construction du scrollpane
		this.scrollDetails = new JScrollPane(this.areaDetails);
		this.scrollDetails.setBounds(10,105,445,100);
		}
	
	private void init_tabCmd()
		{
		// creation du tableau
		this.tabCmd = new JButton[2];
		
		// creation du bouton fermer
		this.tabCmd[0] = new JButton("Close");
		this.tabCmd[0].setToolTipText("Close window");
		this.tabCmd[0].setBounds(350,10,100,25);
		this.tabCmd[0].addActionListener(this);
		this.tabCmd[0].setActionCommand("close");
		
		// creation du bouton details
		this.tabCmd[1] = new JButton("Details >>");
		this.tabCmd[0].setToolTipText("More details...");
		this.tabCmd[1].setBounds(350,45,100,25);
		this.tabCmd[1].addActionListener(this);
		this.tabCmd[1].setActionCommand("details");
		}
	
	
	private void init_tabLab()
		{
		// construit le tableau
		this.tabLab = new JLabel[3];
		
		// construit label de l'icone
		this.tabLab[0] = new JLabel(UIManager.getIcon("OptionPane.errorIcon"));
		this.tabLab[0].setBounds(10,10,43,42);
		
		// label du texte simple
		this.tabLab[1] = new JLabel("");
		this.tabLab[1].setBounds(80,10,250,60);
		this.tabLab[1].setHorizontalAlignment(JLabel.LEFT);
		this.tabLab[1].setVerticalAlignment(JLabel.VERTICAL);
		
		// label du texte de presentation du details
		this.tabLab[2] = new JLabel("Error details :");
		this.tabLab[2].setBounds(10,80,200,17);
		this.tabLab[2].setHorizontalAlignment(JLabel.LEFT);
		this.tabLab[2].setVerticalAlignment(JLabel.VERTICAL);
		}	
	
	
	private void init_dialog()
		{
		// creation de la boite de dialogue
		this.dialog = new JDialog(this.parent,"Error occured",true);
		this.dialog.setLayout(null);
		
		// ajoute les element		
		this.dialog.add(this.tabLab[0]);
		this.dialog.add(this.tabLab[1]);
		this.dialog.add(this.tabLab[2]);
		this.dialog.add(this.tabCmd[0]);
		this.dialog.add(this.tabCmd[1]);
		this.dialog.add(this.scrollDetails);
		}
	
	
	public static void afficher(JFrame parent, String message, 
								String details1, StackTraceElement[] details2)
		{
		new ErreurDialog(parent,message,details1,details2);
		}
	
	public static void afficher(JFrame parent, String message, String details)
		{
		new ErreurDialog(parent,message,details,null);
		}
	
	
	private void dialogVisible(String message, String details1, StackTraceElement[] details2)
		{
		// creation du details
		String det = details1 + "\n\r\n\r";
		for (int i = 0; i < details2.length; i++)
			{
			det += details2[i].toString()+ "\n\r";			
			}		
		
		// change le texte
		this.tabLab[1].setText(message);
		this.areaDetails.setText(det);
		
		// met les dimension normal sans details et affiche
		this.cacheDetails();
		this.dialog.setVisible(true);
		}
	
        private void dialogVisible(String message, String details)
		{
		// change le texte
		this.tabLab[1].setText(message);
		this.areaDetails.setText(details);
		
		// met les dimension normal sans details et affiche
		this.cacheDetails();
		this.dialog.setVisible(true);
		}
	
	private void afficheDetails()
		{
		// si elle n'est pas encore affiche
		if (this.details == false)
			{
			// modifie les elements de la boite de dialogue
			this.tabCmd[1].setText("Details <<");
			this.tabCmd[1].setToolTipText("Hide details");
			
			// modifie la boite de dialogue
			this.dialog.setSize(this.dimDetails);
			this.dialog.setLocationRelativeTo(parent);
			
			// remet element boite de dialogue
			this.dialog.add(this.tabLab[2]);
			this.dialog.add(this.scrollDetails);
			this.dialog.validate();
			
			// change l'etat
			this.details = true;
			}		
		}
	
	private void cacheDetails()
		{
		// si elle n'est pas encore cache
		if (this.details == true)
			{	
			// modifie les elements de la boite de dialogue
			this.tabCmd[1].setText("Details >>");
			this.tabCmd[1].setToolTipText("Show details");
			
			// enleve element boite de dialogue
			this.dialog.remove(this.tabLab[2]);
			this.dialog.remove(this.scrollDetails);
			
			// modifie la boite de dialogue
			this.dialog.setSize(this.dimNormal);
			this.dialog.setLocationRelativeTo(parent);
			this.dialog.validate();
			
			// change l'etat
			this.details = false;
			}
		}

	public void actionPerformed(ActionEvent evt)
		{
		// si c'est le bouton fermer
		if (evt.getActionCommand().equals("close"))
			this.dialog.dispose();
		
		// si c'est le bouton details
		if (evt.getActionCommand().equals("details"))
			{
			if (this.details == true) this.cacheDetails();
			else this.afficheDetails();
			}		
		}
	}