package org.pasoa.pstructure;

import java.io.IOException;
import java.io.Serializable;

import javax.xml.parsers.DocumentBuilderFactory;

import org.pasoa.accessors.AccessorException;
import org.pasoa.accessors.DataAccessorRegistry;
import org.pasoa.common.BestPractice;
import org.pasoa.simpledom.DOMWriter;
import org.pasoa.storeclient.ClientLib;
import org.w3c.dom.Element;

public class PAssertionDataKey implements Serializable {
    private GlobalPAssertionKey  _gpak;
    private Element              _dataAccessor;
    
    private transient DataAccessorRegistry _comparator;
    
    private void readObject(java.io.ObjectInputStream in)
        throws IOException, ClassNotFoundException 
    {
        in.defaultReadObject();
        _comparator   = DataAccessorRegistry.getDefaultRegistry ();
    }
    
    public PAssertionDataKey (GlobalPAssertionKey gpak, Element dataAccessor) {
        _gpak         = gpak;
        _dataAccessor = dataAccessor;
        _comparator   = DataAccessorRegistry.getDefaultRegistry ();
    }
    
    public boolean equals (Object otherPADK) {
        PAssertionDataKey other;
/*if (getGlobalPAssertionKey ().getLocalPAssertionID ().endsWith ("/3")) {
System.out.println ("Comparing " + other.getGlobalPAssertionKey () + " with " + getGlobalPAssertionKey ());
System.out.println (" and " + other.getDataAccessor () + " with " + getDataAccessor ());
}*/
        try {
            if (otherPADK instanceof PAssertionDataKey) {
                other = ((PAssertionDataKey) otherPADK);
                return other.getGlobalPAssertionKey ().equals (getGlobalPAssertionKey ()) &&
                        ((other.getDataAccessor () == null && getDataAccessor () == null) ||
                        (other.getDataAccessor () != null && getDataAccessor () != null &&
                        _comparator.equalDataAccessors (other.getDataAccessor (),
                        BestPractice.VERBATIM_STYLE, getDataAccessor (), BestPractice.VERBATIM_STYLE)));
            } else {
                return false;
            }
        } catch (AccessorException problem) {
            problem.printStackTrace ();
            return false;
        }
    }
    
    public Element getDataAccessor () {
        return _dataAccessor;
    }
    
    public GlobalPAssertionKey getGlobalPAssertionKey () {
        return _gpak;
    }
    
    public int hashCode () {
        return _gpak.hashCode ();
    }
    
    public String toString () {
        return _gpak + ", data accessor: " + DOMWriter.writeToString (_dataAccessor);
    }
}
