/********************************************************************************
 * Created on 2006 May 23
 *
 * Copyright (c) 2006 University of Southampton
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *******************************************************************************/
package org.pasoa.pstructure.dom;

import org.pasoa.dommap.ContextItem;
import org.pasoa.dommap.MappedDocument;
import org.pasoa.dommap.UnderlyingModelAccessor;
import org.pasoa.dommap.UnderlyingModelException;

class PStructureMapDocument extends MappedDocument implements PStructureMapConstants {
    PStructureMapDocument (UnderlyingModelAccessor access, int rootType, ContextItem[] initialContext) throws UnderlyingModelException {
        super (access, rootType);
        registerType (PSTRUCT, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "pstruct", new int[] {INTERACTIONRECORD});
        registerType (INTERACTIONRECORD, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionRecord", new int[] {INTERACTIONRECORD_INTERACTIONKEY, SENDER, RECEIVER, XMLCONTENT});
        registerType (INTERACTIONRECORD_INTERACTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionKey", new int[] {INTERACTIONRECORD_INTERACTIONKEY_MESSAGESOURCE, INTERACTIONRECORD_INTERACTIONKEY_MESSAGESINK, INTERACTIONRECORD_INTERACTIONKEY_INTERACTIONID});
        registerType (INTERACTIONRECORD_INTERACTIONKEY_MESSAGESOURCE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSource", new int[] {INTERACTIONRECORD_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, INTERACTIONRECORD_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, INTERACTIONRECORD_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, INTERACTIONRECORD_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, XMLCONTENT});
        registerType (INTERACTIONRECORD_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (INTERACTIONRECORD_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (INTERACTIONRECORD_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (INTERACTIONRECORD_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (INTERACTIONRECORD_INTERACTIONKEY_MESSAGESINK, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSink", new int[] {INTERACTIONRECORD_INTERACTIONKEY_MESSAGESINK_ADDRESS, INTERACTIONRECORD_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, INTERACTIONRECORD_INTERACTIONKEY_MESSAGESINK_PORTTYPE, INTERACTIONRECORD_INTERACTIONKEY_MESSAGESINK_SERVICENAME, XMLCONTENT});
        registerType (INTERACTIONRECORD_INTERACTIONKEY_MESSAGESINK_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (INTERACTIONRECORD_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (INTERACTIONRECORD_INTERACTIONKEY_MESSAGESINK_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (INTERACTIONRECORD_INTERACTIONKEY_MESSAGESINK_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (INTERACTIONRECORD_INTERACTIONKEY_INTERACTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionId", new int[] {DATACONTENT});
        registerType (SENDER, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "sender", new int[] {SENDER_ASSERTER, SENDER_INTERACTIONPASSERTION, SENDER_RELATIONSHIPPASSERTION, SENDER_ACTORSTATEPASSERTION, SENDER_EXPOSEDINTERACTIONMETADATA, XMLCONTENT});
        registerType (SENDER_ASSERTER, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "asserter", new int[] {XMLCONTENT});
        registerType (SENDER_INTERACTIONPASSERTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionPAssertion", new int[] {SENDER_INTERACTIONPASSERTION_LOCALPASSERTIONID, SENDER_INTERACTIONPASSERTION_DOCUMENTATIONSTYLE, SENDER_INTERACTIONPASSERTION_CONTENT});
        registerType (SENDER_INTERACTIONPASSERTION_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (SENDER_INTERACTIONPASSERTION_DOCUMENTATIONSTYLE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "documentationStyle", new int[] {DATACONTENT});
        registerType (SENDER_INTERACTIONPASSERTION_CONTENT, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "content", new int[] {XMLCONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "relationshipPAssertion", new int[] {SENDER_RELATIONSHIPPASSERTION_LOCALPASSERTIONID, SENDER_RELATIONSHIPPASSERTION_SUBJECTID, SENDER_RELATIONSHIPPASSERTION_RELATION, SENDER_RELATIONSHIPPASSERTION_OBJECTID});
        registerType (SENDER_RELATIONSHIPPASSERTION_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_SUBJECTID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "subjectId", new int[] {SENDER_RELATIONSHIPPASSERTION_SUBJECTID_LOCALPASSERTIONID, SENDER_RELATIONSHIPPASSERTION_SUBJECTID_DATAACCESSOR, SENDER_RELATIONSHIPPASSERTION_SUBJECTID_PARAMETERNAME});
        registerType (SENDER_RELATIONSHIPPASSERTION_SUBJECTID_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_SUBJECTID_DATAACCESSOR, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "dataAccessor", new int[] {XMLCONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_SUBJECTID_PARAMETERNAME, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "parameterName", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_RELATION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "relation", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "objectId", new int[] {SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY, SENDER_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND, SENDER_RELATIONSHIPPASSERTION_OBJECTID_LOCALPASSERTIONID, XMLCONTENT, SENDER_RELATIONSHIPPASSERTION_OBJECTID_DATAACCESSOR, SENDER_RELATIONSHIPPASSERTION_OBJECTID_PARAMETERNAME});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionKey", new int[] {SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE, SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK, SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_INTERACTIONID});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSource", new int[] {SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, XMLCONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSink", new int[] {SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_ADDRESS, SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_PORTTYPE, SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_SERVICENAME, XMLCONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_INTERACTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionId", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "viewKind", new int[] {SENDER_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND_DESCRIPTION}, new String[] {"xsi:type"}, new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND_DESCRIPTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "description", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_DATAACCESSOR, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "dataAccessor", new int[] {XMLCONTENT});
        registerType (SENDER_RELATIONSHIPPASSERTION_OBJECTID_PARAMETERNAME, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "parameterName", new int[] {DATACONTENT});
        registerType (SENDER_ACTORSTATEPASSERTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "actorStatePAssertion", new int[] {SENDER_ACTORSTATEPASSERTION_LOCALPASSERTIONID, SENDER_ACTORSTATEPASSERTION_DOCUMENTATIONSTYLE, SENDER_ACTORSTATEPASSERTION_CONTENT});
        registerType (SENDER_ACTORSTATEPASSERTION_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (SENDER_ACTORSTATEPASSERTION_DOCUMENTATIONSTYLE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "documentationStyle", new int[] {DATACONTENT});
        registerType (SENDER_ACTORSTATEPASSERTION_CONTENT, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "content", new int[] {XMLCONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "exposedInteractionMetaData", new int[] {SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY, SENDER_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "globalPAssertionKey", new int[] {SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY, SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND, SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_LOCALPASSERTIONID, XMLCONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionKey", new int[] {SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE, SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK, SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_INTERACTIONID});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSource", new int[] {SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, XMLCONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSink", new int[] {SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_ADDRESS, SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_PORTTYPE, SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_SERVICENAME, XMLCONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_INTERACTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionId", new int[] {DATACONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "viewKind", new int[] {SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND_DESCRIPTION}, new String[] {"xsi:type"}, new int[] {DATACONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND_DESCRIPTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "description", new int[] {DATACONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionMetaData", new int[] {SENDER_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA_TRACER, XMLCONTENT});
        registerType (SENDER_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA_TRACER, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "tracer", new int[] {DATACONTENT});
        registerType (RECEIVER, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "receiver", new int[] {RECEIVER_ASSERTER, RECEIVER_INTERACTIONPASSERTION, RECEIVER_RELATIONSHIPPASSERTION, RECEIVER_ACTORSTATEPASSERTION, RECEIVER_EXPOSEDINTERACTIONMETADATA, XMLCONTENT});
        registerType (RECEIVER_ASSERTER, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "asserter", new int[] {XMLCONTENT});
        registerType (RECEIVER_INTERACTIONPASSERTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionPAssertion", new int[] {RECEIVER_INTERACTIONPASSERTION_LOCALPASSERTIONID, RECEIVER_INTERACTIONPASSERTION_DOCUMENTATIONSTYLE, RECEIVER_INTERACTIONPASSERTION_CONTENT});
        registerType (RECEIVER_INTERACTIONPASSERTION_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (RECEIVER_INTERACTIONPASSERTION_DOCUMENTATIONSTYLE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "documentationStyle", new int[] {DATACONTENT});
        registerType (RECEIVER_INTERACTIONPASSERTION_CONTENT, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "content", new int[] {XMLCONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "relationshipPAssertion", new int[] {RECEIVER_RELATIONSHIPPASSERTION_LOCALPASSERTIONID, RECEIVER_RELATIONSHIPPASSERTION_SUBJECTID, RECEIVER_RELATIONSHIPPASSERTION_RELATION, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_SUBJECTID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "subjectId", new int[] {RECEIVER_RELATIONSHIPPASSERTION_SUBJECTID_LOCALPASSERTIONID, RECEIVER_RELATIONSHIPPASSERTION_SUBJECTID_DATAACCESSOR, RECEIVER_RELATIONSHIPPASSERTION_SUBJECTID_PARAMETERNAME});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_SUBJECTID_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_SUBJECTID_DATAACCESSOR, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "dataAccessor", new int[] {XMLCONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_SUBJECTID_PARAMETERNAME, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "parameterName", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_RELATION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "relation", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "objectId", new int[] {RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_LOCALPASSERTIONID, XMLCONTENT, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_DATAACCESSOR, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_PARAMETERNAME});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionKey", new int[] {RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_INTERACTIONID});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSource", new int[] {RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, XMLCONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSink", new int[] {RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_ADDRESS, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_PORTTYPE, RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_SERVICENAME, XMLCONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_INTERACTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionId", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "viewKind", new int[] {RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND_DESCRIPTION}, new String[] {"xsi:type"}, new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND_DESCRIPTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "description", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_DATAACCESSOR, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "dataAccessor", new int[] {XMLCONTENT});
        registerType (RECEIVER_RELATIONSHIPPASSERTION_OBJECTID_PARAMETERNAME, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "parameterName", new int[] {DATACONTENT});
        registerType (RECEIVER_ACTORSTATEPASSERTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "actorStatePAssertion", new int[] {RECEIVER_ACTORSTATEPASSERTION_LOCALPASSERTIONID, RECEIVER_ACTORSTATEPASSERTION_DOCUMENTATIONSTYLE, RECEIVER_ACTORSTATEPASSERTION_CONTENT});
        registerType (RECEIVER_ACTORSTATEPASSERTION_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (RECEIVER_ACTORSTATEPASSERTION_DOCUMENTATIONSTYLE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "documentationStyle", new int[] {DATACONTENT});
        registerType (RECEIVER_ACTORSTATEPASSERTION_CONTENT, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "content", new int[] {XMLCONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "exposedInteractionMetaData", new int[] {RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY, RECEIVER_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "globalPAssertionKey", new int[] {RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY, RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND, RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_LOCALPASSERTIONID, XMLCONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionKey", new int[] {RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE, RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK, RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_INTERACTIONID});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSource", new int[] {RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, XMLCONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSink", new int[] {RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_ADDRESS, RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_PORTTYPE, RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_SERVICENAME, XMLCONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_INTERACTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionId", new int[] {DATACONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "viewKind", new int[] {RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND_DESCRIPTION}, new String[] {"xsi:type"}, new int[] {DATACONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND_DESCRIPTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "description", new int[] {DATACONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionMetaData", new int[] {RECEIVER_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA_TRACER, XMLCONTENT});
        registerType (RECEIVER_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA_TRACER, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "tracer", new int[] {DATACONTENT});
        registerType (VIEW, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "view", new int[] {VIEW_ASSERTER, VIEW_INTERACTIONPASSERTION, VIEW_RELATIONSHIPPASSERTION, VIEW_ACTORSTATEPASSERTION, VIEW_EXPOSEDINTERACTIONMETADATA, XMLCONTENT});
        registerType (VIEW_ASSERTER, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "asserter", new int[] {XMLCONTENT});
        registerType (VIEW_INTERACTIONPASSERTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionPAssertion", new int[] {VIEW_INTERACTIONPASSERTION_LOCALPASSERTIONID, VIEW_INTERACTIONPASSERTION_DOCUMENTATIONSTYLE, VIEW_INTERACTIONPASSERTION_CONTENT});
        registerType (VIEW_INTERACTIONPASSERTION_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (VIEW_INTERACTIONPASSERTION_DOCUMENTATIONSTYLE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "documentationStyle", new int[] {DATACONTENT});
        registerType (VIEW_INTERACTIONPASSERTION_CONTENT, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "content", new int[] {XMLCONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "relationshipPAssertion", new int[] {VIEW_RELATIONSHIPPASSERTION_LOCALPASSERTIONID, VIEW_RELATIONSHIPPASSERTION_SUBJECTID, VIEW_RELATIONSHIPPASSERTION_RELATION, VIEW_RELATIONSHIPPASSERTION_OBJECTID});
        registerType (VIEW_RELATIONSHIPPASSERTION_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_SUBJECTID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "subjectId", new int[] {VIEW_RELATIONSHIPPASSERTION_SUBJECTID_LOCALPASSERTIONID, VIEW_RELATIONSHIPPASSERTION_SUBJECTID_DATAACCESSOR, VIEW_RELATIONSHIPPASSERTION_SUBJECTID_PARAMETERNAME});
        registerType (VIEW_RELATIONSHIPPASSERTION_SUBJECTID_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_SUBJECTID_DATAACCESSOR, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "dataAccessor", new int[] {XMLCONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_SUBJECTID_PARAMETERNAME, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "parameterName", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_RELATION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "relation", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "objectId", new int[] {VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY, VIEW_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND, VIEW_RELATIONSHIPPASSERTION_OBJECTID_LOCALPASSERTIONID, XMLCONTENT, VIEW_RELATIONSHIPPASSERTION_OBJECTID_DATAACCESSOR, VIEW_RELATIONSHIPPASSERTION_OBJECTID_PARAMETERNAME});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionKey", new int[] {VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE, VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK, VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_INTERACTIONID});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSource", new int[] {VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, XMLCONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSink", new int[] {VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_ADDRESS, VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_PORTTYPE, VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_SERVICENAME, XMLCONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_MESSAGESINK_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_INTERACTIONKEY_INTERACTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionId", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "viewKind", new int[] {VIEW_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND_DESCRIPTION}, new String[] {"xsi:type"}, new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_VIEWKIND_DESCRIPTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "description", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_DATAACCESSOR, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "dataAccessor", new int[] {XMLCONTENT});
        registerType (VIEW_RELATIONSHIPPASSERTION_OBJECTID_PARAMETERNAME, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "parameterName", new int[] {DATACONTENT});
        registerType (VIEW_ACTORSTATEPASSERTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "actorStatePAssertion", new int[] {VIEW_ACTORSTATEPASSERTION_LOCALPASSERTIONID, VIEW_ACTORSTATEPASSERTION_DOCUMENTATIONSTYLE, VIEW_ACTORSTATEPASSERTION_CONTENT});
        registerType (VIEW_ACTORSTATEPASSERTION_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (VIEW_ACTORSTATEPASSERTION_DOCUMENTATIONSTYLE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "documentationStyle", new int[] {DATACONTENT});
        registerType (VIEW_ACTORSTATEPASSERTION_CONTENT, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "content", new int[] {XMLCONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "exposedInteractionMetaData", new int[] {VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY, VIEW_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "globalPAssertionKey", new int[] {VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY, VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND, VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_LOCALPASSERTIONID, XMLCONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionKey", new int[] {VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE, VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK, VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_INTERACTIONID});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSource", new int[] {VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, XMLCONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSink", new int[] {VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_ADDRESS, VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_PORTTYPE, VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_SERVICENAME, XMLCONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_MESSAGESINK_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_INTERACTIONKEY_INTERACTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionId", new int[] {DATACONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "viewKind", new int[] {VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND_DESCRIPTION}, new String[] {"xsi:type"}, new int[] {DATACONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_VIEWKIND_DESCRIPTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "description", new int[] {DATACONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_GLOBALPASSERTIONKEY_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionMetaData", new int[] {VIEW_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA_TRACER, XMLCONTENT});
        registerType (VIEW_EXPOSEDINTERACTIONMETADATA_INTERACTIONMETADATA_TRACER, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "tracer", new int[] {DATACONTENT});
        registerType (NUMBEROFEXPECTEDASSERTIONS, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "numberOfExpectedAssertions", new int[] {DATACONTENT});
        registerType (PASSERTIONDATAKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "pAssertionDataKey", new int[] {PASSERTIONDATAKEY_INTERACTIONKEY, PASSERTIONDATAKEY_VIEWKIND, PASSERTIONDATAKEY_LOCALPASSERTIONID, XMLCONTENT, PASSERTIONDATAKEY_DATAACCESSOR});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionKey", new int[] {PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESOURCE, PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESINK, PASSERTIONDATAKEY_INTERACTIONKEY_INTERACTIONID});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESOURCE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSource", new int[] {PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, XMLCONTENT});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESINK, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSink", new int[] {PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESINK_ADDRESS, PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESINK_PORTTYPE, PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESINK_SERVICENAME, XMLCONTENT});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESINK_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESINK_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY_MESSAGESINK_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (PASSERTIONDATAKEY_INTERACTIONKEY_INTERACTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionId", new int[] {DATACONTENT});
        registerType (PASSERTIONDATAKEY_VIEWKIND, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "viewKind", new int[] {PASSERTIONDATAKEY_VIEWKIND_DESCRIPTION}, new String[] {"xsi:type"}, new int[] {DATACONTENT});
        registerType (PASSERTIONDATAKEY_VIEWKIND_DESCRIPTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "description", new int[] {DATACONTENT});
        registerType (PASSERTIONDATAKEY_LOCALPASSERTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "localPAssertionId", new int[] {DATACONTENT});
        registerType (PASSERTIONDATAKEY_DATAACCESSOR, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "dataAccessor", new int[] {XMLCONTENT});
        registerType (INTERACTIONCONTEXT, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionContext", new int[] {INTERACTIONCONTEXT_INTERACTIONKEY, INTERACTIONCONTEXT_VIEWKIND, INTERACTIONCONTEXT_INTERACTIONMETADATA});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionKey", new int[] {INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESOURCE, INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESINK, INTERACTIONCONTEXT_INTERACTIONKEY_INTERACTIONID});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESOURCE, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSource", new int[] {INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, XMLCONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESOURCE_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESOURCE_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESOURCE_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESOURCE_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESINK, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "messageSink", new int[] {INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESINK_ADDRESS, INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESINK_PORTTYPE, INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESINK_SERVICENAME, XMLCONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESINK_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESINK_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESINK_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY_MESSAGESINK_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONKEY_INTERACTIONID, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionId", new int[] {DATACONTENT});
        registerType (INTERACTIONCONTEXT_VIEWKIND, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "viewKind", new int[] {INTERACTIONCONTEXT_VIEWKIND_DESCRIPTION}, new String[] {"xsi:type"}, new int[] {DATACONTENT});
        registerType (INTERACTIONCONTEXT_VIEWKIND_DESCRIPTION, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "description", new int[] {DATACONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONMETADATA, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "interactionMetaData", new int[] {INTERACTIONCONTEXT_INTERACTIONMETADATA_TRACER, XMLCONTENT});
        registerType (INTERACTIONCONTEXT_INTERACTIONMETADATA_TRACER, "http://www.pasoa.org/schemas/version025/PStruct.xsd", "tracer", new int[] {DATACONTENT});
        registerType (LINK, "http://www.pasoa.org/schemas/version025/distribution/PLinks.xsd", "link", new int[] {LINK_PROVENANCESTOREREF});
        registerType (LINK_PROVENANCESTOREREF, "http://www.pasoa.org/schemas/version025/distribution/PLinks.xsd", "provenanceStoreRef", new int[] {LINK_PROVENANCESTOREREF_ADDRESS, LINK_PROVENANCESTOREREF_REFERENCEPROPERTIES, LINK_PROVENANCESTOREREF_PORTTYPE, LINK_PROVENANCESTOREREF_SERVICENAME, XMLCONTENT});
        registerType (LINK_PROVENANCESTOREREF_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (LINK_PROVENANCESTOREREF_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (LINK_PROVENANCESTOREREF_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (LINK_PROVENANCESTOREREF_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (VIEWLINK, "http://www.pasoa.org/schemas/version025/distribution/PLinks.xsd", "viewLink", new int[] {VIEWLINK_PROVENANCESTOREREF});
        registerType (VIEWLINK_PROVENANCESTOREREF, "http://www.pasoa.org/schemas/version025/distribution/PLinks.xsd", "provenanceStoreRef", new int[] {VIEWLINK_PROVENANCESTOREREF_ADDRESS, VIEWLINK_PROVENANCESTOREREF_REFERENCEPROPERTIES, VIEWLINK_PROVENANCESTOREREF_PORTTYPE, VIEWLINK_PROVENANCESTOREREF_SERVICENAME, XMLCONTENT});
        registerType (VIEWLINK_PROVENANCESTOREREF_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (VIEWLINK_PROVENANCESTOREREF_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (VIEWLINK_PROVENANCESTOREREF_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (VIEWLINK_PROVENANCESTOREREF_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        registerType (OBJECTLINK, "http://www.pasoa.org/schemas/version025/distribution/PLinks.xsd", "objectLink", new int[] {OBJECTLINK_PROVENANCESTOREREF});
        registerType (OBJECTLINK_PROVENANCESTOREREF, "http://www.pasoa.org/schemas/version025/distribution/PLinks.xsd", "provenanceStoreRef", new int[] {OBJECTLINK_PROVENANCESTOREREF_ADDRESS, OBJECTLINK_PROVENANCESTOREREF_REFERENCEPROPERTIES, OBJECTLINK_PROVENANCESTOREREF_PORTTYPE, OBJECTLINK_PROVENANCESTOREREF_SERVICENAME, XMLCONTENT});
        registerType (OBJECTLINK_PROVENANCESTOREREF_ADDRESS, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "Address", new int[] {DATACONTENT});
        registerType (OBJECTLINK_PROVENANCESTOREREF_REFERENCEPROPERTIES, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ReferenceProperties", new int[] {XMLCONTENT});
        registerType (OBJECTLINK_PROVENANCESTOREREF_PORTTYPE, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "PortType", new int[] {DATACONTENT});
        registerType (OBJECTLINK_PROVENANCESTOREREF_SERVICENAME, "http://schemas.xmlsoap.org/ws/2004/03/addressing", "ServiceName", new int[] {DATACONTENT});
        initialise (initialContext);
    }
}
