package org.pasoa.storeclient.messages;

import java.util.Map; 
import org.pasoa.preserv.pquery.PQueryProblem;
import org.pasoa.preserv.pquery.ProvenanceQueryRequest;
import org.pasoa.preserv.pquery.ProvenanceQuerySerialiser;
import org.pasoa.preserv.pquery.QueryDataHandle;
import org.pasoa.preserv.pquery.RelationshipTargetFilter;
import org.pasoa.simpledom.DOMSerialiser;
import org.pasoa.util.httpsoap.SOAPDocument;

public class ProvenanceQueryRequestDocument extends SOAPDocument {
    public ProvenanceQueryRequestDocument (String queryDataHandleXPath, String scopingXPath, Map namespaces) throws PQueryProblem {
        this (queryDataHandleXPath, namespaces, scopingXPath, namespaces);
    }
    
    public ProvenanceQueryRequestDocument (String queryDataHandleXPath, Map qdhNamespaces, String scopingXPath, Map rtfNamespaces) throws PQueryProblem {
        this (formRequest (queryDataHandleXPath, qdhNamespaces, scopingXPath, rtfNamespaces));
    }
    
    public ProvenanceQueryRequestDocument (ProvenanceQueryRequest request) throws PQueryProblem {
        ProvenanceQuerySerialiser pquery  = new ProvenanceQuerySerialiser ();
        
        new DOMSerialiser (body).append (pquery.serialiseProvenanceQueryRequest (request));
    }
    
    private static ProvenanceQueryRequest formRequest (String queryDataHandleXPath, Map qdhNamespaces, String scopingXPath, Map rtfNamespaces) {
        QueryDataHandle           qdh = new QueryDataHandle (queryDataHandleXPath, qdhNamespaces, null, null);
        RelationshipTargetFilter  rtf = new RelationshipTargetFilter (scopingXPath, rtfNamespaces, null);
        
        return new ProvenanceQueryRequest (qdh, rtf);
    }
}
