package org.pasoa.storeclient.pquery;

import java.util.Iterator;
import java.util.Map;
import org.pasoa.common.BestPractice;

public class ActorProfileChecks {
    private Map _namespaces;
    
    public ActorProfileChecks (Map spaces) {
        _namespaces = spaces;
    }
    
    private String getPrefixForNamespace (String namespace, String defaultPrefix) {
        Iterator eachPrefix = _namespaces.keySet ().iterator ();
        String   prefix;    
        
        while (eachPrefix.hasNext ()) {
            prefix = (String) eachPrefix.next ();
            if (_namespaces.get (prefix).equals (namespace)) {
                return prefix;
            }
        }
        
        _namespaces.put (defaultPrefix, namespace);
        return defaultPrefix;
    }
    
    public String nameCheck (String actorName) {
        String prefix = getPrefixForNamespace (BestPractice.ACTOR_PROFILE_NS, "ap");
        
        return prefix + ":ActorProfile/" + prefix + ":name='" + actorName + "'";
    }
    
    public String typeCheck (String actorType) {
        String prefix = getPrefixForNamespace (BestPractice.ACTOR_PROFILE_NS, "ap");
        
        return prefix + ":ActorProfile/" + prefix + ":type='" + actorType + "'";
    }
}
