package org.pasoa.storeclient.pquery;

import java.util.Map;
import org.pasoa.preserv.pquery.ProvenanceQueryRequest;
import org.pasoa.preserv.pquery.ProvenanceStoreContents;
import org.pasoa.preserv.xquery.QueryProblem;
import org.pasoa.storeclient.proxy.LocalStoreProxy;
import org.w3c.dom.Document;

public class LocalProvenanceQueryBuilder extends ProvenanceQueryBuilder {
    private LocalStoreProxy _localStore;
    
    public LocalProvenanceQueryBuilder (Map namespaces, LocalStoreProxy localStore) {
        super (namespaces);
        _localStore = localStore;
    }

    public ProvenanceQueryRequest build () {
        ProvenanceQueryRequest request = super.build ();
        Document pstructure;
        
        try {
            pstructure = _localStore.getStoreContents();
            request.getQueryDataHandle ().setSearchSpace (new ProvenanceStoreContents (pstructure));
        } catch (QueryProblem ex) {
            throw new RuntimeException (ex);
        }
        
        return request;
    }
}
