package org.pasoa.storeclient.pquery;

import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import org.pasoa.accessors.AccessorException;
import org.pasoa.accessors.DataAccessorRegistry;
import org.pasoa.preserv.pquery.FullRelationship;
import org.pasoa.preserv.pquery.PQueryProblem;
import org.pasoa.preserv.pquery.ProvenanceQueryResults;
import org.pasoa.pstructure.ObjectID;
import org.pasoa.pstructure.PAssertionDataKey;

public class ProvenanceQueryUtilities {
    public static Set extractAddresses (ProvenanceQueryResults results) {
        Set              found  = new HashSet ();
        Iterator         eachFR = results.getFullRelationships ().iterator ();
        FullRelationship full;
        
        while (eachFR.hasNext ()) {
            full = (FullRelationship) eachFR.next ();
            found.add (full.getSubject ().getGlobalPAssertionKey ().getInteractionKey ().getMessageSource ().getTextContent ());
            found.add (full.getSubject ().getGlobalPAssertionKey ().getInteractionKey ().getMessageSink   ().getTextContent ());
            found.add (full.getObject  ().getGlobalPAssertionKey ().getInteractionKey ().getMessageSource ().getTextContent ());
            found.add (full.getObject  ().getGlobalPAssertionKey ().getInteractionKey ().getMessageSink   ().getTextContent ());
        }
        
        return found;
    }

    public static Set extractInteractionKeys (ProvenanceQueryResults results) {
        Set              found  = new HashSet ();
        Iterator         eachFR = results.getFullRelationships ().iterator ();
        FullRelationship full;
        
        while (eachFR.hasNext ()) {
            full = (FullRelationship) eachFR.next ();
            found.add (full.getSubject ().getGlobalPAssertionKey ().getInteractionKey ());
            found.add (full.getObject  ().getGlobalPAssertionKey ().getInteractionKey ());
        }
        
        return found;
    }
    
    public static List findRelationships (ProvenanceQueryResults results, PAssertionDataKey withSubject) throws PQueryProblem {
        try {
            DataAccessorRegistry accessors = DataAccessorRegistry.getDefaultRegistry ();
            List                 found     = new LinkedList ();
            Iterator             eachFR    = results.getFullRelationships ().iterator ();
            FullRelationship     full;
            ObjectID             subject;
            
            while (eachFR.hasNext ()) {
                full    = (FullRelationship) eachFR.next ();
                subject = full.getSubject ();
                if (subject.getGlobalPAssertionKey ().getInteractionKey ().equals (
                        withSubject.getGlobalPAssertionKey ().getInteractionKey ())
                        && accessors.equalDataAccessors (subject.getObjectDataAccessor (), org.pasoa.common.BestPractice.VERBATIM_STYLE,
                        withSubject.getDataAccessor (), org.pasoa.common.BestPractice.VERBATIM_STYLE)) {
                    found.add (full);
                }
            }
            
            return found;
        } catch (AccessorException problem) {
            throw new PQueryProblem ("Problem comparing data accessors", problem);
        }
    }
}
