package org.pasoa.storeclient.proxy;

import java.util.HashMap;
import java.util.Map;

public class StoreCatalogue {
    private Map        _stores;
    private StoreProxy _default;
    
    public StoreCatalogue () {
        _stores = new HashMap ();
    }
    
    public StoreProxy getStoreProxy (String storeURL) {
        StoreProxy proxy;
        if (storeURL == null) {
            return _default;
        }
        
        proxy = (StoreProxy) _stores.get (storeURL);
        if (proxy == null) {
            proxy = new RemoteStoreProxy (storeURL);
            registerStore (storeURL, proxy);
        }

        return proxy;
    }
    
    public void registerDefaultStore (StoreProxy store) {
        _default = store;
    }
    
    public void registerStore (String storeURL, StoreProxy store) {
        _stores.put (storeURL, store);
    }
}
