/********************************************************************************
 * Created on 21-Jul-2006
 *
 * Copyright (c) 2005 University of Southampton
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE.
 *******************************************************************************/

package org.pasoa.storeclient.test;

import java.io.StringReader;
import java.net.URL;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.pasoa.common.Constants;
import org.pasoa.simpledom.DOMWriter;
import org.pasoa.util.httpsoap.DefaultDocumentClient;
import org.w3c.dom.Document;
import org.xml.sax.InputSource;

public class DeleteRepository
{
     public static void main (String args[]) throws Exception
     {
         StringBuffer sb = new StringBuffer();
         sb.append ("<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\">");
         sb.append ("<soapenv:Header>");
         sb.append ("</soapenv:Header>");
         sb.append ("<soapenv:Body>");
         sb.append ("<pm:deleteRepository xmlns:pm=\"" + Constants.PMANAGE_NS + "\">");
         sb.append ("default");
         sb.append ("</pm:deleteRepository>");
         sb.append ("</soapenv:Body>");
         sb.append ("</soapenv:Envelope>");
         
         DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
         DocumentBuilder db = dbf.newDocumentBuilder();
         db.parse(new InputSource(new StringReader(sb.toString())));
         
         DefaultDocumentClient ddc = new DefaultDocumentClient ();
         Document response = ddc.invoke (new URL(args[0]), sb.toString());
         System.out.println(DOMWriter.writeToString (response, true));
         
     }
}
