package org.pasoa.storeclient.tools;

import java.net.URL;
import org.pasoa.common.Constants;
import org.pasoa.simpledom.DOMDeserialiser;
import org.pasoa.storeclient.ClientLib;
import org.w3c.dom.Element;

public class StoreCopy extends UploadPStruct {
    public void copy (String copyFromURL, String copyToURL) throws Exception {
        DOMDeserialiser reader     = new DOMDeserialiser ();
        ClientLib       client     = new ClientLib ();
        URL             queryURL   = new URL (copyFromURL + "/xquery");
        Element         envelope   = client.query ("$ps:pstruct", queryURL).getDocumentElement ();
        Element         body       = reader.single (envelope, Constants.SOAP_NS,     "Body");
        Element         results    = reader.single (body,     Constants.WSXQUERY_NS, "queryResult");
        Element         pstructure = reader.single (results,  Constants.PSTRUCT_NS,  "pstruct");
        
        upload (pstructure, copyToURL);
    }
    
    public static void main (String[] arguments) throws Exception {
        new StoreCopy ().copy (arguments [0], arguments [1]);
    }
}
