package org.pasoa.storeclient.tools;

import java.io.File;
import java.net.URL;
import java.util.Iterator;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.pasoa.common.Constants;
import org.pasoa.pstructure.ActorStatePAssertion;
import org.pasoa.pstructure.InteractionKey;
import org.pasoa.pstructure.InteractionPAssertion;
import org.pasoa.pstructure.InteractionRecord;
import org.pasoa.pstructure.PAssertion;
import org.pasoa.pstructure.Record;
import org.pasoa.pstructure.RelationshipPAssertion;
import org.pasoa.pstructure.View;
import org.pasoa.pstructure.deserialiser.PStructureDeserialiser;
import org.pasoa.simpledom.DOMDeserialiser;
import org.pasoa.storeclient.ClientLib;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class UploadPStruct {
    public static void main (String[] arguments) throws Exception {
        new UploadPStruct ().upload (new File (arguments [0]), arguments [1]);
    }
    
    public void upload (File pstructureFile, String uploadToURL) throws Exception {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance ();
        factory.setNamespaceAware (true);
        DocumentBuilder        builder  = factory.newDocumentBuilder ();
        Document               document = builder.parse (pstructureFile);
        
        upload (document.getDocumentElement (), uploadToURL);
    }
    
    public void upload (Element pstructure, String uploadToURL) throws Exception {
        ClientLib         client     = new ClientLib ();
        URL               recordURL  = new URL (uploadToURL + "/record");
        Iterator          eachRecord = new PStructureDeserialiser ().deserialisePStructure (pstructure).iterator ();
        InteractionRecord record;
        InteractionKey    ikey;
        boolean           isSender;
        View              view;
        Element           asserter;
        Iterator          eachPAssertion;
        PAssertion        passertion;
        
        while (eachRecord.hasNext ()) {
            record   = (InteractionRecord) eachRecord.next ();
            ikey     = record.getInteractionKey ();
            isSender = true;
            do {
                if (isSender) {
                    view = record.getSenderView ();
                } else {
                    view = record.getReceiverView ();
                }
                if (view != null) {
                    asserter = view.getAsserter ();
                    for (int passertionType = 1; passertionType <= 3; passertionType += 1) {
                        switch (passertionType) {
                            case 1:
                                eachPAssertion = view.getInteractionPAssertions ().iterator ();
                                break;
                            case 2:
                                eachPAssertion = view.getActorStatePAssertions ().iterator ();
                                break;
                            default:
                                eachPAssertion = view.getRelationshipPAssertions ().iterator ();
                        }
                        while (eachPAssertion.hasNext ()) {
                            passertion = destupid ((PAssertion) eachPAssertion.next ());
                            if (isSender) {
                                client.record (new Record (passertion, ikey, Constants.SENDER_VIEW_TYPE,   asserter), recordURL);
                            } else {
                                client.record (new Record (passertion, ikey, Constants.RECEIVER_VIEW_TYPE, asserter), recordURL);
                            }
                        }
                    }
                }
                isSender = !isSender;
            } while (!isSender);
        }
    }
    
    private PAssertion destupid (PAssertion passertion) {
        DOMDeserialiser reader = new DOMDeserialiser (Constants.PSTRUCT_NS);
        Element         content;
        
        if (passertion instanceof RelationshipPAssertion) {
            return passertion;
        }
        if (passertion instanceof InteractionPAssertion) {
            content = reader.single (reader.single (((InteractionPAssertion) passertion).getContent (), "content"));
            return new InteractionPAssertion (passertion.getLocalPAssertionID (),
                    ((InteractionPAssertion) passertion).getDocumentationStyle (), content);
        }
        if (passertion instanceof ActorStatePAssertion) {
            content = reader.single (reader.single (((ActorStatePAssertion) passertion).getContent (), "content"));
            return new ActorStatePAssertion (passertion.getLocalPAssertionID (),
                    ((ActorStatePAssertion) passertion).getDocumentationStyle (), content);
        }
        return null;
    }
}
