package org.pasoa.storeclient.wrappers.java;

import java.io.IOException;
import java.io.StringReader;
import java.net.URL;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.pasoa.pstructure.ActorStatePAssertion;
import org.pasoa.pstructure.PAssertion;
import org.w3c.dom.Element;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class ActorStateAsserter extends AbstractAsserter {
    private Element state;

    public ActorStateAsserter (URL provenanceStore, boolean isSenderView, Element actorState) {
        super (provenanceStore, isSenderView);
        state    = actorState;
    }
    
    public ActorStateAsserter (URL provenanceStore, String actorState, boolean isSenderView) throws IOException, ParserConfigurationException, SAXException {
        this (provenanceStore, isSenderView, DocumentBuilderFactory.newInstance ().newDocumentBuilder ().parse (new InputSource (new StringReader (actorState))).getDocumentElement ());
    }
    
    public PAssertion createPAssertion (Element message, String localPAssertionID) {
        return new ActorStatePAssertion (localPAssertionID, state);
    }
}
