package org.pasoa.storeclient.wrappers.java;

import java.io.File;
import java.io.FileNotFoundException;
import org.pasoa.storeclient.wrappers.java.config.AssertersParser;
import org.pasoa.storeclient.wrappers.java.config.ParseException;

public class RecordingActor implements Runnable {
    private ProvenanceWrapper _wrapper;
    
    public RecordingActor (File provConfig, String[] comArgs) throws FileNotFoundException, ParseException {
        _wrapper = new AssertersParser (provConfig).parseAssertersDefinition ();
        
        _wrapper.getActor ().initialise (comArgs);
    }

    public RecordingActor (String[] allArgs) throws FileNotFoundException, ParseException {
        this (new File (allArgs [0]), allButFirst (allArgs));
    }
    
    private static String[] allButFirst (String[] allArgs) {
        String[] comargs = new String [allArgs.length - 1];
         
        System.arraycopy (allArgs, 1, comargs, 0, allArgs.length - 1);
        
        return comargs;
    }
    
    public ProvenanceWrapper getWrapper () {
        return _wrapper;
    }
    
    public static void main (String[] arguments) throws Exception {
        RecordingActor recorder = new RecordingActor (arguments);
        recorder.run ();
    }
    
    public void run () {
        _wrapper.run ();
    }
}
