package org.pasoa.storeclient.wrappers.java;

import java.net.URL;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import org.pasoa.pstructure.GlobalPAssertionKey;
import org.pasoa.pstructure.ObjectID;
import org.pasoa.pstructure.PAssertion;
import org.pasoa.pstructure.Record;
import org.pasoa.pstructure.RelationshipPAssertion;
import org.w3c.dom.Element;

public class RelationshipAsserter extends AbstractAsserter implements RecordListener {
    private Asserter             subAsserter;
    private List                 objAsserters;
    private RelationshipPAssertion         relationship;
    private String               subjectLPAID;
    private GlobalPAssertionKey[] objectGPAIDs;

    /**
     * @param template A relationship without any identifiers set
     */
    public RelationshipAsserter (URL provenanceStore, boolean isSenderView, RelationshipPAssertion template, Asserter subjectAsserter, List objectAsserters) {
        super (provenanceStore, isSenderView);

        Iterator eachAsserter = objectAsserters.iterator ();
        
        relationship = template;
        subAsserter  = subjectAsserter;
        objAsserters = objectAsserters;
        objectGPAIDs = new GlobalPAssertionKey [objectAsserters.size ()];
        
        subAsserter.addListener (this);
        while (eachAsserter.hasNext ()) {
            ((Asserter) eachAsserter.next ()).addListener (this);
        }
    }

    public PAssertion createPAssertion (Element message, String localPAssertionID) {
        List                objectIDs = new LinkedList ();
        GlobalPAssertionKey gpid;
        ObjectID            template;
        ObjectID            objectID;
        
        for (int index = 0; index < objAsserters.size (); index += 1) {
            template = (ObjectID) relationship.getObjectIDs ().get (index);
            objectID = new ObjectID (objectGPAIDs [index], template.getParameterName (), template.getObjectDataAccessor (), null);
            objectIDs.add (objectID);
        }
        
        return new RelationshipPAssertion (localPAssertionID, subjectLPAID, relationship.getSubject().getDataAccessor (),
                relationship.getSubject().getParameterName (), relationship.getRelation (), objectIDs);
    }
    
    public void recorded (Asserter source, Record record, URL location) {
        GlobalPAssertionKey gpid;
        
        if (source == subAsserter) {
            subjectLPAID = record.getPAssertion ().getLocalPAssertionID ();
        } else {
            for (int index = 0; index < objAsserters.size (); index += 1) {
                if (source == objAsserters.get (index)) {
                    gpid = new GlobalPAssertionKey (record.getInteractionKey (), record.getViewKind (),
                            record.getPAssertion ().getLocalPAssertionID ());
                    objectGPAIDs [index] = gpid;
                }
            }
        }
    }
}
