package org.pasoa.util.httpsoap;

import org.pasoa.common.Constants;
import org.pasoa.simpledom.DOMDeserialiser;
import org.pasoa.simpledom.SimpleDocument;
import org.pasoa.simpledom.SimpleElement;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class SOAPDocument extends SimpleDocument {
    public SimpleElement envelope;
    public SimpleElement header;
    public SimpleElement body;
    
    public static final String soapEnvURI = "http://schemas.xmlsoap.org/soap/envelope/";
    
    public SOAPDocument () {
        envelope = new SimpleElement  (this, soapEnvURI, "Envelope");
        header   = new SimpleElement  (this, soapEnvURI, "Header");
        body     = new SimpleElement  (this, soapEnvURI, "Body");
        
        appendChild (envelope);
        envelope.appendChild (header);
        envelope.appendChild (body);
    }
    
    public static Element extractBodyContent (Element envelope) {
        DOMDeserialiser soap    = new DOMDeserialiser (Constants.SOAP_NS);
        Element         content;
        
        if (envelope.getLocalName ().equalsIgnoreCase ("Envelope")) {
            return soap.single (soap.single (soap.single (envelope, "Body"), Constants.WSXQUERY_NS, "queryResult"));
        } else {
            return envelope;
        }
    }
    
    public static Element extractBodyContent (Document envelope) {
        return extractBodyContent (envelope.getDocumentElement ());
    }
}
